package ColorReplace;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import java.awt.image.BufferedImage;


import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import Shapes.ElementImage;
import Tools.ToolStateEyeDropper;
import panels.CanvasPanel;
import utils.DrawStateSingleton;


public class ColorReplacementDlg extends JInternalFrame{
	
	private static final long serialVersionUID = 1L;
	
	public static final int BASIC_MODE = 0;
	public static final int PLUS_MODE = 1;
	public static final int MINUS_MODE = 2;
	public static final int RESULT_MODE = 3;
	
	public static String[][] selectTools = {
		{"eye_dropper_select","eye_dropper_deselect","source ÿ մϴ."},
		{"eye_dropper_plus_select","eye_dropper_plus_deselect"," ÿ  ߰ŵϴ."},
		{"eye_dropper_minus_select","eye_dropper_minus_deselect"," ÿ ܽŵϴ.."},
		{"eye_dropper_select","eye_dropper_result","destnation ÿ  մϴ."},
	};

	private BufferedImage selectionImg;
	private BufferedImage backupImg,replaceImg;
	private int[] originalPixelArray ;
	private int selectionMode;
	
	private JRadioButton eyeDropper_basic,eyeDropper_plus,eyeDropper_minus,eyeDropper_result;
	
	private ColorButton sourceButton;
	private JTextField fuzzinessText;
	private JSlider fuzzinessSlider;
	
	private JButton submitButton,cancelButton;
	private JCheckBox previewCheck;
	
	private ViewSelectAreaPanel viewPanel;
	private JRadioButton selectionRadio,imageRadio;
	
	private JTextField hueText,saturationText,lightnessText;
	private JSlider hueSlider,saturationSlider,lightnessSlider;
	ElementImage element;
	CanvasPanel canvasPanel;
	private ColorButton resultButton;
	public BufferedImage bufImage;
	
	public ColorReplacementDlg(ElementImage element, CanvasPanel canvasPanel){
		super();
		this.getContentPane().setLayout(new BoxLayout(this.getContentPane(),BoxLayout.Y_AXIS));
		this.element = element;
		this.canvasPanel = canvasPanel;
		
		this.bufImage = element.bufferedImage;
		selectionImg = new BufferedImage(bufImage.getWidth(),bufImage.getHeight(),
							BufferedImage.TYPE_4BYTE_ABGR);
		Graphics2D g = selectionImg.createGraphics();
		g.setColor(Color.BLACK);
		g.fillRect(0, 0,selectionImg.getWidth(), selectionImg.getHeight());
		g.dispose();
		backupImg = new BufferedImage(bufImage.getWidth(),bufImage.getHeight(),
				BufferedImage.TYPE_4BYTE_ABGR);
		g = backupImg.createGraphics();
		g.drawImage(bufImage,0,0,null);
		g.dispose();
		
		
		originalPixelArray = ImageUtil.getPixelArray(bufImage);

		
		selectionMode = BASIC_MODE;
		makeSelectionUI();
		makeReplacementUI();
		setListener();
		System.out.println("create Replace");
	
		this.setBounds(new Rectangle(600, 200, 270, 415));
		this.setVisible(true);
	}
	public void setCenterLocation(){
		//this.setLocation(640,150);//Ÿȴ 
	}
	
	public void setSourceColor(Color c){
		if(selectionMode == BASIC_MODE){
			this.sourceButton.setColor(c);
			this.setResultColor(c);
			updateCanvasImg();
		}else if(selectionMode == PLUS_MODE){
			this.sourceButton.setColor(c);
			updateCanvasImg();
		}else if(selectionMode == MINUS_MODE){
			this.sourceButton.setColor(c);
			updateCanvasImg();
		}else if(selectionMode == RESULT_MODE){
			this.sourceButton.setColor(c);
			updateCanvasImg();
		}
		
	}
	public void resultColor(Color color){
		Color newColor = color;
		//System.out.println(color);
		if (newColor != null) {
			
		}else{
			return;
		}
		
		Color color1 = sourceButton.getColor();
		Color color2 = newColor;
		float[] hsv1 = Color.RGBtoHSB(color1.getRed(), color1.getGreen(), color1.getBlue(), null);
		float[] hsv2 = Color.RGBtoHSB(color2.getRed(), color2.getGreen(), color2.getBlue(), null);
		
		int[] result = {(int) ((hsv2[0]-hsv1[0])*360),(int) ((hsv2[1]-hsv1[1])*360),(int) ((hsv2[2]-hsv1[2])*360)};
		hueSlider.setValue(result[0]);
		saturationSlider.setValue(result[1]);
		lightnessSlider.setValue(result[2]);		
		updateCanvasImg();
		invalidate();
		validate();
		repaint();
	
	}
	public void setSelectImg(){
		BufferedImage img = ImageUtil.getColorAreaImage( 
				selectionImg, originalPixelArray,bufImage.getWidth(),bufImage.getHeight(), 
				fuzzinessSlider.getValue(), sourceButton.getColor());
		if(selectionMode == BASIC_MODE){
			selectionImg = img;
		}else if(selectionMode == PLUS_MODE){
			for(int i = 0;i<bufImage.getWidth();i++){
				for(int j = 0;j<bufImage.getHeight();j++){
					int rgb = selectionImg.getRGB(i,j) | img.getRGB(i, j);
					selectionImg.setRGB(i, j,rgb);
				}
			}
		}else if(selectionMode == MINUS_MODE){/////////////
			for(int i = 0;i<bufImage.getWidth();i++){
				for(int j = 0;j<bufImage.getHeight();j++){
					int rgb = selectionImg.getRGB(i,j) & ((~img.getRGB(i, j))|0xff000000);
					selectionImg.setRGB(i, j,rgb);
				}
			}
		}if(selectionMode == RESULT_MODE){
			//selectionImg = img;
			for(int i = 0;i<bufImage.getWidth();i++){
				for(int j = 0;j<bufImage.getHeight();j++){
					int rgb = selectionImg.getRGB(i,j) | img.getRGB(i, j);
					selectionImg.setRGB(i, j,rgb);
				}
			}
		}
		viewPanel.repaint();
	}
	public void updateCanvasImg(){
		replaceImg = new BufferedImage(backupImg.getWidth(),backupImg.getHeight(),
				BufferedImage.TYPE_4BYTE_ABGR);
		Graphics2D g = replaceImg.createGraphics();
		g.drawImage(backupImg,0,0,null);
		g.dispose();
		setSelectImg();
		for(int i = 0; i<selectionImg.getWidth();i++){
			for(int j = 0; j<selectionImg.getHeight();j++){
				int flag = selectionImg.getRGB(i, j)&0xFFFFFF;
				if(flag==0)
					continue;
				else{
					int rgb = replaceImg.getRGB(i, j);
					float[] hsv = Color.RGBtoHSB(((rgb>>16)&0xFF), 
					((rgb>>8)&0xFF), rgb&0xFF, 
					null);
					hsv[0] += hueSlider.getValue()/360.0;
					hsv[1] += saturationSlider.getValue()/360.0;
					hsv[2] += lightnessSlider.getValue()/360.0;
					for(int k = 0;k<hsv.length;k++ ){
						if(hsv[k]<0)
							hsv[k] = 0;
						else if(hsv[k]>1)
							hsv[k] = 1;
					}
					replaceImg.setRGB(i, j, Color.HSBtoRGB(hsv[0], hsv[1], hsv[2]));
				}
			}
		}
		if(previewCheck.isSelected()){
			this.element.setBufferedImage(replaceImg);
			this.canvasPanel.repaint();
		}
	}
	public void setResultColor(Color c){
		float hsv[] = Color.RGBtoHSB(c.getRed(),c.getGreen(),c.getBlue(),null);
		hsv[0] += hueSlider.getValue();
		hsv[1] += saturationSlider.getValue();
		hsv[2] += lightnessSlider.getValue();
		this.resultButton.setColor(new Color(Color.HSBtoRGB(hsv[0], hsv[1], hsv[2])));
	}
	private void setListener(){
		eyeDropper_basic.addItemListener(new EyeDropperModeListener());
		eyeDropper_plus.addItemListener(new EyeDropperModeListener());
		eyeDropper_minus.addItemListener(new EyeDropperModeListener());	
		eyeDropper_result.addItemListener(new EyeDropperModeListener());	
		sourceButton.addActionListener(new SourceColorListener());
		fuzzinessSlider.addChangeListener(new FuzzinessChangeListener());
		fuzzinessSlider.addMouseListener(new MouseAdapter(){
			public void mouseReleased(MouseEvent e) {
				// TODO Auto-generated method stub
				setSourceColor(sourceButton.getColor());
				updateCanvasImg();
				invalidate();
				validate();
				repaint();
			}
		});
		
		fuzzinessText.addKeyListener(new FuzzinessKeyListener());
		hueSlider.addChangeListener(new HSVChangeListener());
		hueSlider.addMouseListener(new MouseAdapter(){
			public void mouseReleased(MouseEvent e) {
				// TODO Auto-generated method stub
				//replaceImg = backupImg.getSubimage(0, 0, canvasPanel.getImage().getWidth(), canvasPanel.getImage().getHeight());	
				updateCanvasImg();
			}
		});
		saturationSlider.addChangeListener(new HSVChangeListener());
		saturationSlider.addMouseListener(new MouseAdapter(){
			public void mouseReleased(MouseEvent e) {
				updateCanvasImg();
			}
		});
		lightnessSlider.addChangeListener(new HSVChangeListener());
		lightnessSlider.addMouseListener(new MouseAdapter(){
			public void mouseReleased(MouseEvent e) {
				updateCanvasImg();
			}
		});
		hueText.addKeyListener(new HSVKeyListener());
		saturationText.addKeyListener(new HSVKeyListener());
		lightnessText.addKeyListener(new HSVKeyListener());
		previewCheck.addItemListener(new PreviewChangeListener());
		
		resultButton.addActionListener(new ResultColorListener());
		submitButton.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				if(replaceImg != null){
					element.setBufferedImage(replaceImg);
					canvasPanel.repaint();
					
				}
				dispose();
			}
			
		});
		cancelButton.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				element.setBufferedImage(backupImg);
				canvasPanel.repaint();
				dispose();
			}	
			
		});
	}
	
	private class EyeDropperModeListener implements ItemListener{
		
		public void itemStateChanged(ItemEvent e) {
			
			if(e.getStateChange()==ItemEvent.SELECTED){
				if(e.getSource() == eyeDropper_basic){
					selectionMode = BASIC_MODE;
					if(DrawStateSingleton.getInstance().getToolState() instanceof ToolStateEyeDropper){
						((ToolStateEyeDropper)DrawStateSingleton.getInstance().getToolState()).setReplaceMode(true);
					}
				}else if(e.getSource() == eyeDropper_plus){
					selectionMode = PLUS_MODE;
					if(DrawStateSingleton.getInstance().getToolState() instanceof ToolStateEyeDropper){
						((ToolStateEyeDropper)DrawStateSingleton.getInstance().getToolState()).setReplaceMode(true);
					}
				}else if(e.getSource() == eyeDropper_minus){
					selectionMode = MINUS_MODE;
					if(DrawStateSingleton.getInstance().getToolState() instanceof ToolStateEyeDropper){
						((ToolStateEyeDropper)DrawStateSingleton.getInstance().getToolState()).setReplaceMode(true);
					}
				}else if(e.getSource() == eyeDropper_result){
					selectionMode = RESULT_MODE;
					if(DrawStateSingleton.getInstance().getToolState() instanceof ToolStateEyeDropper){
						((ToolStateEyeDropper)DrawStateSingleton.getInstance().getToolState()).setReplaceMode(false);
					}
				}
			}else{
				
			}
		}
		
	}
	private class SourceColorListener implements ActionListener{

		public void actionPerformed(ActionEvent e) {
			Color newColor = JColorChooser.showDialog(
                    null,
                    "Choose Color",
                    sourceButton.getColor());
			if (newColor != null) {
				sourceButton.setColor(newColor);
			}else{
				return;
			}
			setSourceColor(sourceButton.getColor());
			setResultColor(sourceButton.getColor());
			
			invalidate();
			validate();
			repaint();
			
			
		}
		
	}
	private class ResultColorListener implements ActionListener{

		public void actionPerformed(ActionEvent arg0) {
		
			Color newColor = JColorChooser.showDialog(
                    null,
                    "Choose Color",
                    resultButton.getColor());
			if (newColor != null) {
				
			}else{
				return;
			}
			
			Color color1 = sourceButton.getColor();
			Color color2 = newColor;
			float[] hsv1 = Color.RGBtoHSB(color1.getRed(), color1.getGreen(), color1.getBlue(), null);
			float[] hsv2 = Color.RGBtoHSB(color2.getRed(), color2.getGreen(), color2.getBlue(), null);
			
			int[] result = {(int) ((hsv2[0]-hsv1[0])*360),(int) ((hsv2[1]-hsv1[1])*360),(int) ((hsv2[2]-hsv1[2])*360)};
			hueSlider.setValue(result[0]);
			saturationSlider.setValue(result[1]);
			lightnessSlider.setValue(result[2]);		
			updateCanvasImg();
			invalidate();
			validate();
			repaint();
		}
		
	}
	private class FuzzinessChangeListener implements ChangeListener{

		public void stateChanged(ChangeEvent e) {
			// TODO Auto-generated method stub
			fuzzinessText.setText(""+fuzzinessSlider.getValue());
		}
		
	}
	private class FuzzinessKeyListener implements KeyListener{

		public void keyPressed(KeyEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void keyReleased(KeyEvent e) {
			// TODO Auto-generated method stub
			if(fuzzinessText.getText().equals(""))
				fuzzinessSlider.setValue(0);
			else
				fuzzinessSlider.setValue(Integer.parseInt(fuzzinessText.getText()));
		}

		public void keyTyped(KeyEvent e) {
			// TODO Auto-generated method stub
			
		}	
	}
	private class HSVChangeListener implements ChangeListener{

		public void stateChanged(ChangeEvent e) {
			// TODO Auto-generated method stub
			Color color1 = sourceButton.getColor();
			float[] hsv1 = Color.RGBtoHSB(color1.getRed(), color1.getGreen(), color1.getBlue(), null);
			//float[] hsv2 = Color.RGBtoHSB(color2.getRed(), color2.getGreen(), color2.getBlue(), null);
			
			hsv1[0] += hueSlider.getValue()/360.0; 
			hsv1[1] +=saturationSlider.getValue()/360.0; 
			hsv1[2] +=lightnessSlider.getValue()/360.0;
			for(int k = 0;k<hsv1.length;k++ ){
				if(hsv1[k]<0)
					hsv1[k] = 0;
				else if(hsv1[k]>1)
					hsv1[k] = 1;
			}
			hueText.setText(""+hueSlider.getValue());
			saturationText.setText(""+saturationSlider.getValue());
			lightnessText.setText(""+lightnessSlider.getValue());
			
			
			resultButton.setColor(Color.getHSBColor(hsv1[0], hsv1[1], hsv1[2]));
			resultButton.repaint();
		}
		
	}
	private class HSVKeyListener implements KeyListener{

		public void keyPressed(KeyEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void keyReleased(KeyEvent e) {
			// TODO Auto-generated method stub
			if(e.getSource() == hueText){
				if(hueText.getText().equals(""))
					hueSlider.setValue(0);
				else
					hueSlider.setValue(Integer.parseInt(hueText.getText()));
			}else if(e.getSource() == saturationText){
				if(saturationText.getText().equals(""))
					saturationSlider.setValue(0);
				else
					saturationSlider.setValue(Integer.parseInt(saturationText.getText()));
			}else if(e.getSource() == lightnessText){
				if(lightnessText.getText().equals(""))
					lightnessSlider.setValue(0);
				else
					lightnessSlider.setValue(Integer.parseInt(lightnessText.getText()));
			}
			
			if(fuzzinessText.getText().equals(""))
				fuzzinessSlider.setValue(0);
			else
				fuzzinessSlider.setValue(Integer.parseInt(fuzzinessText.getText()));
		}

		public void keyTyped(KeyEvent e) {
			// TODO Auto-generated method stub
			
		}	
	}
	
	private class PreviewChangeListener implements ItemListener{

		public void itemStateChanged(ItemEvent e) {
			// TODO Auto-generated method stub
			if(e.getStateChange() == ItemEvent.SELECTED){
				element.setBufferedImage(replaceImg);
				canvasPanel.repaint();
				
				System.out.println("preiveiw");
			}else{
				element.setBufferedImage(backupImg);
				canvasPanel.repaint();
			}
		}
		
	}
	private class ViewSelectAreaPanel extends JPanel{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		//private boolean selectView;
		public ViewSelectAreaPanel(){
			super();
			this.setPreferredSize(new Dimension(bufImage.getWidth()/4,bufImage.getHeight()/4));
			this.setBackground(Color.WHITE);
		}
		public void paint(Graphics g){
			Image i = null;
			if(selectionRadio.isSelected()){
			i = selectionImg.getScaledInstance(this.getWidth(), 
													this.getHeight(), 
													Image.SCALE_SMOOTH);
			}else{
				i = bufImage.getScaledInstance(this.getWidth(), 
																			this.getHeight(), 
																		Image.SCALE_SMOOTH);
			}
			g.drawImage(i,0,0,this);
			
		}
	}
	
	
	private void makeSelectionUI(){
		
		eyeDropper_basic = StaticMethods.makeRadioButton(selectTools[0][0],
				selectTools[0][1],"/image/",selectTools[0][2]);
		eyeDropper_plus = StaticMethods.makeRadioButton(selectTools[1][0],
				selectTools[1][1],"/image/",selectTools[1][2]);
		eyeDropper_minus = StaticMethods.makeRadioButton(selectTools[2][0],
				selectTools[2][1],"/image/",selectTools[2][2]);
		eyeDropper_result = StaticMethods.makeRadioButton(selectTools[3][0],
				selectTools[0][1],"/image/",selectTools[0][2]);
		ButtonGroup group = new ButtonGroup();
		group.add(eyeDropper_basic);
		group.add(eyeDropper_plus);
		group.add(eyeDropper_minus);
		group.add(eyeDropper_result);
		
		eyeDropper_basic.setSelected(true);
		
		Color color = canvasPanel.getInformation().getFillColor();
		sourceButton = new ColorButton(color);
		
		
		
		fuzzinessSlider = new JSlider();
		fuzzinessSlider.setMinimum(0);
		fuzzinessSlider.setMaximum(200);
		fuzzinessSlider.setValue(32);
		fuzzinessText = new JTextField(4);
		fuzzinessText.addKeyListener(new OnlyNumberKeyListener());
		fuzzinessText.setText(""+fuzzinessSlider.getValue());
		
		viewPanel = new ViewSelectAreaPanel();
		
		selectionRadio = new JRadioButton("Selection");
		imageRadio = new JRadioButton("Image");
		group = new ButtonGroup();
		group.add(selectionRadio);
		group.add(imageRadio);
		selectionRadio.setSelected(true);
		
		
		
		submitButton = new JButton("OK");
		submitButton.setPreferredSize(new Dimension(80,30));
		cancelButton = new JButton("Cancel");
		cancelButton.setPreferredSize(new Dimension(80,30));
		previewCheck = new JCheckBox("Preview");
		previewCheck.setPreferredSize(new Dimension(80,30));
		previewCheck.setSelected(true);
		
		JPanel selectionPanel = new JPanel();
		selectionPanel.setBorder(BorderFactory.createTitledBorder("Selection"));
		selectionPanel.setLayout(new BoxLayout(selectionPanel,BoxLayout.Y_AXIS));
	/////////////////////////////////////////////////////////	
		JPanel secondPanel = new JPanel();
		secondPanel.setLayout(new BoxLayout(secondPanel,BoxLayout.X_AXIS));
		
		FlowLayout layout = new FlowLayout();
		layout.setAlignment(FlowLayout.LEFT);
		JPanel panel = new JPanel(layout);
		panel.add(eyeDropper_basic);
		panel.add(eyeDropper_plus);
		panel.add(eyeDropper_minus);
		panel.add(eyeDropper_result);
		
		secondPanel.add(panel);
		layout = new FlowLayout();
		layout.setAlignment(FlowLayout.RIGHT);
		panel = new JPanel(layout);
		panel.add(new JLabel("Color : "));
		panel.add(sourceButton);
		
		secondPanel.add(panel);
		
		selectionPanel.add(secondPanel);
	////////////////////////////////////////////////////////////////	
		
		secondPanel = new JPanel();
		secondPanel.setLayout(new BoxLayout(secondPanel,BoxLayout.X_AXIS));
		
		layout = new FlowLayout();
		layout.setAlignment(FlowLayout.LEFT);
		panel = new JPanel(layout);
		panel.add(new JLabel("Fuzziness : "));
		secondPanel.add(panel);
		layout = new FlowLayout();
		layout.setAlignment(FlowLayout.RIGHT);
		panel = new JPanel(layout);
		panel.add(fuzzinessText);
		secondPanel.add(panel);
		selectionPanel.add(secondPanel);
	//////////////////////////////////////////////////////////////////////	
		secondPanel = new JPanel();
		
		secondPanel.add(fuzzinessSlider);
		selectionPanel.add(secondPanel);
	//////////////////////////////////////////////////////////////////////
		secondPanel = new JPanel();
		
		secondPanel.add(viewPanel);
		selectionPanel.add(secondPanel);
	//////////////////////////////////////////////////////////////////////
		secondPanel = new JPanel();
		
		secondPanel.add(selectionRadio);
		secondPanel.add(imageRadio);
		selectionPanel.add(secondPanel);
	//////////////////////////////////////////////////////////////////////
		layout = new FlowLayout();
		//layout.setAlignment(FlowLayout.LEFT);
		
		JPanel submitPanel = new JPanel(layout);
		submitPanel.setPreferredSize(new Dimension(100,300));
		submitPanel.add(submitButton);
		submitPanel.add(cancelButton);
		submitPanel.add(previewCheck);

		
		JPanel total = new JPanel();
		total.setLayout(new BoxLayout(total,BoxLayout.X_AXIS));
		total.add(selectionPanel);
		total.add(submitPanel);
		
		this.getContentPane().add(total);
	}
	private void makeReplacementUI(){
		
		hueText = new JTextField(4);
		hueText.addKeyListener(new OnlyNumberKeyListener());
		hueText.setText("0");
		saturationText = new JTextField(4);
		saturationText.addKeyListener(new OnlyNumberKeyListener());
		saturationText.setText("0");
		lightnessText = new JTextField(4);
		lightnessText.addKeyListener(new OnlyNumberKeyListener());
		lightnessText.setText("0");
		hueSlider = new JSlider();
		hueSlider.setMinimum(-180);
		hueSlider.setMaximum(+180);
		hueSlider.setValue(0);
		
		saturationSlider = new JSlider();
		saturationSlider.setMinimum(-180);
		saturationSlider.setMaximum(+180);
		saturationSlider.setValue(0);
		
		lightnessSlider = new JSlider();
		lightnessSlider.setMinimum(-180);
		lightnessSlider.setMaximum(+180);
		lightnessSlider.setValue(0);
		
		
		resultButton = new ColorButton(sourceButton.getColor());
		
		JPanel replacementPanel = new JPanel();
		
		replacementPanel.setLayout(new BoxLayout(replacementPanel,BoxLayout.Y_AXIS));
		
		//////////////////////////////////////////////////////
		JPanel secondPanel = new JPanel();
		secondPanel.setLayout(new BoxLayout(secondPanel,BoxLayout.X_AXIS));
		
		FlowLayout layout = new FlowLayout();
		layout.setAlignment(FlowLayout.LEFT);
		JPanel panel = new JPanel(layout);
		panel.add(new JLabel("Hue : "));
		secondPanel.add(panel);
		layout = new FlowLayout();
		layout.setAlignment(FlowLayout.RIGHT);
		panel = new JPanel(layout);
		panel.add(hueText);
	
		secondPanel.add(panel);
		replacementPanel.add(secondPanel);
		
		///////////////////////////////////////////////////////////////
		secondPanel = new JPanel();
		
		secondPanel.add(hueSlider);
		replacementPanel.add(secondPanel);
		
//////////////////////////////////////////////////////
		secondPanel = new JPanel();
		secondPanel.setLayout(new BoxLayout(secondPanel,BoxLayout.X_AXIS));
		
		layout = new FlowLayout();
		layout.setAlignment(FlowLayout.LEFT);
		panel = new JPanel(layout);
		panel.add(new JLabel("Saturation : "));
		secondPanel.add(panel);
		layout = new FlowLayout();
		layout.setAlignment(FlowLayout.RIGHT);
		panel = new JPanel(layout);
		panel.add(saturationText);
	
		secondPanel.add(panel);
		replacementPanel.add(secondPanel);
		
		///////////////////////////////////////////////////////////////
		secondPanel = new JPanel();
		
		secondPanel.add(saturationSlider);
		replacementPanel.add(secondPanel);
		
//////////////////////////////////////////////////////
		secondPanel = new JPanel();
		secondPanel.setLayout(new BoxLayout(secondPanel,BoxLayout.X_AXIS));
		
		layout = new FlowLayout();
		layout.setAlignment(FlowLayout.LEFT);
		panel = new JPanel(layout);
		panel.add(new JLabel("Lightness : "));
		secondPanel.add(panel);
		layout = new FlowLayout();
		layout.setAlignment(FlowLayout.RIGHT);
		panel = new JPanel(layout);
		panel.add(lightnessText);
	
		secondPanel.add(panel);
		replacementPanel.add(secondPanel);
		
		///////////////////////////////////////////////////////////////
		secondPanel = new JPanel();
		
		secondPanel.add(lightnessSlider);
		replacementPanel.add(secondPanel);
		///////////////////////////////////////////////////////////////
		JPanel resultPanel = new JPanel();
		resultPanel.add(resultButton);
		resultPanel.add(new JLabel("Result"));
		
		
		JPanel total = new JPanel();
		total.setBorder(BorderFactory.createTitledBorder("Replacement"));
		total.setLayout(new BoxLayout(total,BoxLayout.X_AXIS));
		total.add(replacementPanel);
		total.add(resultPanel);
		this.getContentPane().add(total);
	}
	
}
