package ColorReplace;
import java.awt.Color;
import java.awt.Component;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.MediaTracker;

import java.awt.Toolkit;
import java.awt.color.ColorSpace;



import java.awt.image.BufferedImage;

import java.awt.image.PixelGrabber;

import javax.swing.JFrame;



public class ImageUtil {
	
	//ȼ ÷ 
	
	public static Color getPixelColor(BufferedImage bi,int x,int y){
		int[] originalPixelArray;
		Color color = null;
		try {
		      PixelGrabber grabber = new PixelGrabber(bi, x, y, 1,
		          1, true);
		      if (grabber.grabPixels()) {
		     
		        originalPixelArray = (int[]) grabber.getPixels();
		        color = new Color(originalPixelArray[0]);
		      } else {
		        System.err.println("Grabbing Failed");
		      }
		    
		} catch (InterruptedException ie) {
			System.err.println("Pixel Grabbing Interrupted");
		}
		return color;
	}
	
	static public BufferedImage createBufferedImage(String fileName,
		      Component comp) {
		Image img = Toolkit.getDefaultToolkit().getImage(fileName);    
		return createBufferedImage(img, BufferedImage.TYPE_INT_ARGB, comp);
		  
	}
	static public BufferedImage createBufferedImage(Image imageIn,
		      Component comp) {
		    return createBufferedImage(imageIn, BufferedImage.TYPE_INT_ARGB, comp);
		  
	}
	static public BufferedImage createBufferedImage(Image imageIn,
		      int imageType, Component comp) {
		    MediaTracker mt = new MediaTracker(comp);
		    mt.addImage(imageIn, 0);
		    try {
		      mt.waitForAll();
		    } catch (InterruptedException ie) {
		    }
		    BufferedImage bufferedImageOut = new BufferedImage(imageIn
		        .getWidth(null), imageIn.getHeight(null), imageType);
		    Graphics g = bufferedImageOut.getGraphics();
		    g.drawImage(imageIn, 0, 0, comp);

		    return bufferedImageOut;
	
	}
	public static Color replaceColor(Color c1,Color c2){
		
		float f1[] = Color.RGBtoHSB(c1.getRed(), c1.getGreen(), c1.getBlue(), null);
		float f2[] = Color.RGBtoHSB(c2.getRed(), c2.getGreen(), c2.getBlue(), null);
		
		f1[0] = f2[0];
		f1[1] = f2[1];
		f1[2] = f2[2];
		Color color = new Color(ColorSpace.getInstance(ColorSpace.TYPE_HSV),f1, 1.0f);
		return color;
	}
	public static int getDistance(Color c1, Color c2){
		float f1[] = Color.RGBtoHSB(c1.getRed(), c1.getGreen(), c1.getBlue(), null);
		float f2[] = Color.RGBtoHSB(c2.getRed(), c2.getGreen(), c2.getBlue(), null);
		
		//double distanceX = Math.pow(f1[0] -f2[0],2);
		//double distanceY = Math.pow(f1[1] -f2[1],2);
		//double distanceZ = Math.pow(f1[2] -f2[2],2);
		
		//double distance = 200*Math.sqrt(distanceX+distanceY+distanceZ);
		
		//int c1rgb[] = {c1.getRed(), c1.getGreen(), c1.getBlue()};
		//int c2rgb[] = {c2.getRed(), c2.getGreen(), c2.getBlue()};
		//System.out.println(distance);
		return (int) Math.abs((f1[0]-f2[0])*200); 
	}
	
	public static int getColorDifference(int[] _oolor1, int[] _color2){
		//use same formula as for two dimentional distance
		int rDiff = _oolor1[0] - _color2[0];
		int gDiff = _oolor1[1] - _color2[1];
		int bDiff = _oolor1[2] - _color2[2];
		return (int)  Math.sqrt(rDiff*rDiff +  gDiff*gDiff +  bDiff*bDiff);
		//strangely using pow function was unbelievably slow
		//return (int) Math.sqrt (Math.pow(rDiff, 2) +  Math.pow(gDiff, 2) +  Math.pow(bDiff, 2));
	}
	
	public static int getColorDifference(int _color1,int _color2){
		//use same formula as for two dimentional distance
		int rDiff = (_color1>>16)&0xff - (_color2>>16)&0xff;
		int gDiff = (_color1>>8)&0xff - (_color2>>8)&0xff;
		int bDiff = (_color1)&0xff - (_color2)&0xff;
		
		
		return (int)  Math.sqrt(rDiff*rDiff +  gDiff*gDiff +  bDiff*bDiff);
		//strangely using pow function was unbelievably slow
		//return (int) Math.sqrt (Math.pow(rDiff, 2) +  Math.pow(gDiff, 2) +  Math.pow(bDiff, 2));
	}

	public static void main(String[] args){
		JFrame frame = new JFrame();
		Image img = Toolkit.getDefaultToolkit().getImage("eye_dropper_select.jpg");
		
		BufferedImage image = createBufferedImage(img,frame);
		Color color = getPixelColor(image,0,0);
		System.out.println(color);
	}
	
		
	public static int[] getPixelArray(BufferedImage img){
		int[] originalPixelArray = null;
		try {
		      PixelGrabber grabber = new PixelGrabber(img, 0, 0, -1,
		          -1, true);
		      if (grabber.grabPixels()) {
		     
		        originalPixelArray = (int[]) grabber.getPixels();
		        //color = new Color(originalPixelArray[0]);
		      } else {
		        System.err.println("Grabbing Failed");
		      }
		    
		} catch (InterruptedException ie) {
			System.err.println("Pixel Grabbing Interrupted");
			return null;
		}
		return originalPixelArray;
	}
	/*
	public static Area getColorArea(BufferedImage image,int fuzziness,Color color,Component comp){
		Area area = null;
		
		BufferedImage img = createBufferedImage(image.getScaledInstance(image.getWidth()/4, image.getHeight()/4, Image.SCALE_SMOOTH),comp);
		int[] originalPixelArray = getPixelArray(img);
		
		//int[]colorRGB = {color.getRed(),color.getGreen(),color.getBlue()};
		area = getColorArea(originalPixelArray,img.getWidth(),img.getHeight(),fuzziness,color);
		AffineTransform a = AffineTransform.getScaleInstance(4,4);
		area = area.createTransformedArea(a);
		return area;
		
	}
	public static Area getColorArea(int[] originalPixelArray,int width,int height,int fuzziness,Color color){
		Area area = new Area();
		
		int[]colorRGB = {color.getRed(),color.getGreen(),color.getBlue()};	
		for(int i = 0; i<height;i+=1){
			for(int j = 0;j<width;j+=1){
			
				
				int pixelRGB1[] = {(originalPixelArray[i*width+j]>>16)&0xff,
						(originalPixelArray[i*width+j]>>8)&0xff,
						(originalPixelArray[i*width+j])&0xff,
				};
				int rDiff1 = pixelRGB1[0] - colorRGB[0];
				int gDiff1 = pixelRGB1[1] - colorRGB[1];
				int bDiff1 = pixelRGB1[2] - colorRGB[2];
				
				int distance1 = (int)  Math.sqrt(rDiff1*rDiff1 +  gDiff1*gDiff1 +  bDiff1*bDiff1);		 	
				if(distance1 <  fuzziness){
					area.add(new Area(new Rectangle(j,i,1,1)));
				}
			
			}
		}	
		return area;
	}
	*/
	public static BufferedImage getColorAreaImage(BufferedImage image,int[] originalPixelArray,int width,int height,int fuzziness,Color color){
		
		BufferedImage img = new BufferedImage(image.getWidth(),image.getHeight(),
				BufferedImage.TYPE_4BYTE_ABGR);
		Graphics2D g = img.createGraphics();
		g.drawImage(image,0,0,null);
		g.dispose();
		int[]colorRGB = {color.getRed(),color.getGreen(),color.getBlue()};	
		for(int i = 0; i<height;i+=1){		
			for(int j = 0;j<width;j+=1){	
				img.setRGB(j, i, 0xff000000);
				int pixelRGB1[] = {(originalPixelArray[i*width+j]>>16)&0xff,
							(originalPixelArray[i*width+j]>>8)&0xff,
							(originalPixelArray[i*width+j])&0xff,
					};
				int rDiff1 = pixelRGB1[0] - colorRGB[0];
				int gDiff1 = pixelRGB1[1] - colorRGB[1];
				int bDiff1 = pixelRGB1[2] - colorRGB[2];
				int distance1 = (int)  Math.sqrt(rDiff1*rDiff1 +  gDiff1*gDiff1 +  bDiff1*bDiff1);		 	
				if(distance1 <  fuzziness){
					img.setRGB(j, i, 0xFFFFFFFF);	
				}	
			}
		}
		return img;
	}
}
