package ColorReplace;

import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Shape;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.geom.AffineTransform;
import java.net.URL;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;




public class StaticMethods {
	//ư  ϰ Ѵ.
	public static JButton makeNavigationButton(String imageName,
            String actionCommand,
            String toolTipText,
            String altText,
            ActionListener listener) {
	
		JButton button = new JButton();
		button.setActionCommand(actionCommand);
		button.setToolTipText(toolTipText);
		button.addActionListener(listener);
		
		String imgLocation = "image/"
            + imageName
            + ".jpg";
		URL imageURL;
		
		imageURL = System.class.getResource(imgLocation);
		if (imageURL != null) {                      //image found
			button.setIcon(new ImageIcon(imageURL, altText));
		} else {                                     //no image found
			button.setText(altText);
			//System.err.println("Resource not found: "
			//		+ imgLocation);
		}
		return button;
	}
	
	public static JRadioButton makeRadioButton(String selectImage,
            String deselectImage,
            String directory,
            String toolTip
           ) {
		//ButtonHandler handler = new ButtonHandler();	
	//Create and initialize the button.
		JRadioButton button = new JRadioButton();
		button.setActionCommand(selectImage);
		button.setToolTipText(toolTip);
		
		
		String imgLocation = directory 
            + selectImage
            + ".jpg";
		String imgLocation2 = directory
            + deselectImage
            + ".jpg";
		URL imageURL,imageURL2;
		
		imageURL = System.class.getResource(imgLocation);
		imageURL2 = System.class.getResource(imgLocation2);
		
		if (imageURL != null && imageURL2 != null) {                      //image found
			button.setIcon(new ImageIcon(imageURL2));
			button.setSelectedIcon(new ImageIcon(imageURL));
			button.setRolloverIcon(new ImageIcon(imageURL));
		} else {                                     //no image found
			button.setText(selectImage);
		}
		
		return button;
	}
	
	public static Shape getMoveStartPointShape(Shape shape){
		Shape ret = null;
		
		int xGap = shape.getBounds().x;
        int yGap = shape.getBounds().y;
		float f[] = {1,0,0,1,-xGap,-yGap};
		AffineTransform affine = new AffineTransform (f); 
		ret = affine.createTransformedShape(shape);
		
		return ret;
	}
	public static Shape shapeMove(Shape shape,int xGap,int yGap){
		float f[] = {1,0,0,1,xGap,yGap};
		AffineTransform affine = new AffineTransform (f); 
		shape = affine.createTransformedShape(shape);
		return shape;
	}
	
	
	public static void gridBagAddComponent(
			Container ct, 
			Component cm,
			GridBagConstraints constraint, 
			int row, 
			int column,
			int width,
			int height){
		if(ct.getLayout() instanceof GridBagLayout){
			constraint.gridx = column;
			constraint.gridy = row;
			constraint.gridwidth = width;
			constraint.gridheight = height;
			((GridBagLayout)ct.getLayout()).setConstraints(cm, constraint);
			
			ct.add(cm);
		}else{
			return;
		}
	}
	
	public static void main(String[] args){
		JFrame frame = new JFrame();
		JPanel p= new JPanel();
		
		String imgLocation = "/ColorReplace/eye_dropper_deselect.jpg";
		URL imageURL;
		
		imageURL = System.class.getResource(imgLocation);
		JRadioButton button = new JRadioButton("dfd",new ImageIcon(imageURL));
		JRadioButton button2 = new JRadioButton("dfd",new ImageIcon(imageURL));
		button.addItemListener(new ItemListener(){

			public void itemStateChanged(ItemEvent e) {
				// TODO Auto-generated method stub
				if(e.getStateChange()==ItemEvent.SELECTED){
					System.out.println("õǾ");
				}else{
					System.out.println("Ǿ");
				}
			}
			
		});
		button2.addItemListener(new ItemListener(){

			public void itemStateChanged(ItemEvent e) {
				// TODO Auto-generated method stub
				if(e.getStateChange()==ItemEvent.SELECTED){
					System.out.println("õ");
				}else{
					
					System.out.println("");
				}
			}
			
		});
		ButtonGroup g = new ButtonGroup();
		g.add(button);
		g.add(button2);
		p.add(button);
		p.add(button2);
		frame.add(p);
		frame.setVisible(true);
		frame.setSize(300,200);
		//frame.addKeyListener(new MainKeyListener());
	}
}
