package FuncDialog;

import java.awt.Button;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import Shapes.ParentElement;
import Start.MainFrame;


public class FuncDialog extends JDialog implements ActionListener, ItemListener, ChangeListener, CaretListener, MouseListener {
	
	private static final long serialVersionUID = 1L;
	private FlowLayout flowLayout, flowLayout2;
	private CardLayout cardLayout;
	private Box box;
	private ParentElement element;
	
	private JPanel eastPanel, centerPanel, westPanel ;
	private JPanel pn_stroke, pn_texture, pn_gradient, pn_color;	
	private JPanel pn_strokeSize, pn_length, pn_rotation, pn_opacity;
	private JPanel pn_colorColor;
			
	private JButton bt_pattern;
	private JButton bt_stroke, bt_texture, bt_gradient, bt_color;
	private Button bt_lineColor, bt_fillColor, bt_gradStart, bt_gradEnd;
	private JRadioButton radio_stroke, radio_texture, radio_gradient, radio_color;
	private ButtonGroup buttonGroup;

	private JCheckBox check_pattern;
	private JCheckBox fill, grad;
	
	private JLabel lb_strokeSize, lb_editWidth, lb_editHeight, lb_rotation, lb_opacity;
	private JLabel lb_pattern, lb_patternScale;
	@SuppressWarnings("unused")
	private JLabel lb_gradAngle, lb_gradColor;
	private JLabel lb_color;

	private JSlider sldr_strokeSize, sldr_editWidth, sldr_editHeight ,sldr_editRotate ,sldr_opacity;
	private JSlider sldr_patternScale;
	private JSlider sldr_gradientAngle;
	
	private JFormattedTextField txtf_strokeSize, txtf_editWidth, txtf_editHeight, txtf_editRotation, txtf_opacity;
	private JFormattedTextField txtf_patternScale;
	private JFormattedTextField txtf_gradientAngle;

	private MainFrame mainframe;
	
	private JPanel pn_textureSelect;
	//
	private JScrollPane scroll;

	private ImageIcon[] img_bigPattern;
//	private JLabel[] lb_bigPattern;
	private String[] pattern;
	private String[] seletedPattern;
	private String[] bigPattern;
	
	private JRadioButton[] radio_pattern;
	private ButtonGroup btGroup_pattern;
	private int offsetWidth, offsetHieght;
	private JColorChooser colorChooser;
	
	@SuppressWarnings("unused")
	private ImageIcon img_pattern54;
	
	
	public FuncDialog(MainFrame mainframe ,ParentElement element){
		super(mainframe, "Edit");
		
		this.mainframe = mainframe;
		this.element = element;
		this.offsetWidth = element.getWidth()/10;
		this.offsetHieght = element.getHeight()/10;
		
		img_bigPattern = new ImageIcon[20];
//		lb_bigPattern = new JLabel[20];
		pattern = new String[20];
		seletedPattern = new String[20];
		bigPattern = new String[20];
		
		for(int i=0 ; i<20 ; i++){
			String str1 = new String("image/pattern");
			str1 += String.valueOf(i) ;
			str1 += ".jpg";
			pattern[i] = str1;
			
			String str2 = new String("image/selected");
			str2 += String.valueOf(i);
			str2 += ".jpg";
			seletedPattern[i] = str2;
			
			String str3 = new String("image/big");
			str3 += String.valueOf(i);
			str3 += ".jpg";
			bigPattern[i] = str3;
						
		}	
		
		flowLayout = new FlowLayout(FlowLayout.LEFT, 5, 5);
		flowLayout2 = new FlowLayout(FlowLayout.LEFT, 0, 0);
		cardLayout = new CardLayout();
		
		box = new Box(BoxLayout.Y_AXIS);
				
		centerPanel = new JPanel();
		westPanel = new JPanel();
		eastPanel = new JPanel();
			
		fill = new JCheckBox("Fill");
		grad = new JCheckBox("Gradation");
		
		if(this.element.information.isFilled){
			this.fill.setSelected(true);
		}
		if(this.element.information.getGradation()){
			this.grad.setSelected(true);
		}
		
		fill.addItemListener(this);
		grad.addItemListener(this);
				
		radio_stroke = new JRadioButton("Edit");
		radio_stroke.setMaximumSize(new Dimension(85, 25));
		radio_stroke.setBackground(Color.LIGHT_GRAY);
				
		radio_texture = new JRadioButton("Texture");
		radio_texture.setMaximumSize(new Dimension(85, 25));
		radio_texture.setBackground(Color.LIGHT_GRAY);
			
		radio_gradient = new JRadioButton("Gradation");
		radio_gradient.setMaximumSize(new Dimension(85, 25));
		radio_gradient.setBackground(Color.LIGHT_GRAY);
			
		radio_color = new JRadioButton("Color");
		radio_color.setMaximumSize(new Dimension(85, 25));
		radio_color.setBackground(Color.LIGHT_GRAY);
			
		bt_stroke = new JButton();
		bt_stroke.setMaximumSize(new Dimension(85, 25));
		bt_stroke.setBorder(BorderFactory.createRaisedBevelBorder());
		bt_stroke.setBackground(Color.LIGHT_GRAY);
			
		bt_texture = new JButton();
		bt_texture.setMaximumSize(new Dimension(85, 25));
		bt_texture.setBorder(BorderFactory.createRaisedBevelBorder());
		bt_texture.setBackground(Color.LIGHT_GRAY);
			
		bt_gradient = new JButton();
		bt_gradient.setMaximumSize(new Dimension(85, 25));
		bt_gradient.setBorder(BorderFactory.createRaisedBevelBorder());
		bt_gradient.setBackground(Color.LIGHT_GRAY);
			
		bt_color = new JButton();
		bt_color.setMaximumSize(new Dimension(85, 25));
		bt_color.setBorder(BorderFactory.createRaisedBevelBorder());
		bt_color.setBackground(Color.LIGHT_GRAY);
			
		buttonGroup = new ButtonGroup();
		
		bt_lineColor = new Button();
		bt_lineColor.setBackground(this.element.information.lineColor);
		bt_fillColor = new Button();
		bt_fillColor.setBackground(this.element.information.fillColor);
		bt_gradStart = new Button();
		bt_gradStart.setBackground(this.element.information.lineColor);
		bt_gradEnd = new Button();
		bt_gradEnd.setBackground(this.element.information.fillColor);
		
		bt_lineColor.addActionListener(this);
		bt_fillColor.addActionListener(this);
		bt_gradStart.addActionListener(this);
		bt_gradEnd.addActionListener(this);
		
		pn_stroke = new JPanel();
		pn_texture = new JPanel();
		pn_gradient = new JPanel();
		pn_color = new JPanel();
		
		pn_strokeSize = new JPanel();
		pn_length = new JPanel();
		pn_rotation = new JPanel();
		pn_opacity = new JPanel();
		
		bt_pattern = new JButton();
		check_pattern = new JCheckBox();
		
		lb_color = new JLabel("Color:");
		
		lb_strokeSize = new JLabel("Size:");
		lb_editWidth = new JLabel ("Width:", SwingConstants.RIGHT);
		lb_editHeight = new JLabel("Height:", SwingConstants.RIGHT);
		lb_rotation = new JLabel("Rotation:");
		lb_opacity = new JLabel("Opacity:");
		
		sldr_strokeSize = new JSlider(SwingConstants.HORIZONTAL);
		sldr_strokeSize.setMaximum(20);
		sldr_strokeSize.setValue(this.element.information.strokeSize);
		sldr_strokeSize.addChangeListener(this);
		
		sldr_editWidth =  new JSlider(SwingConstants.HORIZONTAL, 1, 100, 10);
		sldr_editWidth.addChangeListener(this);
		
		sldr_editHeight = new JSlider(SwingConstants.HORIZONTAL, 1, 100, 10);
		sldr_editHeight.addChangeListener(this);
		
		sldr_editRotate = new JSlider(SwingConstants.HORIZONTAL);
		sldr_editRotate.setMaximum(360);
		sldr_editRotate.setValue((int)this.element.information.getRotationTheta());
		sldr_editRotate.addChangeListener(this);
		
		sldr_opacity = new JSlider(SwingConstants.HORIZONTAL);
		sldr_opacity.setMaximum(10);
		sldr_opacity.setValue(0);
		sldr_opacity.addChangeListener(this);
				
		txtf_strokeSize = new JFormattedTextField();
		txtf_strokeSize.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_strokeSize.addCaretListener(this);
		txtf_strokeSize.setText(String.valueOf(this.element.information.strokeSize));
		
		txtf_editWidth = new JFormattedTextField();
		txtf_editWidth.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_editWidth.addCaretListener(this);
		
		txtf_editHeight = new JFormattedTextField();
		txtf_editHeight.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_editHeight.addCaretListener(this);	
		
		txtf_editRotation = new JFormattedTextField();
		txtf_editRotation.setHorizontalAlignment(SwingConstants.RIGHT);
		
		txtf_opacity = new JFormattedTextField();
		txtf_opacity.setHorizontalAlignment(SwingConstants.RIGHT);
				
		lb_pattern = new JLabel("Pattern:", SwingConstants.RIGHT);
		lb_patternScale = new JLabel(" Scale:");
		
		sldr_patternScale = new JSlider(SwingConstants.HORIZONTAL, 0, 100, 50);
		sldr_patternScale.addChangeListener(this);
		
		txtf_patternScale = new JFormattedTextField("50");
		txtf_patternScale.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_patternScale.addCaretListener(this);

		sldr_gradientAngle = new JSlider(SwingConstants.HORIZONTAL, 0, 100, 50);
		sldr_gradientAngle.setMaximum(360);
		sldr_gradientAngle.setValue(0);
		sldr_gradientAngle.addChangeListener(this);
		
		txtf_gradientAngle = new JFormattedTextField();
		txtf_gradientAngle.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_gradientAngle.addCaretListener(this);
			
		lb_gradAngle = new JLabel("Angle:", SwingConstants.RIGHT);
		lb_gradColor = new JLabel("Color:", SwingConstants.RIGHT);
		
		pn_colorColor = new JPanel();
		pn_colorColor.setBorder(BorderFactory.createLoweredBevelBorder());
		
		colorChooser = new JColorChooser();
		
		pn_textureSelect = new JPanel();
		
		scroll = new JScrollPane(pn_textureSelect, 
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		
		radio_pattern = new JRadioButton[20];
		btGroup_pattern = new ButtonGroup();
					
		this.sub();
	}
	
	public void sub(){
		this.setLayout(flowLayout);
		this.setSize(new Dimension(450, 330));
		this.setLocation(new Point(600, 200));
		this.setVisible(true);
		
		westPanel.setLayout(new BoxLayout(westPanel, BoxLayout.Y_AXIS));
		westPanel.setPreferredSize(new Dimension(90, 285));
		westPanel.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
		
		centerPanel.setLayout(cardLayout);
		centerPanel.setPreferredSize(new Dimension(250, 285));
		
		pn_stroke.setLayout(flowLayout2);
		pn_texture.setLayout(null);
		pn_gradient.setLayout(null);
		pn_color.setLayout(null);
		pn_textureSelect.setLayout(new GridLayout(4, 5));
		pn_textureSelect.setPreferredSize(new Dimension(100, 90));
	//	pn_textureSelect.setBackground(Color.red);
			
		pn_strokeSize.setLayout(null);
		pn_strokeSize.setPreferredSize(new Dimension(238, 55));
		pn_strokeSize.setBorder(BorderFactory.createTitledBorder("Stroke"));
	
		pn_length.setLayout(null);
		pn_length.setPreferredSize(new Dimension(238, 90));
		pn_length.setBorder(BorderFactory.createTitledBorder("Length"));
		
		pn_rotation.setLayout(null);
		pn_rotation.setPreferredSize(new Dimension(238, 55));
		pn_rotation.setBorder(BorderFactory.createTitledBorder("Rotation"));
		
		pn_opacity.setLayout(null);
		pn_opacity.setPreferredSize(new Dimension(238, 55));
		pn_opacity.setBorder(BorderFactory.createTitledBorder("Opacity"));
		
		lb_strokeSize.setBounds(new Rectangle(15, 25, 40, 20));
		pn_strokeSize.add(lb_strokeSize);
		
		sldr_strokeSize.setBounds(new Rectangle(50, 25, 130, 20));
		pn_strokeSize.add(sldr_strokeSize);
		
		txtf_strokeSize.setBounds(new Rectangle(185, 25, 40, 20));
		pn_strokeSize.add(txtf_strokeSize);
		
		lb_editWidth.setBounds(new Rectangle(15, 55, 40, 20));
		pn_length.add(lb_editWidth);
		
		sldr_editWidth.setBounds(new Rectangle(60, 55, 120, 20));
		pn_length.add(sldr_editWidth);
		
		txtf_editWidth.setBounds(new Rectangle(185, 55, 40, 20));
		txtf_editWidth.setText(String.valueOf(this.element.getWidth()));
		pn_length.add(txtf_editWidth);
		
		lb_editHeight.setBounds(new Rectangle(15, 25, 40, 20));
		pn_length.add(lb_editHeight);
		
		sldr_editHeight.setBounds(new Rectangle(60, 25, 120, 20));
		pn_length.add(sldr_editHeight);
		
		txtf_editHeight.setBounds(new Rectangle(185, 25, 40, 20));
		txtf_editHeight.setText(String.valueOf(this.element.getHeight()));
		pn_length.add(txtf_editHeight);
		
		lb_rotation.setBounds(new Rectangle(15, 25, 50, 20));
		pn_rotation.add(lb_rotation);
		
		sldr_editRotate.setBounds(new Rectangle(70, 25, 110, 20));
		pn_rotation.add(sldr_editRotate);
		
		txtf_editRotation.setBounds(new Rectangle(185, 25, 40, 20));
		pn_rotation.add(txtf_editRotation);
		txtf_editRotation.setText(""+this.element.information.getRotationTheta());
		
		lb_opacity.setBounds(new Rectangle(15, 25, 50, 20));
		pn_opacity.add(lb_opacity);
		
		sldr_opacity.setBounds(new Rectangle(70, 25, 110, 20));
		pn_opacity.add(sldr_opacity);
		
		txtf_opacity.setBounds(new Rectangle(185, 25, 40, 20));
		pn_opacity.add(txtf_opacity);
		txtf_opacity.setText(""+this.element.information.opacity);				
		box.add(pn_strokeSize);
		box.add(pn_length);
		box.add(pn_rotation);
		box.add(pn_opacity);
		
		pn_stroke.add(box);
		
		check_pattern.setBounds(new Rectangle(15, 40, 20, 20));
		pn_texture.add(check_pattern);
		check_pattern.addItemListener(this);
		
		lb_pattern.setBounds(new Rectangle(35, 40, 45, 20));
		pn_texture.add(lb_pattern);
		
		bt_pattern.setBounds(new Rectangle(90, 25, 50, 50));
		pn_texture.add(bt_pattern);
		
		lb_patternScale.setBounds(new Rectangle(15, 85, 45, 20));
		pn_texture.add(lb_patternScale);
		
		sldr_patternScale.setBounds(new Rectangle(65, 85, 100, 20));
		pn_texture.add(sldr_patternScale);
		
		txtf_patternScale.setBounds(new Rectangle(170, 85, 45, 20));
		pn_texture.add(txtf_patternScale);
		
		for(int i=0 ; i<pattern.length ; i++) {
			img_bigPattern[i] = new ImageIcon(bigPattern[i]);
			radio_pattern[i] = new JRadioButton();
			radio_pattern[i].setIcon(new ImageIcon(pattern[i]));
			radio_pattern[i].setSelectedIcon(new ImageIcon(seletedPattern[i]));
			btGroup_pattern.add(radio_pattern[i]);
			pn_textureSelect.add(radio_pattern[i]);
			radio_pattern[i].addItemListener(this);
		}
		radio_pattern[0].setSelected(true);
		scroll.setBounds(new Rectangle(25, 120, 180, 150));
		pn_texture.add(scroll);
		
		grad.setBounds(new Rectangle(15, 25, 80, 20));
		pn_gradient.add(grad);
		
		lb_gradAngle.setBounds(new Rectangle(15, 50, 40, 20));
		pn_gradient.add(lb_gradAngle);
		
		sldr_gradientAngle.setBounds(new Rectangle(60, 50, 130, 20));
		pn_gradient.add(sldr_gradientAngle);
		sldr_gradientAngle.setValue((int)this.element.information.gradTheta);
		
		txtf_gradientAngle.setBounds(new Rectangle(195, 50, 40, 20));
		pn_gradient.add(txtf_gradientAngle);
		txtf_gradientAngle.setText(""+this.element.information.gradTheta);
	
		lb_gradColor.setBounds(new Rectangle(15, 95, 40, 20));
		pn_gradient.add(lb_gradColor);
		
		bt_gradStart.setBounds(new Rectangle(60, 80, 40, 40));
		pn_gradient.add(bt_gradStart);
		
		bt_gradEnd.setBounds(new Rectangle(75, 95, 40, 40));
		pn_gradient.add(bt_gradEnd);
	
		//
		fill.setBounds(new Rectangle(15, 25, 60, 20));
		fill.addChangeListener(this);
		pn_color.add(fill);
				
		lb_color.setBounds(new Rectangle(15, 65, 40, 20));
		pn_color.add(lb_color);
				
		bt_lineColor.setBounds(new Rectangle(55, 50, 40, 40));
		pn_color.add(bt_lineColor);
		
		bt_fillColor.setBounds(new Rectangle(70, 65, 40, 40));
		pn_color.add(bt_fillColor);
		
	
			
		centerPanel.add("stroke", pn_stroke);
		centerPanel.add("texture", pn_texture);
		centerPanel.add("gradation", pn_gradient);
		centerPanel.add("color", pn_color);
		cardLayout.show(centerPanel, "opacity");
		
		pn_stroke.setBorder(BorderFactory.createTitledBorder("Edit"));
		pn_texture.setBorder(BorderFactory.createTitledBorder("Texture"));
		pn_gradient.setBorder(BorderFactory.createTitledBorder("Gradation"));
		pn_color.setBorder(BorderFactory.createTitledBorder("Color"));
		//				
		eastPanel.setPreferredSize(new Dimension(99, 285));
		
		buttonGroup.add(radio_stroke);
		buttonGroup.add(radio_texture);
		buttonGroup.add(radio_gradient);
		buttonGroup.add(radio_color);
		
		bt_stroke.add(radio_stroke);
		bt_texture.add(radio_texture);
		bt_gradient.add(radio_gradient);
		bt_color.add(radio_color);

		westPanel.add(bt_stroke);
		westPanel.add(bt_texture);
		westPanel.add(bt_gradient);
		westPanel.add(bt_color);
		
		this.add(westPanel);
		this.add(centerPanel);
		this.add(eastPanel);
	
		radio_stroke.addActionListener(this);
		radio_texture.addActionListener(this);
		radio_gradient.addActionListener(this);
		radio_color.addActionListener(this);
				
		sldr_strokeSize.addChangeListener(this);
		sldr_editWidth.addChangeListener(this);
		sldr_editHeight.addChangeListener(this);
		sldr_editRotate.addChangeListener(this);
		sldr_opacity.addChangeListener(this);
		
		System.gc();
		System.runFinalization();
	}
	
	@SuppressWarnings("static-access")
	public void actionPerformed(ActionEvent e) {
		Object o = e.getSource();
	
		if(o == radio_stroke){
			cardLayout.show(centerPanel, "stroke");
		}	
		else if(o == radio_texture){
			cardLayout.show(centerPanel, "texture");
		}	
		else if(o == radio_gradient){
			cardLayout.show(centerPanel, "gradation");
		}	
		else if(o == radio_color){
			cardLayout.show(centerPanel, "color");
		}else if(o == this.bt_lineColor){
			Color color = this.colorChooser.showDialog(this, "Choose Color", this.element.information.lineColor);
			this.bt_lineColor.setBackground(color);
			this.element.information.lineColor = color;
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
		}else if(o == this.bt_fillColor){
			Color color = this.colorChooser.showDialog(this, "Choose Color", this.element.information.fillColor);
			this.bt_fillColor.setBackground(color);
			this.element.information.fillColor = color;
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
		}else if(o == this.bt_gradStart){
			Color color = this.colorChooser.showDialog(this, "Choose Color", this.element.information.lineColor);
			this.bt_gradStart.setBackground(color);
			this.element.information.lineColor = color;
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
		}else if(o == this.bt_gradEnd){
			Color color = this.colorChooser.showDialog(this, "Choose Color", this.element.information.fillColor);
			this.bt_gradEnd.setBackground(color);
			this.element.information.fillColor = color;
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
		}
		
		
	}

	public void stateChanged(ChangeEvent e) {
		Object o = e.getSource();
		
		if(o == sldr_strokeSize){
			txtf_strokeSize.setText("" + sldr_strokeSize.getValue());
			int value = sldr_strokeSize.getValue();
			this.element.information.setStrokeSize(value);
			this.mainframe.repaint();
		
		}else if(e.getSource().equals(sldr_patternScale)) {
			txtf_patternScale.setText("" + sldr_patternScale.getValue());
			
		}else if(e.getSource().equals(sldr_editWidth)) {
			txtf_editWidth.setText("" + (sldr_editWidth.getValue()*this.offsetWidth));
			this.element.setWidth(sldr_editWidth.getValue()*this.offsetWidth);
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
		}else if(e.getSource().equals(sldr_editHeight)) {
			txtf_editHeight.setText("" + (sldr_editWidth.getValue()*this.offsetHieght));
			this.element.setHeight(sldr_editHeight.getValue()*this.offsetHieght);
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
		}else if(e.getSource().equals(sldr_editRotate)) {
			
			int value = sldr_editRotate.getValue();	
			this.txtf_editRotation.setText(""+value);
			if(value == 0 || value == 360 ){
				this.element.information.isRoatated = false;
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
				this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			}else{
			this.element.information.isRoatated = true;
			this.element.information.setRotationTheta((float)value);
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			}
		}else if(e.getSource().equals(sldr_opacity)) {
			int value = sldr_opacity.getValue();	
			float result = ((float)10 - (float)value) / (float)10;
			this.element.information.opacity = result;
			this.txtf_opacity.setText(""+result);
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
		}else if(e.getSource().equals(sldr_gradientAngle)) {
			
			int value = sldr_gradientAngle.getValue();	
			this.txtf_gradientAngle.setText(""+value);
			this.element.information.gradTheta = value;
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
		}
		
		
	}

	public void caretUpdate(CaretEvent e) {
		
		if(e.getSource().equals(txtf_strokeSize)) {
			try{
				int temp = Integer.parseInt(txtf_strokeSize.getText());
				sldr_strokeSize.setValue(temp);
				
			}catch(Exception err) {}
			
		}else if(e.getSource().equals(txtf_patternScale)) {
			try{
				int temp = Integer.parseInt(txtf_patternScale.getText());
				sldr_patternScale.setValue(temp);
				
			}catch(Exception err) {}
			
		}else if(e.getSource().equals(txtf_gradientAngle)) {
			try{
				int temp = Integer.parseInt(txtf_gradientAngle.getText());
				sldr_gradientAngle.setValue(temp);
				
			}catch(Exception err) {}
			
		}
	}

	public void mouseClicked(MouseEvent e) {
				
	}

	public void mouseEntered(MouseEvent arg0) {
		// TODO ڵ  ޼ҵ 
		
	}

	public void mouseExited(MouseEvent arg0) {
		// TODO ڵ  ޼ҵ 
		
	}

	public void mousePressed(MouseEvent arg0) {
		// TODO ڵ  ޼ҵ 
		
	}

	public void mouseReleased(MouseEvent arg0) {
		// TODO ڵ  ޼ҵ 
		
	}

	public void itemStateChanged(ItemEvent e) {

		for(int i=0 ; i<radio_pattern.length ; i++) {

			if(e.getSource().equals(radio_pattern[i])) {
				if(e.getStateChange() == ItemEvent.SELECTED) {
					bt_pattern.setIcon(img_bigPattern[i]);
					BufferedImage buf = new BufferedImage(img_bigPattern[i].getImage().getWidth(null),img_bigPattern[i].getImage().getHeight(null),BufferedImage.TYPE_INT_RGB);
					Graphics2D gwd = buf.createGraphics();
					gwd.drawImage(img_bigPattern[i].getImage(), 0, 0, null);
					this.element.texture = buf;
					this.mainframe.currentCanvasFrame.canvasPanel.repaint();
					
				}
			}	
		}
				
		Object o = e.getSource();
		int type = e.getStateChange();
		
		if( o == fill){
			if(type == ItemEvent.SELECTED){
				this.element.information.isFilled = true;
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
				this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			}else{
				this.element.information.isFilled = false;
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
				this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			}
		}
		if(o == grad){
			
			if(type == ItemEvent.SELECTED){
				this.element.information.setGradation(true);
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
				this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			}else{
				this.element.information.setGradation(false);
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
				this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			}
		}
		if(o == check_pattern){
			
			if(type == ItemEvent.SELECTED){
				this.element.information.setTexture(true);
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
				this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			}else{
				this.element.information.setTexture(false);
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
				this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			}
		}
	}
	
	
	
	public class display extends JPanel{
		private static final long serialVersionUID = -5788618100011699370L;

		public display(){
			
		}
		
		public void paint(Graphics g){
			super.paint(g);
			Graphics2D g2d = (Graphics2D)g; 
			GradientPaint grad;
			if(mainframe.currentCanvasFrame.canvasPanel.getHeight()<90){
		  		grad=new GradientPaint(element.information.getGradStart().x, element.information.getGradStart().y,
		  				element.information.lineColor,element.information.getGradEnd().x,
		  				element.information.getGradEnd().y ,element.information.fillColor, false);
		  		
			}else{
				int rate = mainframe.currentCanvasFrame.canvasPanel.getHeight() /this.getHeight();
				@SuppressWarnings("unused")
				int width = mainframe.currentCanvasFrame.canvasPanel.getWidth()/rate;
		  		grad=new GradientPaint(element.information.getGradStart().x/rate, element.information.getGradStart().y/rate,
		  				element.information.lineColor,element.information.getGradEnd().x/rate,
		  				element.information.getGradEnd().y/rate ,element.information.fillColor, false);
			}
			g2d.setPaint(grad);
			g2d.fillRect(0, 0, this.getWidth(), this.getHeight());
		}
	}
}
	