package FuncDialog;


import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;

import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFormattedTextField;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSeparator;
import javax.swing.JSlider;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import panels.DisplayPanel;
import popupMenus.PopupRGB;
import utils.DrawStateSingleton;

import ColorReplace.ColorReplacementDlg;
import Shapes.ElementImage;
import Start.MainFrame;
import Tools.ToolStateEyeDropper;


public class imageFunDialog extends JInternalFrame implements ActionListener, ChangeListener 
,ItemListener{
	
	private static final long serialVersionUID = 1L;
	@SuppressWarnings("unused")
	private PopupRGB pop;
	private FlowLayout flowLayout, flowLayout2;
	private CardLayout cardLayout;
	
	private MainFrame mainframe;
	private ElementImage element;
	
	private JPanel centerPanel;
	private JPanel westPanel;
	private JPanel eastPanel;
	private JPanel adjustPanel;
	private JPanel brightAdjustPanel, contrastAdjustPanel,editPanel ,gradPanel, colorPanel, opacityPanel;
	private JPanel pn_length, pn_rotation;
	
	private DisplayPanel displayPanel;
	
	private JCheckBox check_blur, check_sharpen, check_gray, check_invert;
	private JCheckBox check_edge, check_posterize ,check_grad;
	
	private JButton bt_ok, bt_cancel;
	private JButton bt_bright, bt_contrast, bt_edit, bt_grad, bt_color, bt_opacity;
	private JButton bt_ColorReplace;
	private JRadioButton radio_bright, radio_contrast, radio_edit, radio_grad, radio_color, radio_opacity;
	private ButtonGroup btGroup;

	private JLabel lb_bright, lb_contrast;
	private JLabel lb_opacity, lb_width, lb_height, lb_rotation;
	private JLabel lb_gradOpacity, lb_gradRotation;
	
	private JSlider sldr_bright, sldr_contrast, sldr_rotate, sldr_width, sldr_height, sldr_opacity, sldr_gradientOpacity, sldr_gradientAngle;
	private JFormattedTextField txtf_bright, txtf_contrast;
	private JFormattedTextField txtf_opacity, txtf_width, txtf_height, txtf_rotation;
	private JFormattedTextField txtf_gradOpacity, txtf_gradRotation;
	
	private Box box, myBox;
	
	private int offsetWidth, offsetHieght;
			
	public imageFunDialog(MainFrame mainframe, ElementImage element){
		
		flowLayout = new FlowLayout(FlowLayout.LEFT, 5, 5);
		flowLayout2 = new FlowLayout(FlowLayout.LEFT, 0, 0);
		cardLayout = new CardLayout();
		
		this.mainframe = mainframe;
		this.element = element;
		
		pop = new PopupRGB(this);
		
		this.offsetWidth = element.getWidth()/10;
		this.offsetHieght = element.getHeight()/10;
		
		/*Panels*/
		centerPanel = new JPanel();
		westPanel = new JPanel();
		eastPanel = new JPanel();
		
		brightAdjustPanel = new JPanel();
		contrastAdjustPanel = new JPanel();
		editPanel = new JPanel();
		gradPanel = new JPanel();
		colorPanel = new JPanel();
		opacityPanel = new JPanel();
		
		displayPanel  = new DisplayPanel(this.element);
		adjustPanel = new JPanel();
		
		pn_length = new JPanel();
		pn_rotation = new JPanel();
		
		/*RadioButtons*/
		radio_bright = new JRadioButton("Bright");
		radio_bright.setMaximumSize(new Dimension(80, 25));
	
		radio_contrast = new JRadioButton("Contrast");
		radio_contrast.setMaximumSize(new Dimension(80, 25));
	
		radio_edit = new JRadioButton("Edit");
		radio_edit.setMaximumSize(new Dimension(80, 25));
	
		radio_grad = new JRadioButton("Grad");
		radio_grad.setMaximumSize(new Dimension(80, 25));
		
		radio_color = new JRadioButton("Color");
		radio_color.setMaximumSize(new Dimension(80, 25));
		
		radio_opacity = new JRadioButton("Opacity");
		radio_opacity.setMaximumSize(new Dimension(80, 25));
		
		btGroup = new ButtonGroup();
		btGroup.add(radio_edit);
		btGroup.add(radio_bright);
		btGroup.add(radio_contrast);
		btGroup.add(radio_grad);
		btGroup.add(radio_color);
		btGroup.add(radio_opacity);
		
		/*Buttons*/
		bt_bright = new JButton();
		bt_bright.setMaximumSize(new Dimension(80, 25));
		bt_bright.setBorder(BorderFactory.createRaisedBevelBorder());
		bt_bright.setBackground(Color.LIGHT_GRAY);
		bt_bright.add(radio_bright);
				
		bt_contrast = new JButton();
		bt_contrast.setPreferredSize(new Dimension(80, 25));
		bt_contrast.setBorder(BorderFactory.createRaisedBevelBorder());
		bt_contrast.setBackground(Color.LIGHT_GRAY);
		bt_contrast.add(radio_contrast);
		
		bt_edit = new JButton();
		bt_edit.setPreferredSize(new Dimension(80, 25));
		bt_edit.setBorder(BorderFactory.createRaisedBevelBorder());
		bt_edit.setBackground(Color.LIGHT_GRAY);
		bt_edit.add(radio_edit);
		
		bt_grad = new JButton();
		bt_grad.setPreferredSize(new Dimension(80, 25));
		bt_grad.setBorder(BorderFactory.createRaisedBevelBorder());
		bt_grad.setBackground(Color.LIGHT_GRAY);
		bt_grad.add(radio_grad);
		
		bt_color = new JButton();
		bt_color.setPreferredSize(new Dimension(80, 25));
		bt_color.setBorder(BorderFactory.createRaisedBevelBorder());
		bt_color.setBackground(Color.LIGHT_GRAY);
		bt_color.add(radio_color);
		
		bt_opacity = new JButton();
		bt_opacity.setPreferredSize(new Dimension(80, 25));
		bt_opacity.setBorder(BorderFactory.createRaisedBevelBorder());
		bt_opacity.setBackground(Color.LIGHT_GRAY);
		bt_opacity.add(radio_opacity);
		
		bt_ok = new JButton("Ok");
		bt_cancel = new JButton("Cancel");		
		
		/*CheckBox*/
		check_blur = new JCheckBox("Blur");
		check_sharpen = new JCheckBox("Sharpen");
		check_gray = new JCheckBox("Gray");
		check_invert = new JCheckBox("Invert");
		check_edge = new JCheckBox("Edge");
		check_posterize= new JCheckBox("Posterize");
					
		/*Label*/
		lb_bright = new JLabel("Bright:");
		lb_contrast = new JLabel("Contrast:");
		lb_opacity = new JLabel("Opacity:");
		lb_width = new JLabel("Width:", SwingConstants.RIGHT);
		lb_height = new JLabel("Length:", SwingConstants.RIGHT);
		lb_rotation = new JLabel("Rotation:");
		
		lb_gradOpacity = new JLabel("Opacity:", SwingConstants.RIGHT);
		lb_gradRotation = new JLabel("Rotation:", SwingConstants.RIGHT);
				
		/*Slider*/
		sldr_bright = new JSlider(SwingConstants.HORIZONTAL, 0, 100, 50);
		sldr_bright.addChangeListener(this);
			
		sldr_contrast = new JSlider(SwingConstants.HORIZONTAL, 0, 100, 20);
		sldr_contrast.addChangeListener(this);
				
		sldr_rotate = new JSlider(SwingConstants.HORIZONTAL, 0, 100, 0);
		sldr_rotate.addChangeListener(this);
		
		sldr_opacity = new JSlider(SwingConstants.HORIZONTAL, 0, 100, 0);
		sldr_opacity.addChangeListener(this);
		
		sldr_width = new JSlider(SwingConstants.HORIZONTAL, 1, 100, 10);
		sldr_width.addChangeListener(this);
		
		sldr_height = new JSlider(SwingConstants.HORIZONTAL, 1, 100, 10);
		sldr_height.addChangeListener(this);
				
		sldr_gradientAngle = new JSlider(SwingConstants.HORIZONTAL, 0, 100, 0);
		sldr_gradientAngle.addChangeListener(this);
		
		sldr_gradientOpacity = new JSlider(SwingConstants.HORIZONTAL, 0, 100, 0);
		sldr_gradientOpacity.addChangeListener(this);
		
		/*FormattedTextField*/
		txtf_bright = new JFormattedTextField();
		txtf_bright.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_contrast = new JFormattedTextField();
		txtf_contrast.setHorizontalAlignment(SwingConstants.RIGHT);
		
		txtf_opacity = new JFormattedTextField();
		txtf_opacity.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_width = new JFormattedTextField();
		txtf_width.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_height = new JFormattedTextField();
		txtf_height.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_rotation = new JFormattedTextField();
		txtf_rotation.setHorizontalAlignment(SwingConstants.RIGHT);
		
		txtf_gradOpacity = new JFormattedTextField();
		txtf_gradOpacity.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_gradRotation = new JFormattedTextField();
		txtf_gradRotation.setHorizontalAlignment(SwingConstants.RIGHT);
		
		box = new Box(BoxLayout.Y_AXIS);
	
		myBox = new Box(BoxLayout.Y_AXIS);
	
		this.sub();
		//this.requestFocusInWindow();
		this.requestFocus();
	}
	
	@SuppressWarnings("static-access")
	private void sub() {
		this.setLayout(flowLayout);
		this.setBounds(new Rectangle(600, 200, 470, 415));
		this.setVisible(true);
				
		/*make wsetPanel Attribute*/
		westPanel.setLayout(flowLayout);
		westPanel.setPreferredSize(new Dimension(95, 370));
		westPanel.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
		bt_ColorReplace = new JButton("Replace");
		
		bt_ColorReplace.setMaximumSize(new Dimension(80,40));
		bt_ColorReplace.setBorder(BorderFactory.createRaisedBevelBorder());
		bt_ColorReplace.addActionListener(this);
		box.add(bt_edit);
		box.add(bt_opacity);
		box.add(bt_bright);
		box.add(bt_contrast);
		box.add(bt_grad);
		box.add(bt_color);
		
		box.add(box.createRigidArea(new Dimension(0, 5)));
		box.add(new JSeparator());
		box.add(box.createRigidArea(new Dimension(0, 5)));
		box.add(check_blur);
		box.add(check_sharpen);
		box.add(check_gray);
		box.add(check_invert);
		box.add(check_edge);
		box.add(check_posterize);
		box.add(box.createRigidArea(new Dimension(0, 5)));
		box.add(new JSeparator());
		box.add(box.createRigidArea(new Dimension(0, 5)));
		box.add(bt_ColorReplace);
		westPanel.add(box);
						
		/*centerPanel*/
		centerPanel.setLayout(null);
		centerPanel.setPreferredSize(new Dimension(250, 370));
		
		displayPanel.setBounds(new Rectangle(0, 0, 250, 200));
		centerPanel.add(displayPanel);
		adjustPanel.setBounds(new Rectangle(0, 205, 250, 165));
		centerPanel.add(adjustPanel);

		adjustPanel.setLayout(cardLayout);
		displayPanel.setBorder(BorderFactory.createLoweredBevelBorder());
			
		/*adjustPanel*/
		brightAdjustPanel.setBorder(BorderFactory.createTitledBorder("Bright"));
		contrastAdjustPanel.setBorder(BorderFactory.createTitledBorder("Contrast"));
		editPanel.setBorder(BorderFactory.createTitledBorder("Edit"));
		gradPanel.setBorder(BorderFactory.createTitledBorder("Gradation"));
		colorPanel.setBorder(BorderFactory.createTitledBorder("Color"));
		opacityPanel.setBorder(BorderFactory.createTitledBorder("Opacity"));
		
		adjustPanel.add("Edit", editPanel);
		adjustPanel.add("Opacity", opacityPanel);
		adjustPanel.add("Bright", brightAdjustPanel);
		adjustPanel.add("Contrast", contrastAdjustPanel);
		adjustPanel.add("Grad", gradPanel);
		adjustPanel.add("Color", colorPanel);
				
		brightAdjustPanel.add(sldr_bright);
		contrastAdjustPanel.add(sldr_contrast);
		
		//Bright,Contrast,Rotate
		cardLayout.show(adjustPanel, "Edit");
		
		/*eastPanel*/
		eastPanel.setPreferredSize(new Dimension(90, 370));
		eastPanel.setLayout(null);
		
		bt_ok.setBounds(new Rectangle(5, 5, 80, 20));
		eastPanel.add(bt_ok);
		bt_cancel.setBounds(new Rectangle(5, 30, 80, 20));
		bt_ok.addActionListener(this);
		eastPanel.add(bt_cancel);
		
		/*brightAdjustPanel*/
		brightAdjustPanel.setLayout(null);
		
		lb_bright.setBounds(new Rectangle(15, 35, 50, 20));
		brightAdjustPanel.add(lb_bright);
		
		sldr_bright.setBounds(new Rectangle(55, 35, 140, 20));
		brightAdjustPanel.add(sldr_bright);
		
		txtf_bright.setBounds(new Rectangle(195, 35, 40, 20));
		brightAdjustPanel.add(txtf_bright);
		txtf_bright.setText(""+50);
		/*contrastAdjustPanel*/
		contrastAdjustPanel.setLayout(null);
		
		lb_contrast.setBounds(new Rectangle(15, 35, 60, 20));
		contrastAdjustPanel.add(lb_contrast);
		
		sldr_contrast.setBounds(new Rectangle(70, 35, 125, 20));
		contrastAdjustPanel.add(sldr_contrast);
		
		txtf_contrast.setBounds(new Rectangle(195, 35, 40, 20));
		contrastAdjustPanel.add(txtf_contrast);
		txtf_contrast.setText(""+20);
		/*opacityPanel*/
		opacityPanel.setLayout(null);
		
		lb_opacity.setBounds(new Rectangle(15, 35, 50, 20));
		opacityPanel.add(lb_opacity);
		
		sldr_opacity.setBounds(new Rectangle(65, 35, 120, 20));
		opacityPanel.add(sldr_opacity);
		sldr_opacity.setMaximum(10);
		
		txtf_opacity.setBounds(new Rectangle(185, 35, 40, 20));
		opacityPanel.add(txtf_opacity);
		
		/*editpanel*/
		editPanel.setLayout(flowLayout2);
		
		pn_length.setLayout(null);
		pn_rotation.setLayout(null);
				
		pn_length.setPreferredSize(new Dimension(238, 80));
		pn_rotation.setPreferredSize(new Dimension(238, 55));
		
		pn_length.setBorder(BorderFactory.createTitledBorder("Length"));
		pn_rotation.setBorder(BorderFactory.createTitledBorder("Rotation"));
				
		lb_width.setBounds(new Rectangle(15, 20, 50, 20));
		pn_length.add(lb_width);
		
		sldr_width.setBounds(new Rectangle(65, 20, 120, 20));
		pn_length.add(sldr_width);
		
		txtf_width.setBounds(new Rectangle(185, 20, 40, 20));
		pn_length.add(txtf_width);
		txtf_width.setText(""+this.element.rect.getWidth());
		
		lb_height.setBounds(new Rectangle(15, 45, 50, 20));
		pn_length.add(lb_height);
		
		sldr_height.setBounds(new Rectangle(65, 45, 120, 20));
		pn_length.add(sldr_height);
		
		txtf_height.setBounds(new Rectangle(185, 45, 40, 20));
		pn_length.add(txtf_height);
		txtf_height.setText(""+this.element.rect.getHeight());
				
		lb_rotation.setBounds(new Rectangle(15, 20, 50, 20));
		pn_rotation.add(lb_rotation);
		
		sldr_rotate.setBounds(new Rectangle(65, 20, 120, 20));
		pn_rotation.add(sldr_rotate);
		sldr_rotate.setMaximum(360);
		
		txtf_rotation.setBounds(new Rectangle(185, 20, 40, 20));
		pn_rotation.add(txtf_rotation);
		txtf_rotation.setText(""+this.element.information.getRotationTheta());
		
		myBox.add(pn_length);
		myBox.add(pn_rotation);
		
		editPanel.add(myBox);
					
		/*GradPanel*///sldr_gradientOpacity , sldr_gradientAngle
		gradPanel.setLayout(null);
		
		check_grad = new JCheckBox("Gradation");
		check_grad.setBounds(new Rectangle(15, 25, 80, 20));
		check_grad.addItemListener(this);
		gradPanel.add(check_grad);
		
		lb_gradOpacity.setBounds(new Rectangle(15, 50, 50, 20));
		gradPanel.add(lb_gradOpacity);
		
		sldr_gradientOpacity.setBounds(new Rectangle(70, 50, 125, 20));
		gradPanel.add(sldr_gradientOpacity);
		sldr_gradientOpacity.setMaximum(10);
		sldr_gradientOpacity.setValue(0);
		
		txtf_gradOpacity.setBounds(new Rectangle(195, 50, 40, 20));
		gradPanel.add(txtf_gradOpacity);
		txtf_gradOpacity.setText("0");
		
		lb_gradRotation.setBounds(new Rectangle(15, 75, 50, 20));
		gradPanel.add(lb_gradRotation);
		
		sldr_gradientAngle.setBounds(new Rectangle(70, 75, 125, 20));
		gradPanel.add(sldr_gradientAngle);
		sldr_gradientAngle.setValue((int)this.element.information.gradTheta);
		
		txtf_gradRotation.setBounds(new Rectangle(195, 75, 40, 20));
		gradPanel.add(txtf_gradRotation);
		txtf_gradRotation.setText(""+this.element.information.gradTheta);
												
		/**/		
		
		/*action*/
		check_blur.addItemListener(this);
		check_sharpen.addItemListener(this);
		check_gray.addItemListener(this);
		check_invert.addItemListener(this);
		check_edge.addItemListener(this);
		check_posterize.addItemListener(this);
		bt_cancel.addActionListener(this);
		radio_bright.addActionListener(this);
		radio_opacity.addActionListener(this);
		radio_contrast.addActionListener(this);
		radio_edit.addActionListener(this);
		radio_grad.addActionListener(this);
		radio_color.addActionListener(this);
		
				
		this.add(westPanel);
		this.add(centerPanel);
		this.add(eastPanel);
	}
	public void setRGBInvert(String str , boolean b){
		if(str.equals("red")){
			this.displayPanel.rInvert = b;
		}else if(str.equals("blue")){
			this.displayPanel.bInvert = b;
		}else if(str.equals("green")){
			this.displayPanel.gInvert = b;
		}
		this.displayPanel.repaint();
	}
	public void setRGBRemove(String str, boolean b){
		if(str.equals("red")){
			this.displayPanel.rRemove = b;
		}else if(str.equals("blue")){
			this.displayPanel.bRemove = b;
		}else if(str.equals("green")){
			this.displayPanel.gRemove = b;
		}
		this.displayPanel.repaint();
	}
	public void actionPerformed(ActionEvent e) {
		Object o = e.getSource();
	
		if(o == bt_cancel){
			this.dispose();
		}
		else if(o == radio_bright){
			cardLayout.show(adjustPanel, "Bright");
		}	
		else if(o == radio_contrast){
			cardLayout.show(adjustPanel, "Contrast");
		}
		else if(o == radio_edit){
			cardLayout.show(adjustPanel, "Edit");
		}
		else if(o == radio_grad){
			cardLayout.show(adjustPanel, "Grad");
		}
		else if(o == bt_ok){
			this.element.bufferedImage = this.displayPanel.dst;
			//this.element.bufferedImage = null;
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			this.dispose();
		}
		else if(o == radio_opacity) {
			cardLayout.show(adjustPanel, "Opacity");
		}else if(o == bt_ColorReplace) {
			
			//BufferedImage bufImage, DisplayPanel displayPanel,MainFrame mainframe
			ColorReplacementDlg dialog = new ColorReplacementDlg(this.element,this.mainframe.currentCanvasFrame.canvasPanel);
			dialog.pack();
			this.mainframe.desktopPane.add(dialog);
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateEyeDropper(mainframe.currentCanvasFrame.canvasPanel,dialog));
				this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
				this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
				this.mainframe.swapToolBar("edit");
		}
		
	}
	
	public void itemStateChanged(ItemEvent e) {
		Object o = e.getSource();
		int type = e.getStateChange();
	
		if(o == check_blur){
			if(type == ItemEvent.SELECTED){
				displayPanel.blur = true;
				displayPanel.repaint();
			}else{
				displayPanel.blur = false;
				displayPanel.repaint();
			}
		}else if(o == check_sharpen){
			if(type == ItemEvent.SELECTED){
				displayPanel.sharpen = true;
				displayPanel.repaint();
			}else{
				displayPanel.sharpen = false;
				displayPanel.repaint();
			}
		}else if(o == check_invert){
			if(type == ItemEvent.SELECTED){
				displayPanel.invert = true;
				displayPanel.repaint();
			}else{
				displayPanel.invert = false;
				displayPanel.repaint();
			}
		}else if(o == check_edge){
			if(type == ItemEvent.SELECTED){
				displayPanel.edge = true;
				displayPanel.repaint();
			}else{
				displayPanel.edge = false;
				displayPanel.repaint();
			}
		}else if(o == check_posterize){
			if(type == ItemEvent.SELECTED){
			displayPanel.posterize = true;
			displayPanel.repaint();
			}else{
				displayPanel.posterize = false;
				displayPanel.repaint();
			}
		}else if(o == check_gray){
			if(type == ItemEvent.SELECTED){
			displayPanel.gray = true;
			displayPanel.repaint();
			}else{
				displayPanel.gray = false;
				displayPanel.repaint();
			}
		}else if(o == check_grad){
			if(type == ItemEvent.SELECTED){
				//this.element.information.setGradation(true);
				this.displayPanel.grad = true;
				}else{
					//this.element.information.setGradation(false);
					this.displayPanel.grad = false;
				}
		}
	}
	
	public void stateChanged(ChangeEvent e) {
		Object o = e.getSource();
	
		if(o == sldr_bright){
			int value = sldr_bright.getValue();
		
			if(value != 50){
				this.displayPanel.bright = true;
				this.displayPanel.brightRescale(value);
				this.txtf_bright.setText(""+value);
				this.displayPanel.repaint();
			}else{
				this.displayPanel.bright = false;
				this.displayPanel.repaint();
			}
		}else if(o == sldr_contrast){
			int value = sldr_contrast.getValue();
			
			if(value !=10){
				this.displayPanel.contrast = true;
				this.displayPanel.ContrastRescale(value);
				this.txtf_contrast.setText(""+value);
				this.displayPanel.repaint();
			}else{
				this.displayPanel.contrast = false;
				this.displayPanel.repaint();
			}
		}else if(o == sldr_rotate){
			int value = sldr_rotate.getValue();	
			this.txtf_rotation.setText(""+value);
			if(value == 0 || value == 360 ){
				this.element.information.isRoatated = false;
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
				this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			}else{
			this.element.information.isRoatated = true;
			this.element.information.setRotationTheta((float)value);
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			}
		}else if(o == sldr_width){
			int value = sldr_width.getValue();	
			this.element.setResizePosition( new Rectangle(this.element.rect.x, this.element.rect.y
					,value*this.offsetWidth,this.element.rect.height));
			this.txtf_width.setText(""+value*this.offsetWidth);
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			
		}else if(o == sldr_height){
			int value = sldr_height.getValue();	
			this.element.setResizePosition( new Rectangle(this.element.rect.x, this.element.rect.y
					,this.element.rect.width,value*this.offsetHieght));
			this.txtf_height.setText(""+value*this.offsetHieght);
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
			
		}else if(e.getSource().equals(sldr_opacity)) {
			
			int value = sldr_opacity.getValue();	
			float result = ((float)10 - (float)value) / (float)10;
			this.element.information.opacity = result;
			this.txtf_opacity.setText(""+result);
			this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
		}else if(e.getSource().equals(sldr_gradientAngle)) {
			
			int value = sldr_gradientAngle.getValue();	
			this.txtf_gradRotation.setText(""+value);
			this.displayPanel.gradTheta = value;
			this.displayPanel.repaint();
		}else if(e.getSource().equals(sldr_gradientOpacity)) {
			
			int value = sldr_gradientOpacity.getValue();	
			float result = ((float)value) / (float)10;
			this.txtf_gradOpacity.setText(""+result);
			this.displayPanel.gradOpacity = result;
			this.displayPanel.repaint();
		
		}	
		
	}

	
}
