package Layers;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import FuncDialog.LayerFuncDialog;
import Start.MainFrame;



public class LayerButton extends JButton implements ActionListener , ItemListener{
	
	private static final long serialVersionUID = 1L;
	
	private JPanel funcPanel, pn_checkBox, pn_radioBt;
	public SmallLayerPanel naviPanel;
	
	public JLabel lb_layerName;
	private Font myFont;
	
	@SuppressWarnings("unused")
	private ImageIcon img_eye, img_empty, img_remove, img_funcdiag;
	
	private JRadioButton radio_wholeLayer;
	
	private JButton func, remove;
		
	private JCheckBox visible;
	private Layer layer;
	
	MainFrame mainframe;
	
	public LayerButton(MainFrame mainframe , Layer layer , JRadioButton radio){
		this.mainframe = mainframe;
		this.layer = layer;
		
		funcPanel = new JPanel();
		
		myFont = new Font("Arial", Font.PLAIN, 9);
		
		lb_layerName = new JLabel("Layer ");
		lb_layerName.setFont(myFont);
		
		pn_checkBox = new JPanel();
		pn_checkBox.setLayout(new GridLayout());
		pn_checkBox.setPreferredSize(new Dimension(22, 20));
		pn_checkBox.setBorder(BorderFactory.createLoweredBevelBorder());
		
		img_eye = new ImageIcon("image/eye.jpg");
		img_empty = new ImageIcon("image/empty.jpg");
		img_remove = new ImageIcon("image/.jpg");
		img_funcdiag = new ImageIcon("image/funcDialog.jpg");
		
		visible = new JCheckBox(img_eye);
		visible.setSelectedIcon(img_empty);
		
		pn_radioBt = new JPanel();
		pn_radioBt.setLayout(new GridLayout());
		pn_radioBt.setPreferredSize(new Dimension(22, 20));
		pn_radioBt.setBorder(BorderFactory.createLoweredBevelBorder());
		
		radio_wholeLayer = radio;
		
		func = new JButton(img_funcdiag);
		remove = new JButton(img_remove);
		
		this.setBorder(BorderFactory.createRaisedBevelBorder());
		this.setLayout(null);
		this.setPreferredSize(new Dimension(180,100));
		this.setMaximumSize(new Dimension(184,52));
		float rate =0;
		float result =0;
		int height = mainframe.currentCanvasFrame.canvasPanel.getHeight();
		rate =height /(float)40;
		result =(int)(mainframe.currentCanvasFrame.canvasPanel.getWidth()/rate);
		
		naviPanel = new SmallLayerPanel(this.layer ,rate,rate);
		
		if(height <=40){
			naviPanel.setBounds(new Rectangle(5, 6, 40, 40));
		}else{
			rate =height /(float)40;
			result =(int)(mainframe.currentCanvasFrame.canvasPanel.getWidth()/rate);
			naviPanel.setBounds(new Rectangle(5, 6, (int)result, 40));
		}
		
		funcPanel.setPreferredSize(new Dimension(40,40));
	
		this.add(naviPanel);
		
		lb_layerName.setBounds(new Rectangle(47, 17, 40, 20));
		this.add(lb_layerName);
		
		pn_radioBt.add(radio_wholeLayer);
		pn_radioBt.setBounds(new Rectangle(81, 15, 22, 20));
		this.add(pn_radioBt);
		
		pn_checkBox.add(visible);
		pn_checkBox.setBounds(new Rectangle(104, 15, 22, 20));
		this.add(pn_checkBox);
					
		func.setBounds(new Rectangle(127, 13, 25, 25));
		this.add(func);
		
		remove.setBounds(new Rectangle(152, 13, 25, 25));
		this.add(remove);
		
		visible.addItemListener(this);
		func.addActionListener(this);
		remove.addActionListener(this);
		radio_wholeLayer.addActionListener(this);
	}
	
	@SuppressWarnings("deprecation")
	public void actionPerformed(ActionEvent e) {
		Object o = e.getSource();
		
		if(o == this.remove){
			this.mainframe.currentCanvasFrame.canvasPanel.removeLayer(this.layer);
		}
		else if(o == this.func){
			@SuppressWarnings("unused")
			LayerFuncDialog lf = new LayerFuncDialog(this.layer);
			lf.show();
		}
		if(o == this.radio_wholeLayer){
			this.mainframe.currentCanvasFrame.canvasPanel.currentLayer = this.layer;
		}
		
	}
	
	public void itemStateChanged(ItemEvent e) {
		Object o = e.getSource();
		
		int type = e.getStateChange();
		System.out.println("type :"+type);
		if(o == visible ){
			if( type == 1){
				this.layer.isVisible = false;
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
				//this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
				this.mainframe.editFrame.updateElement(
						this.mainframe.currentCanvasFrame.canvasPanel.getStorage().getDrawableList());
			}
			else if(type == 2){
				this.layer.isVisible = true;
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
				this.mainframe.editFrame.updateElement(
						this.mainframe.currentCanvasFrame.canvasPanel.getStorage().getDrawableList());
			}
		}
	
	}
}
