package ShapeSelect;


import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.GeneralPath;


import utils.DrawableInformation;

public class ElementSelectPen extends ParentSelect{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private GeneralPath gp = null;
	float[] dash=new float[]{10,5,5,5};
	public Rectangle rect = new Rectangle(0,0,7,7);
	
	public ElementSelectPen(DrawableInformation information){
		this.information = information;
	}
	public void setGeneralPath(GeneralPath gp){
		this.gp = gp;
	}
	public boolean isSelected(int x, int y){
		if(gp.intersects((double)x-5, (double)y-5, (double)10, (double)10))
		{
			return true;
		}else{
			return false;
		}
		
	}
	
	public boolean contains(float x, float y) {
		if(this.gp.contains(x,y)){
			return true;
		}else{
			return false;
		}
	}
	
	
	public Point getStartPoint(){
		Point r = new Point();
		r.x = (int)gp.getCurrentPoint().getX();
		r.y = (int)gp.getCurrentPoint().getY();
		return r;
	}
	
	public void move(int x, int y){
		AffineTransform Tx = AffineTransform.getTranslateInstance(
				x, y);
		gp.transform(Tx);
		rect.translate(x, y);
	}
	
	
	
	
	
	public void paint(Graphics2D g){
		g.setColor(Color.white);
		g.draw(gp);
		g.setColor(Color.black);
		if(this.isComplete == false){
			g.setColor(Color.white);
			g.fill(rect);
			g.setColor(Color.black);
			g.draw(this.rect);
		}
		
		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g.setStroke(new BasicStroke(1,0,BasicStroke.JOIN_MITER,1.0f,dash, 0));
		if(this.isSelected() == true){
			g.setColor(Color.white);
			g.fill(rect);
			g.setColor(Color.black);
			g.draw(this.rect);
		}
		g.draw(gp);
	}
	
	
	public Shape getShape(){
		return this.gp;
	}
	
}

