package ShapeSelect;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.AffineTransform;

import utils.DrawableInformation;

public class ElementSelectRect extends ParentSelect{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public Rectangle rect;
	AffineTransform saveAt;
	float[] dash=new float[]{10,5,5,5};
	
	public ElementSelectRect(Rectangle rect){
		this.rect = rect;
	}
	public ElementSelectRect(	DrawableInformation information){
		this.information = information;
	}
	public void setRect(Rectangle rect){
		this.rect = rect;
	}
	public Point getStartPoint(){
		return new Point(this.rect.x,this.rect.y);
	}

	public int getHeight(){
		return this.rect.height;
	}
	public int getWidth(){
		return this.rect.width;
	}
	public void setHeight(int height){
		this.rect.height =height;
	}
	public void setWidth(int width){
		this.rect.width = width;
	}
	public void setResizePosition(Rectangle rect){
		this.rect.x = rect.x;
		this.rect.y = rect.y;
		this.rect.width = rect.width;
		this.rect.height = rect.height;
	}
	public void move(int x, int y){
		rect.translate(x, y);
		//rect.setLocation(new Point(x,y));
	}
	public boolean isSelected(int x, int y){
		Rectangle r = new Rectangle(x-5,y-5,10,10);
		if(this.rect.intersects(r)){
			return true;
		}else{
			return false;
		}
				
	}
	public boolean contains(float x, float y) {
		if(this.rect.contains(x,y)){
			return true;
		}else{
			return false;
		}
	}
	
	
	
	public void paint(Graphics2D g){
		//this.information.setGraphicAttribute(g);
		
		
		if(this.isSelected()){
			g.setStroke(new BasicStroke(1,0,BasicStroke.JOIN_MITER,1.0f,dash, 0));
			g.setColor(Color.black);
			g.draw(this.rect);
			g.setColor(Color.white);
			g.fillRect(this.rect.x -4, this.rect.y -4, 7,7);
			g.fillRect(this.rect.x -4, this.rect.y+rect.height -4, 7, 7);
			g.fillRect(this.rect.x +rect.width-4, this.rect.y -4, 7, 7);
			g.fillRect(this.rect.x+rect.width -4, this.rect.y+rect.height -4, 7, 7);
			g.setColor(Color.black);
			g.setStroke(new BasicStroke(1,0, 0));
			g.drawRect(this.rect.x -4, this.rect.y -4, 7,7);
			g.drawRect(this.rect.x -4, this.rect.y+rect.height -4, 7, 7);
			g.drawRect(this.rect.x +rect.width-4, this.rect.y -4, 7, 7);
			g.drawRect(this.rect.x+rect.width -4, this.rect.y+rect.height -4, 7, 7);
			
			
		}else{
			g.setColor(Color.black);
			g.setStroke(new BasicStroke(1,0,BasicStroke.JOIN_MITER,1.0f,dash, 0));
			g.draw(this.rect);
		}
	
		
	}

	public Shape getShape(){
		return this.rect;
	}
	
}
