package Shapes;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.RenderingHints;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.util.Vector;

import Layers.Layer;
import utils.DrawableInformation;

public class ElementBursh_k1 extends ParentElement{
	private static final long serialVersionUID = 1L;
	private Vector<Point> vector = new Vector<Point>();
	
	public ElementBursh_k1(DrawableInformation information ,Layer layer){
		this.information =information;
		this.layer = layer;
	}
	public boolean contains(float x, float y) {
		// TODO Auto-generated method stub
		return false;
	}
	public void addPath(Point p){
		this.vector.add(p);
	}
	public Shape getShape(){
		return null;
	}
	public void samllPaint(Graphics2D g){
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		if(this.information.getCanvasSize().y<40){
			float broad = (float)(this.vector.size() /3);
	    	
	    	for(int i=1;i<vector.size();i++){
	    		if(i<=broad){
	    			g.setColor(Color.black);
	    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
	    			g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
	    		
	    		}else if(i>broad){
	    			
	    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
	        		g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
	    		}
	    	}
		}else{
			float rate = (float)this.information.getCanvasSize().y /(float)40;
			g.scale(1/rate, 1/rate);
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
					RenderingHints.VALUE_ANTIALIAS_ON);

			float broad = (float)(this.vector.size() /3);
	    	
	    	for(int i=1;i<vector.size();i++){
	    		if(i<=broad){
	    			g.setColor(Color.black);
	    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
	    			g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
	    		
	    		}else if(i>broad){
	    			
	    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
	        		g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
	    		}
	    	}
			g.setTransform(saveAt);
		}
	}
	
	public void middlePaint(Graphics2D g){
		this.information.setGraphicAttribute(g);
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		if(this.information.getCanvasSize().y<150){
			this.information.setGraphicAttribute(g);
			
			if(information.getGradation()){
				GradientPaint grad;
		  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
		  				information.lineColor,information.getGradEnd().x,
		  				information.getGradEnd().y ,information.fillColor, false);
		  		
		  		g.setPaint(grad);
		  		float broad = (float)(this.vector.size() /3);
		    	
		    	for(int i=1;i<vector.size();i++){
		    		if(i<=broad){
		    			g.setColor(Color.black);
		    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
		    			g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
		    		
		    		}else if(i>broad){
		    			
		    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
		        		g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
		    		}
		    	}
			}else{
				g.setColor(this.information.getLineColor());
				float broad = (float)(this.vector.size() /3);
		    	
		    	for(int i=1;i<vector.size();i++){
		    		if(i<=broad){
		    			g.setColor(Color.black);
		    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
		    			g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
		    		
		    		}else if(i>broad){
		    			
		    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
		        		g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
		    		}
		    	}
			}
		}else{
			float rate = (float)this.information.getCanvasSize().y /(float)150;
			g.scale(1/rate, 1/rate);
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
					RenderingHints.VALUE_ANTIALIAS_ON);
			this.information.setGraphicAttribute(g);
			
			if(information.getGradation()){
				GradientPaint grad;
		  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
		  				information.lineColor,information.getGradEnd().x,
		  				information.getGradEnd().y ,information.fillColor, false);
		  		
		  		g.setPaint(grad);
		  		float broad = (float)(this.vector.size() /3);
		    	
		    	for(int i=1;i<vector.size();i++){
		    		if(i<=broad){
		    			g.setColor(Color.black);
		    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
		    			g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
		    		
		    		}else if(i>broad){
		    			
		    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
		        		g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
		    		}
		    	}
			}else{
				g.setColor(this.information.getLineColor());
				
				float broad = (float)(this.vector.size() /3);
		    	
		    	for(int i=1;i<vector.size();i++){
		    		if(i<=broad){
		    			g.setColor(Color.black);
		    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
		    			g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
		    		
		    		}else if(i>broad){
		    			
		    			g.setStroke(new BasicStroke(3,1,BasicStroke.JOIN_ROUND));
		        		g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
		    		}
		    	}
			}
			g.setTransform(saveAt);
		}
	}
	public void paint(Graphics2D g) {
		this.information.setGraphicAttribute(g);
		
		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 
				this.information.opacity);
		g.setComposite(ac);
		g.setColor(this.information.getLineColor());
		if(this.information.getGradation()){
			GradientPaint grad;
	  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
	  				information.lineColor,information.getGradEnd().x,
	  				information.getGradEnd().y ,information.fillColor, false);
	  		
	  		g.setPaint(grad);
		}
		float broad = (float)(this.vector.size() /3);
    	float thickness;
    	for(int i=1;i<vector.size();i++){
    		if(i<=broad){
    			
    			thickness = 13+ ((float)i*12/broad);
    			g.setStroke(new BasicStroke(thickness,1,BasicStroke.JOIN_ROUND));
    			g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
    		
    		}else if(i>broad){
    			thickness =  ((float)25 - ((float)i-(float)broad)*((float)25/((float)vector.size() - (float)broad)));
    			g.setStroke(new BasicStroke(thickness,1,BasicStroke.JOIN_ROUND));
        		g.drawLine(vector.elementAt(i-1).x,vector.elementAt(i-1).y,vector.elementAt(i).x,vector.elementAt(i).y);
    		}
    	}
    	
    	
		
	}

	
	
}
