package Shapes;


import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.RenderingHints;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.GeneralPath;

import Layers.Layer;

import utils.DrawableInformation;

public class ElementEraser extends ParentElement{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private GeneralPath gp = null;
	float[] dash=new float[]{10,5,5,5};
	
	public ElementEraser(DrawableInformation information ,Layer layer){
		this.information =information;
		this.layer = layer;
	}
	
	public void setGeneralPath(GeneralPath gp){
		this.gp = gp;
	}
	public boolean isSelected(int x, int y){
		if(gp.intersects((double)x-5, (double)y-5, (double)10, (double)10))
		{
			return true;
		}else{
			return false;
		}
		
	}
	public Shape getShape(){
		return gp;
	}
	public boolean contains(float x, float y) {
		if(this.gp.contains(x,y)){
			return true;
		}else{
			return false;
		}
	}
	
	
	public Point getStartPoint(){
		Point r = new Point();
		r.x = (int)gp.getCurrentPoint().getX();
		r.y = (int)gp.getCurrentPoint().getY();
		return r;
	}
	
	public void move(int x, int y){
		AffineTransform Tx = AffineTransform.getTranslateInstance(
				x, y);
		gp.transform(Tx);
	}
	
	public void samllPaint(Graphics2D g){
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		
		if(this.information.getCanvasSize().y<40){
			g.draw(gp);
			
		}else{
			float rate = (float)this.information.getCanvasSize().y /(float)40;
			g.scale(1/rate, 1/rate);
			
			g.setColor(Color.white);
			g.setStroke(new BasicStroke(20,1,1));
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
					RenderingHints.VALUE_ANTIALIAS_ON);
			g.draw(gp);
			g.setTransform(saveAt);
		}
	}
	
	public void middlePaint(Graphics2D g){
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		
		if(this.information.getCanvasSize().y<150){
			g.draw(gp);
		}else{
			float rate = (float)this.information.getCanvasSize().y /(float)150;
			g.scale(1/rate, 1/rate);
			g.setColor(Color.white);
			
			g.setStroke(new BasicStroke(20,1,1));
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
					RenderingHints.VALUE_ANTIALIAS_ON);
			g.draw(gp);
			g.setTransform(saveAt);
		}
	}
	
	public void paint(Graphics2D g){
		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
			               RenderingHints.VALUE_ANTIALIAS_ON);
		g.setColor(Color.white);
		g.setStroke(new BasicStroke(20,1,1));
		if(this.isSelected()){
			g.setColor(Color.pink);
			g.draw(gp);
			g.setColor(Color.white);
		}else{
			g.draw(gp);
		}
		
		
		
		
	}

	
}
