package Shapes;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.RenderingHints;
import java.awt.Shape;
import java.awt.font.TextLayout;
import java.awt.geom.AffineTransform;
import java.awt.geom.Area;
import java.util.Vector;

import Layers.Layer;

import utils.DrawableInformation;

public class ElementFont extends ParentElement{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	@SuppressWarnings("unused")
	private Font font;
	private RenderingHints antiRender;
	@SuppressWarnings("unused")
	private Vector<TextLayout> tm;
	private Vector<Shape> sm;
	Area area ;
	public ElementFont(DrawableInformation information,Font font,Vector<TextLayout> tm ,Layer layer){
		this.information = information;
		this.font = font;
		this.tm = tm;
		antiRender = new RenderingHints(RenderingHints.KEY_ANTIALIASING,
				RenderingHints.VALUE_ANTIALIAS_ON);
		this.layer = layer;
	}
	public Shape getShape(){
		area = new Area(this.sm.elementAt(0).getBounds());
		for(int i= 0;i<sm.size();i++){
			area.add(new Area(this.sm.elementAt(i).getBounds()));
		}
		
		return area;
	}
	public boolean isSelected(int x, int y){
		area = new Area(this.sm.elementAt(0).getBounds());
		for(int i= 0;i<sm.size();i++){
			area.add(new Area(this.sm.elementAt(i).getBounds()));
		}
		if(area.getBounds().contains(new Point((int)x,(int)y))){
			return true;
		}else{
			return false;
		}
	}
	public boolean contains(float x, float y) {
		/*for(int i =0;i<sm.size();i++){
			//System.out.println(i+"sm :"+sm.elementAt(i).getBounds());
			//System.out.println(i+"tm :"+tm.elementAt(i).getBounds());
			if(sm.elementAt(i).contains(x,y)){
				return true;
			}
		}*/
		area = new Area(this.sm.elementAt(0).getBounds());
		for(int i= 0;i<sm.size();i++){
			area.add(new Area(this.sm.elementAt(i).getBounds()));
		}
		if(area.getBounds().contains(new Point((int)x,(int)y))){
			return true;
		}else{
			return false;
		}
		
		
	}
	
	public void setShape(Vector<Shape> sm){
		this.sm = sm;
	}
	
	public Point getStartPoint(){
		
		//Point r = new Point();
		//r.x = (int)gp.getCurrentPoint().getX();
		//r.y = (int)gp.getCurrentPoint().getY();
		return null;
	}
	public void samllPaint(Graphics2D g){
		
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		if(this.information.getCanvasSize().y<40){
			for(int i=0;i<sm.size();i++){
				g.fill(sm.elementAt(i));
			}
		}else{
			float rate = (float)this.information.getCanvasSize().y /(float)40;
			g.scale(1/rate, 1/rate);
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
					RenderingHints.VALUE_ANTIALIAS_ON);
			g.setColor(Color.black);
			for(int i=0;i<sm.size();i++){
				g.fill(sm.elementAt(i));
			}
			g.setTransform(saveAt);
		}
	}
	
	public void middlePaint(Graphics2D g){
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		if(this.information.getCanvasSize().y<150){
			for(int i=0;i<sm.size();i++){
				g.fill(sm.elementAt(i));
			}
		}else{
			float rate = (float)this.information.getCanvasSize().y /(float)150;
			g.scale(1/rate, 1/rate);
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
					RenderingHints.VALUE_ANTIALIAS_ON);
			for(int i=0;i<sm.size();i++){
				g.fill(sm.elementAt(i));
			}
			g.setTransform(saveAt);
		}
	}
	
	public void paint(Graphics2D g) {
		this.information.setGraphicAttribute(g);
		AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 
				this.information.opacity);
		g.setComposite(ac);
		g.setRenderingHints(antiRender);
		for(int i=0;i<sm.size();i++){
			g.fill(sm.elementAt(i));
		}
		if(this.isSelected()){
			g.draw(area);
		}
	}
	
	

}
