package Shapes;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.GradientPaint;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.TexturePaint;
import java.awt.geom.AffineTransform;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Rectangle2D;

import Layers.Layer;

import utils.DrawableInformation;

public class ElementOval extends ParentElement{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public Ellipse2D.Double ellipse;
	
	public ElementOval(Ellipse2D.Double ellipse){
		this.ellipse = ellipse;
	}
	public ElementOval(DrawableInformation information ,Layer layer){
		this.information = information;
		this.layer = layer;
		
	}
	public void setOval(Ellipse2D.Double ellipse){
		this.ellipse = ellipse;
	}
	public Shape getShape(){
		return this.ellipse;
	}
	public Point getStartPoint(){
		return new Point((int)this.ellipse.x,(int)this.ellipse.y);
	}

	public int getHeight(){
		return (int)this.ellipse.height;
	}
	public int getWidth(){
		return (int)this.ellipse.width;
	}
	public void setHeight(int height){
		this.ellipse.height =height;
	}
	public void setWidth(int width){
		this.ellipse.width = width;
	}
	public void setResizePosition(Rectangle rect){
		this.ellipse.x = rect.x;
		this.ellipse.y = rect.y;
		this.ellipse.width = rect.width;
		this.ellipse.height = rect.height;
	}
	public void move(int x, int y){
		ellipse.x = ellipse.x + x;
		ellipse.y = ellipse.y + y;
	}
	public boolean isSelected(int x, int y){
		if(ellipse.intersects((double)x-5, (double)y-5, (double)10, (double)10))
		{
			return true;
		}else{
			return false;
		}
		
	}

	public boolean contains(float x, float y) {
		if(this.ellipse.contains(x,y)){
			return true;
		}else{
			return false;
		}
	}
	public void samllPaint(Graphics2D g){
		int ellipsex = (int)ellipse.x;
		int ellipsey = (int)ellipse.y;
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		if(this.information.getCanvasSize().y<40){
			if(information.isRoatated == true){
				g.translate(this.centerX, this.centerY);
				g.rotate(Math.toRadians(this.information.getRotationTheta()));
				ellipse.x = -ellipse.width/2;
				ellipse.y = -ellipse.height/2;
			}
			g.draw(ellipse);
		}else{
			float rate = (float)this.information.getCanvasSize().y /(float)40;
			if(information.isRoatated == true){
				g.translate(this.centerX/rate, this.centerY/rate);
				g.rotate(Math.toRadians(this.information.getRotationTheta()));
				ellipse.x = -ellipse.width/2;
				ellipse.y = -ellipse.height/2;
			}
			g.scale(1/rate, 1/rate);
			g.draw(ellipse);
			
		}
		if(information.isRoatated == true){
			ellipse.x = ellipsex;
			ellipse.y = ellipsey;
		}
		g.setTransform(saveAt);
	}
	
	public void middlePaint(Graphics2D g){
		int ellipsex = (int)ellipse.x;
		int ellipsey = (int)ellipse.y;
		this.information.setGraphicAttribute(g);
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		if(this.information.getCanvasSize().y<150){
			if(information.isRoatated == true){
				g.translate(this.centerX, this.centerY);
				g.rotate(Math.toRadians(this.information.getRotationTheta()));
				ellipse.x = -ellipse.width/2;
				ellipse.y = -ellipse.height/2;
			}
			g.draw(ellipse);
			if(this.information.isFilled){
				g.setColor(this.information.getFillColor());
				g.fill(this.ellipse);
			}else{
				if(information.getGradation()){
					GradientPaint grad;
			  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
			  				information.lineColor,information.getGradEnd().x,
			  				information.getGradEnd().y ,information.fillColor, false);
			  		System.out.println(information.getGradStart().x+information.getGradStart().y+information.getGradEnd().x+information.getGradEnd().y);
			  		g.setPaint(grad);
				}
				g.draw(this.ellipse);
			}
		}else{
			float rate = (float)this.information.getCanvasSize().y /(float)150;
			if(information.isRoatated == true){
				g.translate(this.centerX/rate, this.centerY/rate);
				g.rotate(Math.toRadians(this.information.getRotationTheta()));
				ellipse.x = -ellipse.width/2;
				ellipse.y = -ellipse.height/2;
			}
			g.scale(1/rate, 1/rate);
			g.draw(ellipse);
			if(this.information.isFilled){
				if(information.getGradation()){
					GradientPaint grad;
			  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
			  				information.lineColor,information.getGradEnd().x,
			  				information.getGradEnd().y ,information.fillColor, false);
			  		System.out.println(information.getGradStart().x+information.getGradStart().y+information.getGradEnd().x+information.getGradEnd().y);
			  		g.setPaint(grad);
					g.fill(ellipse);
				}else{
					g.setColor(this.information.getFillColor());
					g.fill(this.ellipse);
				}
			}else{
				if(information.getGradation()){
					GradientPaint grad;
			  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
			  				information.lineColor,information.getGradEnd().x,
			  				information.getGradEnd().y ,information.fillColor, false);
			  		System.out.println(information.getGradStart().x+information.getGradStart().y+information.getGradEnd().x+information.getGradEnd().y);
			  		g.setPaint(grad);
				}
				g.draw(this.ellipse);
			}
			
		}
		if(information.isRoatated == true){
			ellipse.x = ellipsex;
			ellipse.y = ellipsey;
		}
		g.setTransform(saveAt);
	}
	
	public void paint(Graphics2D g){
		this.information.setGraphicAttribute(g);
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 
				this.information.opacity);
		g.setComposite(ac);
		if(information.isRoatated == true){
			this.centerX= (int)ellipse.getCenterX();
			this.centerY = (int)ellipse.getCenterY();
			g.translate(this.centerX, this.centerY);
			g.rotate(Math.toRadians(this.information.getRotationTheta()));
			ellipse.x = -ellipse.width/2;
			ellipse.y = -ellipse.height/2;
		}
		
		if(this.isSelected()){
			//g.setColor(Color.black);
			g.setStroke(new BasicStroke(1,0,BasicStroke.JOIN_MITER,1.0f,dash, 0));
			g.drawOval((int)this.ellipse.x-1,(int)this.ellipse.y-1,(int)this.ellipse.width+2,(int)this.ellipse.height+2);
			g.setStroke(new BasicStroke(this.information.strokeSize,1,0));
			//g.setColor(this.information.lineColor);
		}else{
			g.draw(this.ellipse);
		}
		if(this.information.isFilled){
			if(information.getGradation()){
				AlphaComposite c = AlphaComposite.getInstance(
						AlphaComposite.SRC_OVER, this.information.gradOpacity);
				g.setComposite(c);
				
				if(this.information.gradTheta !=0) {
					g.clip(this.ellipse);
					float cross = (float) ((ellipse.width)*(ellipse.width) + (ellipse.height)*(ellipse.height));
					int result = (int)Math.sqrt(cross);
					Rectangle rect2 = new Rectangle( (int)(- result/2) , (int)(- result /2) ,result,result);
					AffineTransform at2 = new AffineTransform();	
					AffineTransform saveform = g.getTransform();		
					at2.setToTranslation(ellipse.x + ellipse.width/2, ellipse.y + ellipse.height/2);
					at2.rotate(Math.toRadians(this.information.gradTheta)); 
					g.transform(at2); 
					GradientPaint grad;
			  		grad=new GradientPaint( rect2.x , rect2.y,
			  				information.lineColor,rect2.x+rect2.width,
			  				rect2.y + rect2.height ,information.fillColor, false);
			  		g.setPaint(grad);
			  		g.fill(rect2);
			  		
			  		g.setTransform(saveform);
			  		g.setClip(null);
				}else{
					GradientPaint grad;
			  		grad=new GradientPaint((int) ellipse.x, (int)ellipse.y,
			  				information.lineColor,(int)ellipse.x+(int)ellipse.width,
			  				(int)ellipse.y+(int)ellipse.height ,information.fillColor, false);
			  		g.setPaint(grad);
					g.fill(ellipse);
				}
				if(this.information.getTexture()){
					if(this.texture != null){
						TexturePaint tpaint = new TexturePaint(this.texture, new Rectangle2D.Float(10,10,50,50));
						g.setPaint(tpaint);
						g.fill(ellipse);
					}
				}
			}else{
				g.setColor(this.information.getFillColor());
				g.fill(this.ellipse);
				if(this.information.getTexture()){
					if(this.texture != null){
						TexturePaint tpaint = new TexturePaint(this.texture, new Rectangle2D.Float(10,10,50,50));
						g.setPaint(tpaint);
						g.fill(ellipse);
					}
				}
			}
		}else{
			if(information.getGradation()){
				GradientPaint grad;
		  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
		  				information.lineColor,information.getGradEnd().x,
		  				information.getGradEnd().y ,information.fillColor, false);
		  		System.out.println(information.getGradStart().x+information.getGradStart().y+information.getGradEnd().x+information.getGradEnd().y);
		  		g.setPaint(grad);
			}
			g.draw(this.ellipse);
			if(this.information.getTexture()){
				if(this.texture != null){
					TexturePaint tpaint = new TexturePaint(this.texture, new Rectangle2D.Float(10,10,50,50));
					g.setPaint(tpaint);
					g.draw(this.ellipse);
				}
			}
		}
		if(information.isRoatated == true){
			ellipse.x = this.centerX-ellipse.width/2;
			ellipse.y = this.centerY-ellipse.height/2;
		}
		g.setTransform(saveAt);
	}

	public void setRoatatePositoin(){
		
	}
}
