package Shapes;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.GradientPaint;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.TexturePaint;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;

import Layers.Layer;

import utils.DrawableInformation;

public class ElementRect extends ParentElement{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public Rectangle rect;
	AffineTransform saveAt;
	public ElementRect(Rectangle rect){
		this.rect = rect;
	}
	public Shape getShape(){
		return this.rect;
	}
	public ElementRect(	DrawableInformation information ,Layer layer){
		this.information = information;
		this.layer = layer;
	}
	public void setRect(Rectangle rect){
		this.rect = rect;
	}
	public Point getStartPoint(){
		return new Point(this.rect.x,this.rect.y);
	}

	public int getHeight(){
		return this.rect.height;
	}
	public int getWidth(){
		return this.rect.width;
	}
	public void setHeight(int height){
		this.rect.height =height;
	}
	public void setWidth(int width){
		this.rect.width = width;
	}
	public void setResizePosition(Rectangle rect){
		this.rect.x = rect.x;
		this.rect.y = rect.y;
		this.rect.width = rect.width;
		this.rect.height = rect.height;
	}
	public void move(int x, int y){
		rect.translate(x, y);
		//rect.setLocation(new Point(x,y));
	}
	public boolean isSelected(int x, int y){
		Rectangle r = new Rectangle(x-5,y-5,10,10);
		if(this.rect.intersects(r)){
			return true;
		}else{
			return false;
		}
				
	}
	public boolean contains(float x, float y) {
		if(this.rect.contains(x,y)){
			return true;
		}else{
			return false;
		}
	}
	
	public void samllPaint(Graphics2D g){
		int rectx = rect.x;
		int recty = rect.y;
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		
		if(this.information.getCanvasSize().y<40){
			if(information.isRoatated == true){
				g.translate(this.centerX, this.centerY);
				g.rotate(Math.toRadians(this.information.getRotationTheta()));
				rect.x = -rect.width/2;
				rect.y = -rect.height/2;
			}
			g.draw(rect);
		}else{
			float rate = (float)this.information.getCanvasSize().y /(float)40;
			if(information.isRoatated == true){
				g.translate(this.centerX/rate, this.centerY/rate);
				g.rotate(Math.toRadians(this.information.getRotationTheta()));
				rect.x = -rect.width/2;
				rect.y = -rect.height/2;
			}
			g.scale(1/rate, 1/rate);
			g.draw(rect);
			
		}
		if(information.isRoatated == true){
			rect.x = rectx;
			rect.y = recty;
		}
		g.setTransform(saveAt);
	}
	
	public void middlePaint(Graphics2D g){
		int rectx = rect.x;
		int recty = rect.y;
		this.information.setGraphicAttribute(g);
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		if(this.information.getCanvasSize().y<150){
			if(information.isRoatated == true){
				g.translate(this.centerX, this.centerY);
				g.rotate(Math.toRadians(this.information.getRotationTheta()));
				rect.x = -rect.width/2;
				rect.y = -rect.height/2;
			}
			g.draw(rect);
			if(this.information.isFilled){
				if(information.getGradation()){
					GradientPaint grad;
			  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
			  				information.lineColor,information.getGradEnd().x,
			  				information.getGradEnd().y ,information.fillColor, false);
			  		g.setPaint(grad);
					g.fill(rect);
				}else{
					g.setColor(this.information.getFillColor());
					g.fill(this.rect);
				}
			}else{
				if(information.getGradation()){
					GradientPaint grad;
			  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
			  				information.lineColor,information.getGradEnd().x,
			  				information.getGradEnd().y ,information.fillColor, false);
			  		
			  		g.setPaint(grad);
				}
				g.draw(this.rect);
			}
		}else{
			
			float rate = (float)this.information.getCanvasSize().y /(float)150;
			if(information.isRoatated == true){
				g.translate(this.centerX/rate, this.centerY/rate);
				g.rotate(Math.toRadians(this.information.getRotationTheta()));
				rect.x = -rect.width/2;
				rect.y = -rect.height/2;
			}
			g.scale(1/rate, 1/rate);
			
			g.draw(rect);
			if(this.information.isFilled){
				if(information.getGradation()){
					GradientPaint grad;
			  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
			  				information.lineColor,information.getGradEnd().x,
			  				information.getGradEnd().y ,information.fillColor, false);
			  		
			  		g.setPaint(grad);
					g.fill(rect);
					
				}else{
					g.setColor(this.information.getFillColor());
					g.fill(this.rect);
				}
			}else{
				if(information.getGradation()){
					GradientPaint grad;
			  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
			  				information.lineColor,information.getGradEnd().x,
			  				information.getGradEnd().y ,information.fillColor, false);
			  		
			  		g.setPaint(grad);
				}
				g.draw(this.rect);
			}
			
		}
		if(information.isRoatated == true){
			rect.x = rectx;
			rect.y = recty;
		}
		g.setTransform(saveAt);
	}
	
	public void paint(Graphics2D g){
		
		this.information.setGraphicAttribute(g);
		
		/**/
		AffineTransform at= g.getTransform();
		AffineTransform saveAt = (AffineTransform) at.clone();
		//g.setComposite(new AlphaComposite(AlphaComposite.SRC_OVER,this.information.opacity));
		AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 
				this.information.opacity);
		g.setComposite(ac);
		if(information.isRoatated == true){
			this.centerX= (int)rect.getCenterX();
			this.centerY = (int)rect.getCenterY();
			g.translate(this.centerX, this.centerY);
			g.rotate(Math.toRadians(this.information.getRotationTheta()));
			rect.x = -rect.width/2;
			rect.y = -rect.height/2;
		}
		if(this.isSelected()){
			//g.setColor(Color.black);
			g.setStroke(new BasicStroke(1,0,BasicStroke.JOIN_MITER,1.0f,dash, 0));
			g.drawRect(this.rect.x-1, this.rect.y-1,this.rect.width+2,this.rect.height+2);
			g.setStroke(new BasicStroke(this.information.strokeSize,1,0));
			//g.setColor(this.information.lineColor);
		}else{
			g.draw(this.rect);
		}
		if(this.information.isFilled){
			if(information.getGradation()){
						
				AlphaComposite c = AlphaComposite.getInstance(
						AlphaComposite.SRC_OVER, this.information.gradOpacity);
				g.setComposite(c);
				
				if(this.information.gradTheta !=0) {
					g.clip(this.rect);
					float cross = (rect.width)*(rect.width) + (rect.height)*(rect.height);
					int result = (int)Math.sqrt(cross);
					Rectangle rect2 = new Rectangle( (int)(- result/2) , (int)(- result /2) ,result,result);
					AffineTransform at2 = new AffineTransform();	
					AffineTransform saveform = g.getTransform();		
					at2.setToTranslation(rect.x + rect.width/2, rect.y + rect.height/2);
					at2.rotate(Math.toRadians(this.information.gradTheta)); 
					g.transform(at2); 
					GradientPaint grad;
			  		grad=new GradientPaint( rect2.x , rect2.y,
			  				information.lineColor,rect2.x+rect2.width,
			  				rect2.y + rect2.height ,information.fillColor, false);
			  		g.setPaint(grad);
			  		g.fill(rect2);
			  		
			  		g.setTransform(saveform);
			  		g.setClip(null);
				}else{
					GradientPaint grad;
			  		grad=new GradientPaint( rect.x, rect.y,
			  				information.lineColor,rect.x+rect.width,
			  				rect.y+rect.height ,information.fillColor, false);
			  		g.setPaint(grad);
					g.fill(rect);
				}
				
				if(this.information.getTexture()){
					if(this.texture != null){
						TexturePaint tpaint = new TexturePaint(this.texture, new Rectangle2D.Float(10,10,50,50));
						g.setPaint(tpaint);
						g.fill(rect);
					}
				}
				
			}else{
				g.setColor(this.information.getFillColor());
				g.fill(this.rect);
				if(this.information.getTexture()){
					if(this.texture != null){
						TexturePaint tpaint = new TexturePaint(this.texture, new Rectangle2D.Float(10,10,50,50));
						g.setPaint(tpaint);
						g.fill(rect);
					}
				}
			}
		}else{
			if(information.getGradation()){
				GradientPaint grad;
		  		grad=new GradientPaint(information.getGradStart().x, information.getGradStart().y,
		  				information.lineColor,information.getGradEnd().x,
		  				information.getGradEnd().y ,information.fillColor, false);
		  		
		  		g.setPaint(grad);
			}
			
			g.draw(this.rect);
			if(this.information.getTexture()){
				if(this.texture != null){
					TexturePaint tpaint = new TexturePaint(this.texture, new Rectangle2D.Float(10,10,50,50));
					g.setPaint(tpaint);
					g.draw(rect);
				}
			}
		}
		if(information.isRoatated == true){
			rect.x = this.centerX-rect.width/2;
			rect.y = this.centerY-rect.height/2;
		}
	
		g.setTransform(saveAt);
		
	}

	public void setRoatatePositoin(){
		if(this.setRoatatecount == 0){
			//this.centerX = (int)rect.getCenterX();
			//this.centerY = (int)rect.getCenterY();
		}
		setRoatatecount++;
	}
	
}
