package Shapes;

import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.image.BufferedImage;
import java.io.Serializable;

import Layers.Layer;

import utils.DrawStateSingleton;
import utils.DrawableInformation;

public abstract class ParentElement implements Serializable{
	private static final long serialVersionUID = 1L;
	
	protected Point startPoint ,endPoint;
	protected int StrokeSize=1 ;
	protected int width,height ;
	protected boolean antiAlias = true;
	public boolean isVisible = true;
	int setRoatatecount = 0;
	int centerX, centerY;
	public DrawableInformation information;
	protected boolean selected;
	public boolean isComplete= false;
	public Layer layer;
	float[] dash=new float[]{10,5,5,5};
	public BufferedImage texture;
	public ParentElement(){
		this.information = new DrawableInformation(DrawStateSingleton.getInstance().getDrawableInformation());
		startPoint = new Point();
		endPoint = new Point();
		
	}
	
	public ParentElement(DrawableInformation information) {
		this.information = new DrawableInformation(information);
		selected = true;
	}
	public void setLayer(Layer layer){
		this.layer = layer;
	}

	public Layer getLayer(){
		return this.layer;
	}
	public void setVisible(boolean visible){
		isVisible = visible;
	}
	
	public boolean isVisible(){
		return isVisible;
	}
	

	
	public boolean isSelected(int x, int y){
		return false;
	}
	public void setStartPoint(Point _stpoint){
		this.startPoint = (Point)_stpoint;
	}
	
	public void setEndPoint(Point _endpoint){
		this.endPoint = (Point)_endpoint;
	}
	public Point getStartPoint(){
		return this.startPoint;
	}
	
	public Point getEndPoint(){
		return this.endPoint ;
	}
	
	public void setWidth(int width){
		this.width = width;
	}

	public int getHeight(){
		return this.height;
	}
	public int getWidth(){
		return this.width;
	}

	public void setHeight(int height){
		this.height = height;
	}

	
	public void setResizePosition(Rectangle rect){
		
	}
	
	public abstract void paint(Graphics2D g);
	
	public void samllPaint(Graphics2D g){
		
	}

	public void middlePaint(Graphics2D g){
		
	}
	
	
	public void setSelect(boolean selected){
		this.selected = selected;
	}
	public boolean isSelected(){
		return this.selected;
	}
	public void finishDraw(){
		this.setSelect(false);
	}
	public void resize(Rectangle rect){
		
	}
	public void move(int x, int y){
		
	}
	
	public void setRoatatePositoin(){
		
	}
	public Shape getShape(){
		return null;
	}
	public abstract boolean contains(float x, float y);
}
