package ToolSelect;

import java.awt.Point;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.GeneralPath;
import panels.CanvasPanel;
import utils.DrawStateSingleton;
import ShapeSelect.ElementSelectPen;




public class ToolStatePencilSelect extends ToolSelectAbstract{
	private GeneralPath gp;

	public ToolStatePencilSelect(CanvasPanel panel) {
		this.canvasPanel = panel;
	}

	public void mousePressed(MouseEvent e){
		if(this.drawable == null && e.getModifiers() != InputEvent.META_MASK){
			this.drawable = new ElementSelectPen(DrawStateSingleton.getInstance()
						.getDrawableInformation()) ;
			gp = new GeneralPath();
			gp.moveTo(e.getX(), e.getY());
			((ElementSelectPen)drawable).setGeneralPath(gp);
			((ElementSelectPen)drawable).rect.x = e.getX()-2;
			((ElementSelectPen)drawable).rect.y = e.getY() - 2;
			this.canvasPanel.selectVector.add(drawable);
		}
	}
	
	public void mouseDragged(MouseEvent e) {
		
		if(this.drawable != null && e.getModifiers() != InputEvent.META_MASK){
			
			gp.lineTo(e.getX(), e.getY());
			canvasPanel.repaint();
		}
	}
	
	public void mouseReleased(MouseEvent e) {
		if(this.drawable != null && e.getModifiers() != InputEvent.META_MASK){
		if(((ElementSelectPen)drawable).rect.contains(new Point(e.getX(),e.getY()))){
			gp.closePath();
			gp = null;
			((ElementSelectPen)drawable).isComplete = true;
			canvasPanel.repaint();
			drawable = null;
			
		}
		}
		
	}

	
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseMoved(MouseEvent e) {}

}
