package ToolSelect;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;

import panels.CanvasPanel;
import utils.DrawStateSingleton;
import ShapeSelect.ElementSelectRect;


public class ToolStateSelectRect  extends ToolSelectAbstract{

	private Rectangle rect;
	private Point startPoint;
	
	
	public ToolStateSelectRect(CanvasPanel panel){
		this.canvasPanel = panel;
		this.startPoint = new Point();
	}
	
	public void mousePressed(MouseEvent e) {	
		if(e.getModifiers() != InputEvent.META_MASK){
		if(drawable == null){
			drawable = new ElementSelectRect(DrawStateSingleton.getInstance()
					.getDrawableInformation());
			drawable.information.setGraphicAttribute(canvasPanel.gback);
			rect = new Rectangle(0,0,0,0);
			((ElementSelectRect)drawable).setRect(rect);
			canvasPanel.selectVector.add(drawable);
			
		}
	
		
		this.startPoint.x = e.getX();
		this.startPoint.y = e.getY();
	
		}
	}
	public void mouseDragged(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		int width = e.getX() - startPoint.x;
        int height = e.getY() - startPoint.y;
        int tmpX = startPoint.x;
        int tmpY = startPoint.y;
        
	    if(width < 0) { width = -width; tmpX = e.getX();}
		if(height < 0) {height = -height;tmpY = e.getY();}
        
		((ElementSelectRect)drawable).rect.x = tmpX;
		((ElementSelectRect)drawable).rect.y = tmpY;
		((ElementSelectRect)drawable).rect.width = width;
		((ElementSelectRect)drawable).rect.height = height;
		
		
		canvasPanel.repaint();
		}
	}
	public void mouseReleased(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		
		drawable = null;
		DrawStateSingleton.getInstance().currentSelect = null;
		this.canvasPanel.updateElement();
		canvasPanel.repaint();
		}
	}



	
	public void mouseEntered(MouseEvent arg0) {}
	public void mouseExited(MouseEvent arg0) {}
	public void mouseMoved(MouseEvent arg0) {}
}
