package Tools;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.MouseEvent;
import java.awt.geom.Ellipse2D;
import java.awt.image.BufferedImage;

import panels.CanvasPanel;
import Shapes.ElementImage;
import Shapes.ParentElement;

public class ToolStateDropper extends ToolStateAbstract{

	private Ellipse2D.Double ellipse = new Ellipse2D.Double(0,0,10,10);
	private int currentContained = -1;
	private BufferedImage image;
	public ToolStateDropper(CanvasPanel panel){
		this.canvasPanel = panel;
	}
	public void mouseMoved(MouseEvent e) {
		for(int i=0;i<canvasPanel.getStorage().getDrawableList().size();i++){
			if(canvasPanel.getStorage().getDrawableList().get(i).contains(e.getX(), e.getY())){
				//System.out.println(i+ "  contain");
				this.currentContained =i;
			}
		}
		this.ellipse.x = e.getX()- ellipse.width/2;
		this.ellipse.y = e.getY()- ellipse.height/2;
		canvasPanel.update();
		canvasPanel.gback.setColor(Color.black);
		canvasPanel.gback.setStroke(new BasicStroke(1,1,1));
		canvasPanel.gback.draw(ellipse);
		canvasPanel.swapBuffer();
	}

	
	
	public void mouseClicked(MouseEvent e) {
		ParentElement ele =canvasPanel.getStorage().getDrawableList().get(currentContained );
		if(ele instanceof ElementImage){	
		
	
		image =new BufferedImage((int)this.ellipse.width,
		(int)this.ellipse.height,BufferedImage.TYPE_INT_RGB);

		Graphics2D g2d = image.createGraphics();
		g2d.setRenderingHint(RenderingHints.KEY_INTERPOLATION,
		        RenderingHints.VALUE_INTERPOLATION_BICUBIC);
		int centx = e.getX();
		int centy = e.getY();
		int resultx =centx -((ElementImage)ele).rect.x;
		int resulty = centy -((ElementImage)ele).rect.y;
		g2d.drawImage(((ElementImage)ele).bufferedImage,-resultx+ (int)ellipse.width/2,-resulty+ (int)ellipse.height/2, ((ElementImage)ele).rect.width,((ElementImage)ele).rect.height,  null);

		//this.canvasPanel.gback.drawImage(image, 0, 0, (int)ellipse.width, (int)ellipse.height, null);
		//this.canvasPanel.swapBuffer();
		this.canvasPanel.mainframe.setHealingImage(image);
	
			
		
		
		}
	}
	
	
	public void setEllipseSize(int size){
		this.ellipse.width = size;
		this.ellipse.height = size/2;
	}
	public void mouseEntered(MouseEvent e) {}

	public void mouseExited(MouseEvent e) {
		canvasPanel.repaint();
	}
	
	
	public void mousePressed(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}

}
