package Tools;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.Ellipse2D;
import java.awt.image.BufferedImage;
import Shapes.ElementImage;
import Shapes.ParentElement;
import panels.CanvasPanel;

public class ToolStateEnlarge extends ToolStateAbstract{
	private Ellipse2D.Double ellipse = new Ellipse2D.Double(0,0,40,20);
	private int currentContained = -1;
	public ToolStateEnlarge(CanvasPanel panel){
		this.canvasPanel = panel;
	}
	public void mouseMoved(MouseEvent e) {
		for(int i=0;i<canvasPanel.getStorage().getDrawableList().size();i++){
			if(canvasPanel.getStorage().getDrawableList().get(i).contains(e.getX(), e.getY())){
				//System.out.println(i+ "  contain");
				this.currentContained =i;
			}
		}
		this.ellipse.x = e.getX()- ellipse.width/2;
		this.ellipse.y = e.getY()- ellipse.height/2;
		canvasPanel.update();
		if(canvasPanel.gback != null){
		canvasPanel.gback.setColor(Color.black);
		canvasPanel.gback.setStroke(new BasicStroke(1,1,1));
		canvasPanel.gback.draw(ellipse);
		//canvasPanel.getGraphics().drawImage(canvasPanel.gBackImg, 0, 0, canvasPanel);
		canvasPanel.swapBuffer();
		}
	}

	
	
	public void mouseClicked(MouseEvent e) {
		
		if(e.getModifiers() == InputEvent.META_MASK){
			//System.out.println("elliisize");
			//this.setEllipseSize((int)this.ellipse.width + 10);
			
		}
		else{

			ParentElement ele =canvasPanel.getStorage().getDrawableList().get(currentContained );
			if(ele instanceof ElementImage){	
				BufferedImage image =new BufferedImage((int)(((ElementImage)ele).rect.width *1.1),
				(int)(((ElementImage)ele).rect.height*1.1),BufferedImage.TYPE_INT_RGB);

				Graphics2D g2d = image.createGraphics();
				g2d.setRenderingHint(RenderingHints.KEY_INTERPOLATION,
				        RenderingHints.VALUE_INTERPOLATION_BICUBIC);
				
				g2d.drawImage(((ElementImage)ele).bufferedImage, 0,0,(int)(((ElementImage)ele).rect.width *1.1),
						(int)(((ElementImage)ele).rect.height*1.1),  null);
				float y1 = (float)(ellipse.getCenterY() - ((ElementImage)ele).rect.y);				
				float x1 = (float)(ellipse.getCenterX() - ((ElementImage)ele).rect.x);
				
				
				
				BufferedImage buffer = ((ElementImage)ele).bufferedImage; 
				Graphics2D g2 = buffer.createGraphics();
				int bufWidth = ((ElementImage)ele).bufferedImage.getWidth();
				int bufHeight = ((ElementImage)ele).bufferedImage.getHeight();
				double scalex = (double)((ElementImage)ele).rect.width/ (double)bufWidth;
				double scaley = (double)((ElementImage)ele).rect.height/ (double)bufHeight;
				g2.scale(1/scalex, 1/scaley);
				//g2.translate(-((ElementImage)ele).rect.x+1,-((ElementImage)ele).rect.y +1);
				g2.translate(-((ElementImage)ele).rect.x,-((ElementImage)ele).rect.y );
				g2.setClip(ellipse);
				g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION,
				        RenderingHints.VALUE_INTERPOLATION_BICUBIC);
				g2.setComposite(AlphaComposite.getInstance(
						AlphaComposite.SRC_OVER, 0.5f));
				g2.drawImage(image,(int)( ((ElementImage)ele).rect.x-x1/10), 
					(int)(((ElementImage)ele).rect.y-y1/10),
					((int)((ElementImage)ele).rect.width +((ElementImage)ele).rect.width/10),
					((int)((ElementImage)ele).rect.height+(((ElementImage)ele).rect.height/10)), null);
				Ellipse2D.Double ellipse2 = 
					new Ellipse2D.Double(ellipse.x +(ellipse.width/8),ellipse.y+(ellipse.height/8),
							ellipse.width* 3/4,ellipse.height*3/4);
				
				g2.setClip(ellipse2);
				g2.setComposite(AlphaComposite.getInstance(
						AlphaComposite.SRC_OVER, 1.0f));
				g2.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
				g2.drawImage(image,(int)( ((ElementImage)ele).rect.x-x1/10), 
					(int)(((ElementImage)ele).rect.y-y1/10),
					((int)((ElementImage)ele).rect.width +((ElementImage)ele).rect.width/10),
					((int)((ElementImage)ele).rect.height+(((ElementImage)ele).rect.height/10)), null);
				
				
				//g2.translate(((ElementImage)ele).rect.x-1,((ElementImage)ele).rect.y -1);
				g2.translate(((ElementImage)ele).rect.x,((ElementImage)ele).rect.y );
				canvasPanel.update();
				canvasPanel.gback.setColor(Color.black);
				canvasPanel.gback.setStroke(new BasicStroke(1,1,1));
				canvasPanel.gback.draw(ellipse);
				//canvasPanel.getGraphics().drawImage(canvasPanel.gBackImg, 0, 0, canvasPanel);
				canvasPanel.swapBuffer();
			}
			
			
		
		
		}
	}
	
	
	public void setEllipseSize(int size){
		this.ellipse.width = size;
		this.ellipse.height = size/2;
	}
	public void mouseEntered(MouseEvent e) {}

	public void mouseExited(MouseEvent e) {
		canvasPanel.repaint();
		
		
	}
	
	public void refresh(){
		this.currentContained = -1;
	}
	public void mousePressed(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}
