package Tools;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.Ellipse2D;
import java.awt.geom.GeneralPath;

import Shapes.ElementEraser;
import panels.CanvasPanel;
import utils.DrawStateSingleton;

public class ToolStateEraser extends ToolStateAbstract{
	private GeneralPath gp;
	private Ellipse2D.Double ellipse;
	public ToolStateEraser(CanvasPanel panel) {
		super(panel);
		ellipse = new Ellipse2D.Double(0,0,20,20);
		
	}

	public void mousePressed(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		if(drawable == null){
			drawable = new ElementEraser(DrawStateSingleton.getInstance()
					.getDrawableInformation(),this.canvasPanel.currentLayer);
			System.out.println("tstate :"+DrawStateSingleton.getInstance()
					.getDrawableInformation().getCanvasSize());
			gp = new GeneralPath();
			gp.moveTo(e.getX(), e.getY());
			((ElementEraser)drawable).setGeneralPath(gp);
			canvasPanel.getStorage().getDrawableList().add(drawable);
			canvasPanel.currentLayer.vector.add(drawable);
		}
		}
	}
	
	public void mouseDragged(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		gp.lineTo(e.getX(), e.getY());
		
		//((ElementEraser)drawable).paint(canvasPanel.gback);  
		canvasPanel.repaint();
		ellipse.x = (int) gp.getCurrentPoint().getX()-10;
		ellipse.y = (int) gp.getCurrentPoint().getY()-10;
		
		canvasPanel.gback.setColor(Color.black);
		canvasPanel.gback.setStroke(new BasicStroke(1,1,1));
		canvasPanel.gback.draw(ellipse);
		canvasPanel.getGraphics().drawImage(canvasPanel.gBackImg, 0, 0, canvasPanel);  // gbackImg гο ׸     
		//canvasPanel.update();
		}
	}
	
	public void mouseReleased(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		canvasPanel.updateElement();
		gp = null;
		canvasPanel.repaint();
		drawable = null;
		}
	}

	
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseMoved(MouseEvent e) {}

}
