package Tools;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;

import ColorReplace.ColorReplacementDlg;
import ColorReplace.ImageUtil;

import panels.CanvasPanel;

public class ToolStateEyeDropper extends ToolStateAbstract{
	private Color color;
	private ColorReplacementDlg dlg;
	private boolean isColorReplace;
	BufferedImage img;
	
	public ToolStateEyeDropper(CanvasPanel c,ColorReplacementDlg dlg){
		this.canvasPanel = c;
		isColorReplace = true;
		this.dlg = dlg;
		img  = new BufferedImage(this.canvasPanel.gBackImg.getWidth(null),this.canvasPanel.gBackImg.getHeight(null),BufferedImage.TYPE_4BYTE_ABGR);
		Graphics2D imgG = img.createGraphics();
		imgG.drawImage(this.canvasPanel.gBackImg,0, 0, null);
	}
	public void setReplaceMode(boolean b){
		this.isColorReplace = b;
		//System.out.println(b);
	}
	public void mouseReleased(MouseEvent e) {
		img  = new BufferedImage(this.canvasPanel.gBackImg.getWidth(null),this.canvasPanel.gBackImg.getHeight(null),BufferedImage.TYPE_4BYTE_ABGR);
		Graphics2D imgG = img.createGraphics();
		imgG.drawImage(this.canvasPanel.gBackImg,0, 0, null);
		color = getColor(img,e.getX(),e.getY());
		action();
	
	}

	
	private Color getColor(BufferedImage bi,int x, int y){
		return ImageUtil.getPixelColor(bi, x, y);
	}
	public Color getColor(){
		return color;
	}

	private void action(){
		if(isColorReplace){
			dlg.setSourceColor(color);
			dlg.invalidate();
			dlg.validate();
			dlg.repaint();
		}else{
			dlg.resultColor(color);
			
			
		}
	}
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseMoved(MouseEvent e) {
		color = getColor(img,e.getX(),e.getY());
		this.canvasPanel.mainframe.editFrame.colorPanel.setValue(color, e.getX(), e.getY());
		
	}
	
}
