package Tools;

import java.awt.Color;
import java.awt.Font;
import java.awt.Point;
import java.awt.Shape;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;
import java.awt.geom.AffineTransform;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JTextPane;
import Shapes.ElementFont;

import panels.CanvasPanel;
import utils.DrawStateSingleton;

public class ToolStateFont extends ToolStateAbstract{
	private Point startPoint;
	private Font font;
	private JTextPane textpane = null ;	
	private int oldX = 0, oldY = 0,oldWidth = 0, oldHeight = 0,tmpX,tmpY ;
	private Vector<TextLayout> tm;
	private Vector<Shape> sm;
	int width ,height;
	public ToolStateFont(CanvasPanel canvaspanel){
		this.canvasPanel = canvaspanel;
		startPoint = new Point();
		tm = new Vector<TextLayout>();
		sm = new Vector<Shape>();
	}
	
	
	public void mousePressed(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK && this.width == 0){
			this.canvasPanel.setComponentPopupMenu(null);
			this.startPoint.x = e.getX();
			this.startPoint.y = e.getY();
			
			oldX = 0; oldY = 0;
		    oldWidth = 0; oldHeight = 0;
		}
	}

	

	public void mouseDragged(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
			if(textpane != null){
				
			}else{
			width = e.getX() - startPoint.x;
	        height = e.getY() - startPoint.y;
	        tmpX = startPoint.x;
	        tmpY = startPoint.y;
		    if(width < 0) { width = -width; tmpX = e.getX();}
			if(height < 0) {height = -height;tmpY = e.getY();}
			
			canvasPanel.gback.setXORMode(Color.white);
			canvasPanel.gback.drawRect(tmpX, tmpY, width, height);
			canvasPanel.gback.drawRect(oldX, oldY, oldWidth, oldHeight);
			canvasPanel.getGraphics().drawImage(this.canvasPanel.gBackImg, 0, 0, null);
			oldX = tmpX; oldY = tmpY;
	        oldWidth = width;oldHeight = height;
			}
		}
	}

	public void mouseReleased(MouseEvent e) {
		if(e.getModifiers() == InputEvent.META_MASK){

			if(textpane !=  null && Math.abs(this.width)>10){
			String text = textpane.getText();
			FontRenderContext frc  = canvasPanel.gback.getFontRenderContext();
			StringTokenizer st = new StringTokenizer(text , "\n");
			for(int i=0;st.hasMoreTokens();i++){
				String token = st.nextToken();
				TextLayout t = new TextLayout(token, font, frc);
				tm.add(t);
				AffineTransform Tx = AffineTransform.getTranslateInstance(
						tmpX+1, tmpY+canvasPanel.getFontSize()+2+(canvasPanel.getFontSize()*i));
				Shape sha = t.getOutline(Tx);
				sm.add(sha);
			}
			
		
			
			canvasPanel.getRootPane().remove(textpane);
			canvasPanel.update();
			for(int i =0 ;i<sm.size();i++){
				canvasPanel.gback.draw(sm.elementAt(i));
				//System.out.println("׸.");
			}
			if(drawable == null){
				drawable = new ElementFont(DrawStateSingleton.getInstance().getDrawableInformation()
				,font,tm,this.canvasPanel.currentLayer);
			}
			((ElementFont)drawable).setShape(sm);
			this.canvasPanel.setComponentPopupMenu(null);
			canvasPanel.currentLayer.vector.add(drawable);
			canvasPanel.getStorage().getDrawableList().add(drawable);
			
			System.out.println("⿩ "+ canvasPanel.currentLayer.vector.size());
			canvasPanel.repaint();
			canvasPanel.updateElement();
			textpane = null;
			drawable = null;
			this.width = 0;
			this.height = 0;
			MouseListener[] m = canvasPanel.getMouseListeners();
			if(m.length != 0){
			canvasPanel.removeMouseListener(m[0]);
			MouseMotionListener[] mm = canvasPanel.getMouseMotionListeners();
			canvasPanel.removeMouseMotionListener(mm[0]);}
			canvasPanel.setComponentPopupMenu(canvasPanel.popup);
			}
		}else{
			if(textpane == null){
			canvasPanel.update();
			font = new Font(canvasPanel.getFontType(), Font.BOLD, canvasPanel.getFontSize());
			textpane = new JTextPane();	
			textpane.setFont(font);
			textpane.setLocation(this.startPoint.x, this.startPoint.y);
			textpane.setSize(oldWidth,oldHeight);
			textpane.setBorder(BorderFactory.createLineBorder(Color.black));
			this.canvasPanel.getRootPane().add(textpane);
			textpane.selectAll();
			textpane.setVisible(true);
			textpane.invalidate();
			textpane.validate();
			textpane.repaint();
			textpane.requestFocusInWindow();
			canvasPanel.validate();
			
			
			}else{}
		}
		
	}
	
	public void mouseMoved(MouseEvent arg0) {}
	public void mouseClicked(MouseEvent arg0) {}
	public void mouseEntered(MouseEvent arg0) {}
	public void mouseExited(MouseEvent arg0) {}


}
