package Tools;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.geom.Ellipse2D;

import panels.CanvasPanel;
import Shapes.ElementImage;
import Shapes.ParentElement;

public class ToolStateHealing extends ToolStateAbstract{
	private Ellipse2D.Double ellipse = new Ellipse2D.Double(0,0,10,10);
	private int currentContained = -1;
	public ToolStateHealing(CanvasPanel panel){
		this.canvasPanel = panel;
	}
	public void mouseMoved(MouseEvent e) {
		for(int i=0;i<canvasPanel.getStorage().getDrawableList().size();i++){
			if(canvasPanel.getStorage().getDrawableList().get(i).contains(e.getX(), e.getY())){
				//System.out.println(i+ "  contain");
				this.currentContained =i;
			}
		}
		this.ellipse.x = e.getX()- ellipse.width/2;
		this.ellipse.y = e.getY()- ellipse.height/2;
		canvasPanel.update();
		canvasPanel.gback.setColor(Color.black);
		canvasPanel.gback.setStroke(new BasicStroke(1,1,1));
		canvasPanel.gback.draw(ellipse);
		canvasPanel.swapBuffer();
	}

	
	
	public void mouseClicked(MouseEvent e) {
		ParentElement ele =canvasPanel.getStorage().getDrawableList().get(currentContained );
		if(ele instanceof ElementImage){
			if(this.canvasPanel.mainframe.getHealingImage()!= null){
				Graphics2D g2 = ((ElementImage)ele).bufferedImage.createGraphics();
				g2.translate(-((ElementImage)ele).rect.x, -((ElementImage)ele).rect.y);
				g2.setClip(this.ellipse);
				g2.setComposite(AlphaComposite.getInstance(
						AlphaComposite.SRC_OVER, 1.0f));
				g2.drawImage(this.canvasPanel.mainframe.getHealingImage(), e.getX() - (int)this.ellipse.width/2,
						e.getY() - (int)this.ellipse.height/2, null);
				this.canvasPanel.repaint();
			}
		}
		
	}
	
	
	public void setEllipseSize(int size){
		this.ellipse.width = size;
		this.ellipse.height = size/2;
	}
	public void mouseEntered(MouseEvent e) {}

	public void mouseExited(MouseEvent e) {
		canvasPanel.repaint();
	}
	
	
	public void mousePressed(MouseEvent e) {}
	public void mouseDragged(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}
