package Tools;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import Shapes.ElementImage;
import panels.CanvasPanel;
import utils.DrawStateSingleton;

public class ToolStateImage extends ToolStateAbstract{
	private Point startPoint; 
	public ToolStateImage(CanvasPanel panel){
		this.canvasPanel = panel;
		this.startPoint = new Point();
	}
	public void mousePressed(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		if(canvasPanel.currentSelectedImage != null){
		if(drawable == null){
			drawable = new ElementImage(DrawStateSingleton.getInstance()
					.getDrawableInformation(),this.canvasPanel.currentLayer);
			((ElementImage)drawable).setRect(new Rectangle(e.getX(),e.getY(),5,5));
			if(canvasPanel.currentSelectedImage != null){
				((ElementImage)drawable).setImage(canvasPanel.currentSelectedImage);
			}
			canvasPanel.getStorage().getDrawableList().add(drawable);
			canvasPanel.currentLayer.vector.add(drawable);
		}
		
		
		this.startPoint.x = e.getX();
		this.startPoint.y = e.getY();
		
		}
		}
	    
	}

	public void mouseDragged(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		if(canvasPanel.currentSelectedImage != null){
		int width = e.getX() - startPoint.x;
        int height = e.getY() - startPoint.y;
        int tmpX = startPoint.x;
        int tmpY = startPoint.y;
       
	    if(width < 0) { width = -width; tmpX = e.getX();}
		if(height < 0) {height = -height;tmpY = e.getY();}
        
		if(canvasPanel.currentSelectedImage != null){
	
		((ElementImage)drawable).setRect(new Rectangle(tmpX,tmpY,width,height));
		canvasPanel.repaint();
		}
		
		}
		}
	}

	public void mouseReleased(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		if(canvasPanel.currentSelectedImage != null){
		this.canvasPanel.updateElement();
		drawable = null;
		this.canvasPanel.currentSelectedImage = null;
		}
		}
	}
	
	public void mouseMoved(MouseEvent arg0){}
	public void mouseEntered(MouseEvent arg0){}
	public void mouseExited(MouseEvent arg0){}


}
