package Tools;

import java.awt.Point;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.Line2D;
import Shapes.ElementLine;
import panels.CanvasPanel;
import utils.DrawStateSingleton;

public class ToolStateLine extends ToolStateAbstract{
	private Point startPoint;
	private Line2D.Double line;
	public ToolStateLine(CanvasPanel panel){
		this.canvasPanel  = panel;
		startPoint = new Point();
		
	}
	
	
	public void mousePressed(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		if(drawable == null){
			drawable = new ElementLine(DrawStateSingleton.getInstance().getDrawableInformation(),this.canvasPanel.currentLayer);
			((ElementLine)drawable).information.setGraphicAttribute(canvasPanel.gback);
			line = new Line2D.Double(); 
			((ElementLine)drawable).setLine(line);
			canvasPanel.getStorage().getDrawableList().add(drawable);
			canvasPanel.currentLayer.vector.add(drawable);
		}
		
		
		this.startPoint.x = e.getX();
		this.startPoint.y = e.getY();	
		}
	}
	
	public void mouseDragged(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		int width = e.getX() - startPoint.x;
        int height = e.getY() - startPoint.y;
      
	    if(width < 0) { width = -width; }
		if(height < 0) {height = -height;}
		line.x1 = startPoint.x;
		line.x2 = e.getX();
		line.y1 = startPoint.y;
		line.y2 = e.getY();
	
		//canvasPanel.update();
		//((ElementLine)drawable).paint(canvasPanel.gback);
		//canvasPanel.getGraphics().drawImage(this.canvasPanel.gBackImg, 0, 0, null);
		canvasPanel.repaint();
		}
	}
	
	public void mouseReleased(MouseEvent e) {
		//((ElementLine)drawable).setLine(line);
		if(e.getModifiers() != InputEvent.META_MASK){
		canvasPanel.updateElement();
		canvasPanel.repaint();
		drawable = null;
		}
	}


	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseMoved(MouseEvent e) {}

	

}
