package Tools;

import java.awt.Point;
import java.awt.event.MouseEvent;

import Shapes.ParentElement;

import panels.CanvasPanel;

public class ToolStateMove extends ToolStateAbstract{

	private int currentContained = -1;
	private int currentSelection = -1;
	private Point spoint;
	int tranX = 0;
	int tranY = 0;
	public ToolStateMove(CanvasPanel panel){
		this.canvasPanel = panel;
		spoint = new Point();
	}
	
	public void mouseMoved(MouseEvent e) {
		for(int i=0;i<canvasPanel.selectVector.size();i++){
			if(canvasPanel.selectVector.elementAt(i).contains(e.getX(),e.getY())){
				currentSelection = i;
				canvasPanel.selectVector.elementAt(i).setSelect(true);
				
			}else{
				canvasPanel.selectVector.elementAt(i).setSelect(false);
			}
		}
		if(this.currentSelection != -1){
			this.canvasPanel.repaint();
			return;
		}
		for(int i=canvasPanel.getStorage().getDrawableList().size()-1;i>=0;i--){
			if(canvasPanel.getStorage().getDrawableList().get(i).contains(e.getX(), e.getY())){
				this.currentContained =i;
				for(int j=0;j<canvasPanel.getStorage().getDrawableList().size();j++){
					canvasPanel.getStorage().getDrawableList().get(j).setSelect(false);
				}
				canvasPanel.getStorage().getDrawableList().get(i).setSelect(true);
				this.canvasPanel.repaint();
				return;
				
			}
		}
	}
	public void mousePressed(MouseEvent e) {
		if( this.currentSelection != -1 && this.currentSelection<canvasPanel.selectVector.size()){
			if(canvasPanel.selectVector.elementAt(currentSelection)!= null){
			ParentElement ele = canvasPanel.selectVector.elementAt(currentSelection);
			spoint.x = e.getX();
			spoint.y = e.getY();
			tranX = e.getX() - ele.getStartPoint().x;
			tranY = e.getY() - ele.getStartPoint().y;
			return;
			}
		}
			if(this.currentContained != -1 && currentContained <canvasPanel.getStorage().getDrawableList().size()){
				
				ParentElement ele = canvasPanel.getStorage().getDrawableList().get(currentContained);
				if(ele != null){
				spoint.x = e.getX();
				spoint.y = e.getY();
				if(ele.getStartPoint() != null){
				tranX = e.getX() - ele.getStartPoint().x;
				tranY = e.getY() - ele.getStartPoint().y;
				}
				}
			}
	}



	public void mouseDragged(MouseEvent e) {
		int trany =0;
		int tranx = 0;
		if(this.currentSelection != -1 && this.currentSelection<canvasPanel.selectVector.size()){
			ParentElement ele = canvasPanel.selectVector.elementAt(currentSelection);
			if(ele.getStartPoint() != null){
				tranx = e.getX() - ele.getStartPoint().x;
				trany = e.getY() - ele.getStartPoint().y;
			}
			ele.move(tranx- tranX, trany-tranY);
			canvasPanel.repaint();	
			return;
		}
		if(this.currentContained != -1 && currentContained<canvasPanel.getStorage().getDrawableList().size()){
			ParentElement ele = canvasPanel.getStorage().getDrawableList().get(currentContained);
			if(ele.getStartPoint() != null){
				tranx = e.getX() - ele.getStartPoint().x;
				trany = e.getY() - ele.getStartPoint().y;
			}
			ele.move(tranx- tranX, trany-tranY);
			canvasPanel.repaint();
		
		}
	}

	public void mouseReleased(MouseEvent e) {
		this.currentContained = -1;
		this.currentSelection = -1;
		for(int i=0;i<canvasPanel.getStorage().getDrawableList().size();i++){
			canvasPanel.getStorage().getDrawableList().get(i).setSelect(false);
		}
		canvasPanel.repaint();
		canvasPanel.updateElement();
	}

	public void refresh(){
		this.currentContained = -1;
		this.currentSelection = -1;
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}

}
