package Tools;

import java.awt.Point;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.Ellipse2D;
import Shapes.ElementOval;

import panels.CanvasPanel;
import utils.DrawStateSingleton;

public class ToolStateOval extends ToolStateAbstract{
	private Ellipse2D.Double ellipse;
	private Point startPoint; 
	
	public ToolStateOval(CanvasPanel panel){
		this.canvasPanel = panel;
		startPoint = new Point();
	}
	
	public void mousePressed(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		if(drawable == null){
			drawable = new ElementOval(DrawStateSingleton.getInstance()
					.getDrawableInformation(),this.canvasPanel.currentLayer);
			drawable.information.setGraphicAttribute(canvasPanel.gback);
			ellipse = new Ellipse2D.Double();
			((ElementOval)drawable).setOval(ellipse);
			canvasPanel.getStorage().getDrawableList().add(drawable);
			canvasPanel.currentLayer.vector.add(drawable);
		}
		
		this.startPoint.x = e.getX();
		this.startPoint.y = e.getY();
		}
		
	}

	public void mouseDragged(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		int width = e.getX() - startPoint.x;
        int height = e.getY() - startPoint.y;
        int tmpX = startPoint.x;
        int tmpY = startPoint.y;
	    if(width < 0) { width = -width; tmpX = e.getX();}
		if(height < 0) {height = -height;tmpY = e.getY();}
		
	
		((ElementOval)drawable).ellipse.x = tmpX;
		((ElementOval)drawable).ellipse.y = tmpY;
		((ElementOval)drawable).ellipse.width = width;
		((ElementOval)drawable).ellipse.height = height;
		//canvasPanel.update();
		//drawable.paint(canvasPanel.gback);
		//canvasPanel.getGraphics().drawImage(canvasPanel.gBackImg, 0, 0, null);
		canvasPanel.repaint();
		}
	}

	public void mouseReleased(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		this.canvasPanel.updateElement();
		canvasPanel.repaint();
		drawable = null;
		}
	}

	public void mouseMoved(MouseEvent arg0) {}

	public void mouseEntered(MouseEvent arg0) {}

	public void mouseExited(MouseEvent arg0) {}


}
