package Tools;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import Shapes.ElementRect;

import panels.CanvasPanel;
import utils.DrawStateSingleton;

public final class ToolStateRect extends ToolStateAbstract{

	private Rectangle rect;
	private Point startPoint;
	
	
	public ToolStateRect(CanvasPanel panel){
		this.canvasPanel = panel;
		this.startPoint = new Point();
	}
	
	public void mousePressed(MouseEvent e) {	
		if(e.getModifiers() != InputEvent.META_MASK){
		if(drawable == null){
			drawable = new ElementRect(DrawStateSingleton.getInstance()
					.getDrawableInformation(),this.canvasPanel.currentLayer);
			drawable.information.setGraphicAttribute(canvasPanel.gback);
			rect = new Rectangle(0,0,0,0);
			((ElementRect)drawable).setRect(rect);
			canvasPanel.getStorage().getDrawableList().add(drawable);
			canvasPanel.currentLayer.vector.add(drawable);
			System.out.println("׸ "+canvasPanel.getStorage().getDrawableList().size());
		}
	
		
		this.startPoint.x = e.getX();
		this.startPoint.y = e.getY();
	
		}
	}
	public void mouseDragged(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		int width = e.getX() - startPoint.x;
        int height = e.getY() - startPoint.y;
        int tmpX = startPoint.x;
        int tmpY = startPoint.y;
        
	    if(width < 0) { width = -width; tmpX = e.getX();}
		if(height < 0) {height = -height;tmpY = e.getY();}
        
		((ElementRect)drawable).rect.x = tmpX;
		((ElementRect)drawable).rect.y = tmpY;
		((ElementRect)drawable).rect.width = width;
		((ElementRect)drawable).rect.height = height;
		
		
		canvasPanel.repaint();
		}
	}
	public void mouseReleased(MouseEvent e) {
		if(e.getModifiers() != InputEvent.META_MASK){
		
		drawable = null;
		DrawStateSingleton.getInstance().currentSelect = null;
		this.canvasPanel.updateElement();
		canvasPanel.repaint();
		}
	}



	
	public void mouseEntered(MouseEvent arg0) {}
	public void mouseExited(MouseEvent arg0) {}
	public void mouseMoved(MouseEvent arg0) {}

}
