package Tools;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;

import Shapes.ElementLine;
import Shapes.ParentElement;

import panels.CanvasPanel;

public class ToolStateResize extends ToolStateAbstract{
	private int currentSelected;
	private Point spoint;
	
	public ToolStateResize(CanvasPanel panel){
		this.canvasPanel = panel;
		spoint = new Point();
	}
	public void mouseMoved(MouseEvent e) {
		for(int i=0;i<canvasPanel.getStorage().getDrawableList().size();i++){
			
			if(canvasPanel.getStorage().getDrawableList().
					get(i).isSelected(e.getX(),e.getY())){
				
				this.currentSelected = i;
				for(int j=0;j<canvasPanel.getStorage().getDrawableList().size();j++){
					canvasPanel.getStorage().getDrawableList().get(j).setSelect(false);
				}
				canvasPanel.getStorage().getDrawableList().get(i).setSelect(true);
			}
			
		}
		this.canvasPanel.repaint();
	}

	public void mousePressed(MouseEvent e) {
		spoint.x = e.getX();
		spoint.y = e.getY();	
	
	}

	
	public void mouseDragged(MouseEvent e) {
		 int width = e.getX() - spoint.x;
	     int height = e.getY() - spoint.y;
	     
	     if(currentSelected != -1 && currentSelected<canvasPanel.getStorage().getDrawableList().size()){
	     
     	//Ʈ Ȳ̶ Ѵ.
 	   ParentElement ele = canvasPanel.getStorage().getDrawableList().get(currentSelected);
 	   //ϴ ް
 	   
 	   Point startP = ele.getStartPoint();
 	   Point endP = ele.getEndPoint();
 	   //Ʈ̸
 	   if(ele instanceof ElementLine){
 		   if((startP.x > e.getX() -15 && startP.x<e.getX()+15) && (startP.y >e.getY() -15 && startP.y < e.getY()+15)){
 			   ele.setStartPoint(new Point(e.getX(), e.getY()));
 		   }
 		   
 		  if((endP.x > e.getX() -15 && endP.x<e.getX()+15) && (endP.y >e.getY() -15 && endP.y < e.getY()+15)){
			   ele.setEndPoint(new Point(e.getX(), e.getY()));
		   }
 		   
 	   }else{
 		  if(startP.x>e.getX()-15 && startP.x<e.getX()+15){
 	 		   width = ele.getWidth() - (e.getX()-startP.x);
 	 		   height = ele.getHeight();  
 	 		   ele.setResizePosition(new Rectangle(e.getX(),ele.getStartPoint().y,Math.abs(width), Math.abs(height)));
 	 	   }else if(ele.getWidth()+startP.x>e.getX()-15 &&ele.getWidth()+startP.x<e.getX()+15){
 	 		   width = e.getX() - ele.getStartPoint().x;
 	 		   height = ele.getHeight();
 	 		   ele.setResizePosition(new Rectangle(ele.getStartPoint().x , ele.getStartPoint().y,Math.abs(width), Math.abs(height)));
 	 	   }
 	 	 
 	 	   if(startP.y>e.getY()-15 && startP.y<e.getY()+15){
 	 		   height = ele.getHeight() - (e.getY()-startP.y);
 	 		   width = ele.getWidth();
 	 		   ele.setResizePosition(new Rectangle(ele.getStartPoint().x,e.getY(),Math.abs(width), Math.abs(height)));
 	 		   
 	 	   }else if(ele.getHeight() + startP.y > e.getY()-15 && ele.getHeight() + startP.y<e.getY()+ 15){
 	 		   height = e.getY() - ele.getStartPoint().y;
 	 		   width = ele.getWidth();
 	 		   ele.setResizePosition(new Rectangle(ele.getStartPoint().x,ele.getStartPoint().y,Math.abs(width), Math.abs(height)));
 	 	   }
 	 	   
 	   }
 	  
 	   canvasPanel.repaint();
 	  
	     }
	}
	
	public void mouseReleased(MouseEvent e) {
		currentSelected = -1;
		for(int i=0;i<canvasPanel.getStorage().getDrawableList().size();i++){
			canvasPanel.getStorage().getDrawableList().get(i).setSelect(false);
		}
		canvasPanel.repaint();
		canvasPanel.updateElement();
		
	}

	public void refresh(){
		this.currentSelected = -1;
	}
	
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
}
