package Tools;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.geom.Ellipse2D;
import java.awt.image.BufferedImage;

import Shapes.ElementImage;
import Shapes.ParentElement;

import panels.CanvasPanel;

public class ToolStateStamp extends ToolStateAbstract{
	private Ellipse2D.Double ellipse = new Ellipse2D.Double(0,0,20,20);
	private int currentContained = -1;
	BufferedImage stampImage;
	Graphics2D g2;
	int transX, transY;
	double scalex;
	double scaley;
	public ToolStateStamp(CanvasPanel panel){
		this.canvasPanel = panel;
	}
	public void setEllipseSize(int size){
		this.ellipse.width = size;
		this.ellipse.height = size;
	}
	public void refresh(){
		this.currentContained = -1;
	}
	public void mouseMoved(MouseEvent e) {
		for(int i=0;i<canvasPanel.getStorage().getDrawableList().size();i++){
			if(canvasPanel.getStorage().getDrawableList().get(i).contains(e.getX(), e.getY())){
				//System.out.println(i+ "  contain");
				this.currentContained =i;
			}
		}
		this.ellipse.x = e.getX()- ellipse.width/2;
		this.ellipse.y = e.getY()- ellipse.height/2;
		canvasPanel.update();
		if(canvasPanel.gback != null){
			canvasPanel.gback.setColor(Color.black);
			canvasPanel.gback.setStroke(new BasicStroke(1,1,1));
			canvasPanel.gback.draw(ellipse);
			canvasPanel.swapBuffer();
		}
		
	}
	
	public void mousePressed(MouseEvent e) {
		ParentElement ele =canvasPanel.getStorage().getDrawableList().get(currentContained );
		if(ele instanceof ElementImage){
			if(this.canvasPanel.mainframe.getStampImage()!= null){
				stampImage = this.canvasPanel.mainframe.getStampImage();
				Point stampPoint = (Point)this.canvasPanel.mainframe.getStampPoint();
				Point stampScale = (Point)this.canvasPanel.mainframe.getStampScale();
				scalex = (double)stampScale.x/(double)((ElementImage)ele).rect.width;
				scaley =  (double)stampScale.y/(double)((ElementImage)ele).rect.height;
				
				g2 = (Graphics2D) ((ElementImage)ele).bufferedImage.getGraphics();
				ellipse.x = ellipse.x - ((ElementImage)ele).rect.x;
				ellipse.y = ellipse.y - ((ElementImage)ele).rect.y;
				
				ellipse.x = ellipse.x*scalex;//
				ellipse.y = ellipse.y*scaley;//
				
				g2.setClip(this.ellipse );
				transX = (e.getX()-((ElementImage)ele).rect.x) - stampPoint.x ;
				transY = (e.getY()-((ElementImage)ele).rect.y) - stampPoint.y;
				g2.translate(transX,transY );
				
				
				g2.drawImage(stampImage ,0,0,null);
				this.canvasPanel.repaint();
			}
		}
		
	}
	public void mouseDragged(MouseEvent e) {
		ParentElement ele =canvasPanel.getStorage().getDrawableList().get(currentContained );
		if(ele instanceof ElementImage){
			this.ellipse.x = e.getX()- ellipse.width/2;
			this.ellipse.y = e.getY()- ellipse.height/2;
			
			//canvasPanel.update();
			canvasPanel.gback.setColor(Color.black);
			canvasPanel.gback.setStroke(new BasicStroke(1,1,1));
			canvasPanel.gback.draw(ellipse);
			canvasPanel.swapBuffer();
			ellipse.x = ellipse.x -((ElementImage)ele).rect.x - transX;
			ellipse.y = ellipse.y - ((ElementImage)ele).rect.y - transY;
			g2.setClip(this.ellipse );
			g2.drawImage(stampImage ,0,0,null);
			this.canvasPanel.repaint();
		}
	}
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	

	
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
	public void mouseExited(MouseEvent e) {
		canvasPanel.repaint();
		
	}

}
