package Tools;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.geom.Ellipse2D;
import java.awt.image.BufferedImage;
import Shapes.ElementImage;
import Shapes.ParentElement;
import panels.CanvasPanel;

public class ToolStateStampSpoide extends ToolStateAbstract{
	private Ellipse2D.Double ellipse = new Ellipse2D.Double(0,0,20,20);
	private int currentContained = -1;
	
	public ToolStateStampSpoide(CanvasPanel panel){
		this.canvasPanel = panel;
	}
	public void setEllipseSize(int size){
		this.ellipse.width = size;
		this.ellipse.height = size;
	}
	public void mouseMoved(MouseEvent e) {
		for(int i=0;i<canvasPanel.getStorage().getDrawableList().size();i++){
			if(canvasPanel.getStorage().getDrawableList().get(i).contains(e.getX(), e.getY())){
				this.currentContained =i;
			}
		}
		this.ellipse.x = e.getX()- ellipse.width/2;
		this.ellipse.y = e.getY()- ellipse.height/2;
		canvasPanel.update();
		if(canvasPanel.gback != null){
			canvasPanel.gback.setColor(Color.black);
			canvasPanel.gback.setStroke(new BasicStroke(1,1,1));
			canvasPanel.gback.draw(ellipse);
			canvasPanel.swapBuffer();
		}
		
	}

	public void mousePressed(MouseEvent e) {	
		ParentElement ele =canvasPanel.getStorage().getDrawableList().get(currentContained );
		if(ele instanceof ElementImage){	
			int resultX = e.getX() -((ElementImage)ele).rect.x;
			int resultY = e.getY() -((ElementImage)ele).rect.y;
			int scalex = ((ElementImage)ele).bufferedImage.getWidth();
			int scaley = ((ElementImage)ele).bufferedImage.getHeight();
			
			BufferedImage buf = new BufferedImage(((ElementImage)ele).rect.width,((ElementImage)ele).rect.height,BufferedImage.TYPE_4BYTE_ABGR);
			Graphics2D bufg = buf.createGraphics();
			bufg.drawImage(((ElementImage)ele).bufferedImage, 0, 0, ((ElementImage)ele).rect.width, ((ElementImage)ele).rect.height, null);
			this.canvasPanel.mainframe.setStampImage(resultX, resultY , buf ,scalex,scaley);
			
			
			this.canvasPanel.gback.setColor(Color.pink);
			this.canvasPanel.gback.draw(this.ellipse);
			this.canvasPanel.gback.drawLine((int)this.ellipse.x , (int)this.ellipse.y+ (int)this.ellipse.height/2 ,
					(int)this.ellipse.x + (int)this.ellipse.width ,(int)this.ellipse.y+ (int)this.ellipse.height/2);
			this.canvasPanel.gback.drawLine((int)this.ellipse.x+(int)this.ellipse.width/2 , (int)this.ellipse.y ,
					(int)this.ellipse.x + (int)this.ellipse.width/2 ,(int)this.ellipse.y+ (int)this.ellipse.height/2);
			this.canvasPanel.swapBuffer();
			this.canvasPanel.gback.setColor(Color.yellow);
			this.canvasPanel.gback.draw(this.ellipse);
			this.canvasPanel.swapBuffer();
		}
	}
	


	
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
	public void mouseExited(MouseEvent e) {
		canvasPanel.repaint();
	}
	public void mouseDragged(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void refresh(){
		this.currentContained = -1;
	}

}
