package Tools;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.event.MouseEvent;
import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;
import java.awt.image.BufferedImage;
import java.awt.image.ConvolveOp;
import java.awt.image.Kernel;
import java.awt.image.Raster;

import Shapes.ElementImage;
import Shapes.ParentElement;

import panels.CanvasPanel;

public class ToolStateSubBlur extends ToolStateAbstract{
	private Ellipse2D.Double ellipse = new Ellipse2D.Double(0,0,40,40);
	private int currentContained = -1;
	BufferedImage clearBuf ;
	BufferedImage dst;
	Graphics2D sourceGraphics;
	BufferedImage source , copy ;
	Area area, exArea;
	Raster raster;
	float ninth = 1.0f / 9.0f;
	 float[] blurKernel = { ninth, ninth, ninth, ninth, ninth, ninth, ninth,
		        ninth, ninth };
	ConvolveOp BLUR ;
	public ToolStateSubBlur(CanvasPanel panel){
		this.canvasPanel = panel;
		BLUR = new ConvolveOp(new Kernel(3, 3, blurKernel),
		        ConvolveOp.EDGE_NO_OP, null);
	}
	public void mouseMoved(MouseEvent e) {
		for(int i=0;i<canvasPanel.getStorage().getDrawableList().size();i++){
			if(canvasPanel.getStorage().getDrawableList().get(i).contains(e.getX(), e.getY())){
				//System.out.println(i+ "  contain");
				this.currentContained =i;
			}
		}
		this.ellipse.x = e.getX()- ellipse.width/2;
		this.ellipse.y = e.getY()- ellipse.height/2;
		//canvasPanel.update();
		canvasPanel.repaint();
		if(canvasPanel.gback != null){
			canvasPanel.gback.setColor(Color.black);
			canvasPanel.gback.setStroke(new BasicStroke(1,1,1));
			canvasPanel.gback.draw(ellipse);
			canvasPanel.swapBuffer();
		}
	}
	public void mousePressed(MouseEvent e) {
		if(this.currentContained != -1){
		ParentElement ele =canvasPanel.getStorage().getDrawableList().get(currentContained );
		if(ele instanceof ElementImage){
			source = new BufferedImage(((ElementImage)ele).rect.width,((ElementImage)ele).rect.height,BufferedImage.TYPE_4BYTE_ABGR);
			sourceGraphics = source.createGraphics();
			
			copy = new BufferedImage(((ElementImage)ele).rect.width,((ElementImage)ele).rect.height,BufferedImage.TYPE_4BYTE_ABGR);
			Graphics2D g = (Graphics2D) copy.getGraphics();
			g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
			g.drawImage(((ElementImage)ele).bufferedImage,0, 0,((ElementImage)ele).rect.width,((ElementImage)ele).rect.height, null); // copy 
			
			dst =   new BufferedImage(((ElementImage)ele).rect.width,((ElementImage)ele).rect.height,BufferedImage.TYPE_4BYTE_ABGR);
			Graphics2D dstg = (Graphics2D) dst.getGraphics();
			dstg.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
			dstg.drawImage(((ElementImage)ele).bufferedImage,0, 0,((ElementImage)ele).rect.width,((ElementImage)ele).rect.height, null); 
			
			this.BLUR.filter(copy, dst); // filter
			
			clearBuf =new BufferedImage(((ElementImage)ele).rect.width,((ElementImage)ele).rect.height,BufferedImage.TYPE_4BYTE_ABGR);
			raster = clearBuf.getData();
			//g.dispose();
		}
		}
	}
	

	public void mouseReleased(MouseEvent e) {
		ParentElement ele =canvasPanel.getStorage().getDrawableList().get(currentContained );
		if(ele instanceof ElementImage){
			//System.out.println("b ellipse :" + ellipse.x +" y:"+ellipse.y);
			ellipse.x = (ellipse.x -((ElementImage)ele).rect.x);
			ellipse.y = (ellipse.y -((ElementImage)ele).rect.y);
			area = new Area(ellipse);
			
			
			this.sourceGraphics.setClip(this.ellipse);
			sourceGraphics.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
			this.sourceGraphics.drawImage(dst, 0,0, ((ElementImage)ele).rect.width,((ElementImage)ele).rect.height,
					 null);
			//sourceGraphics.draw(this.ellipse);
			((ElementImage)ele).bufferedImage = this.source;
			Area ex = new Area(new Rectangle(0,0,((ElementImage)ele).rect.width,((ElementImage)ele).rect.height));
			ex.subtract(area);
			this.sourceGraphics.setClip(ex);

			this.sourceGraphics.drawImage(copy, 0,0, ((ElementImage)ele).rect.width,((ElementImage)ele).rect.height,
			 null);
			this.canvasPanel.repaint();
			
		}
	
	}

	
	public void mouseDragged(MouseEvent e) {
		
	}
	public void mouseEntered(MouseEvent arg0) {}

	public void mouseExited(MouseEvent arg0) {
		canvasPanel.repaint();
	}

	public void setEllipseSize(int size){
		this.ellipse.width = size;
		this.ellipse.height = size;
	}
	public void refresh(){
		this.currentContained = -1;
	}
}
