package menus;

import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.net.MalformedURLException;

import javax.swing.JFileChooser;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import Start.MainFrame;



public class FileMenu extends JMenu implements ActionListener{
	
	private static final long serialVersionUID = 1L;
	
	private JMenuItem newFile;
	private JMenuItem open;
	private JMenuItem save;
	private JMenuItem saveAs;
	private JMenuItem preview;
	private JMenuItem print;
	private JMenuItem exit;
	private MainFrame mainframe;
	private JFileChooser fileChooser;
	private Toolkit myToolkit;
	public FileMenu(String name ,MainFrame mainframe) {
		super(name);
		this.mainframe = mainframe;
		newFile = new JMenuItem("New");
		open = new JMenuItem("Open");
		save = new JMenuItem("Save");
		saveAs = new JMenuItem("Save As");
		preview = new JMenuItem("Print with Preview");
		print = new JMenuItem("Print");
		exit = new JMenuItem("Exit");
		
		newFile.addActionListener(this);
		open.addActionListener(this);
		save.addActionListener(this);
		saveAs.addActionListener(this);
		preview.addActionListener(this);
		print.addActionListener(this);
		exit.addActionListener(this);
		this.sub();
	}
	
	public void sub() {
		
		this.add(newFile);
		this.add(open);
		this.addSeparator();
		this.add(save);
		
		myToolkit = Toolkit.getDefaultToolkit();
		fileChooser = new JFileChooser(new File("./GraphicIsland") );
		
	    fileChooser.setFileSelectionMode(
	         JFileChooser.FILES_AND_DIRECTORIES );
	    
	}

	@SuppressWarnings("deprecation")
	public void actionPerformed(ActionEvent e) {
		Object o = e.getSource();
		if(o == this.newFile){	
			this.mainframe.addCanvasFrame();
		}else if(o == this.open){
			Image temporeryImage = null;
			
			fileChooser.showOpenDialog(null);
			File file = fileChooser.getSelectedFile();
			
			if(file == null){}
			else{
			try {
				temporeryImage = myToolkit.getImage(file.toURL());
			} catch (MalformedURLException e1) {
				e1.printStackTrace();
			}
			MediaTracker mt = new MediaTracker(mainframe);
			mt.addImage(temporeryImage, 0);
			try {
				mt.waitForID(0);
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			
			this.mainframe.addCanvasFrame(temporeryImage);
			}
		}else if(o == this.save){
			//System.out.println("save");
		}else if(o == this.saveAs){
			//System.out.println("saveAs");
		}else if(o == this.preview){
			//System.out.println("preview");
		}else if(o == this.print){
			//System.out.println("print");
		}else if(o == this.exit){
			//System.out.println("exit");
		}
		
	}

}
