package menus;

import java.awt.Font;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JCheckBox;
import javax.swing.JMenu;

import Start.MainFrame;



public class WindowMenu extends JMenu implements ItemListener{
	
	private static final long serialVersionUID = 1L;
	
	private Font myFont;
	
	private JCheckBox formFrame;
	private JCheckBox editFrame;
	private JCheckBox layerFrame;
	
	MainFrame mainframe;
	
	public WindowMenu(String name , MainFrame mainframe) {
		super(name);
		this.mainframe = mainframe;
		
		myFont = new Font(" ", Font.PLAIN, 12);
				
		formFrame = new JCheckBox("FormFrame");
		formFrame.setFont(myFont);
		
		editFrame = new JCheckBox("EditFrame");
		editFrame.setFont(myFont);
		
		layerFrame = new JCheckBox("LayerFrame");
		layerFrame.setFont(myFont);
		
		this.add(formFrame);
		this.add(editFrame);
		this.add(layerFrame);
		
		formFrame.addItemListener(this);
		editFrame.addItemListener(this);
		layerFrame.addItemListener(this);
		
		formFrame.setSelected(false);
		editFrame.setSelected(true);
		layerFrame.setSelected(true);
	}

	public void itemStateChanged(ItemEvent e) {
		int type = e.getStateChange();
		Object o = e.getSource();
		
		if(o == this.formFrame){
			if(type == ItemEvent.SELECTED){
				this.mainframe.formFrame.setVisible(true);
			}else{
				this.mainframe.formFrame.setVisible(false);
			}
		}
		
		if(o == this.editFrame){
			if(type == ItemEvent.SELECTED){
				this.mainframe.editFrame.setVisible(true);
			}else{
				this.mainframe.editFrame.setVisible(false);
			}
		}
		
		if(o == this.layerFrame){
			if(type == ItemEvent.SELECTED){
				this.mainframe.historyFrame.setVisible(true);
			}else{
				this.mainframe.historyFrame.setVisible(false);
			}
		}
		
	}
}
