package panels;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;

import Shapes.ElementFrame;
import Shapes.ElementImage;
import Start.MainFrame;


public class FramePanel extends JPanel implements ItemListener {

	private static final long serialVersionUID = 1L;
	
	MainFrame mainframe;
	private Font myFont;
	
	private JCheckBox check_frame;
	private JLabel lb_frame;
	private JButton bt_frame;
	
	private JPanel pn_frame;
	private JScrollPane scroll;
	
	private ImageIcon[] img_bigFrame;

	private String[] frame;
	private String[] selectedFrame;
	private String[] bigFrame;
	
	private JRadioButton[] radio_frame;
	private ButtonGroup btGroup;
	boolean frameMode = false;
/*	JCheckBox frame0 , frame1, frame2, frame3, frame4, frame5,
	frame6, frame7, frame8, frame9, frame10, frame11; */
	
	public FramePanel(MainFrame mainframe) {
		super();

		this.mainframe = mainframe;
		
		myFont = new Font("Arial", Font.PLAIN, 10);
		
		check_frame = new JCheckBox();
		
		lb_frame = new JLabel("Choose the Frame:");
		lb_frame.setFont(myFont);
	
		bt_frame = new JButton();
		
		pn_frame = new JPanel();
		
		scroll = new JScrollPane(pn_frame, 
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		
		img_bigFrame = new ImageIcon[11];
				
		frame = new String[11];
		selectedFrame = new String[11];
		bigFrame = new String[11];
		
		for(int i=0 ; i<11 ; i++){
			String str1 = new String("image/frame");
			str1 += String.valueOf(i) ;
			str1 += "-2.jpg";
			frame[i] = str1;
			
			String str2 = new String("image/frame");
			str2 += String.valueOf(i);
			str2 += "-3.jpg";
			selectedFrame[i] = str2;
			
			String str3 = new String("image/frame");
			str3 += String.valueOf(i);
			str3 += "-1.jpg";
			bigFrame[i] = str3;						
		}	
		
		radio_frame = new JRadioButton[11];
		btGroup = new ButtonGroup();
		
	    this.sub();
	    
	}
	
	public void sub() {
		this.setBorder(BorderFactory.createEtchedBorder());
		this.setLayout(null);
		pn_frame.setLayout(new GridLayout(3, 4));

		check_frame.setBounds(new Rectangle(15, 40, 20, 20));
		this.add(check_frame);
		check_frame.addItemListener(this);
		
		lb_frame.setBounds(new Rectangle(35, 40, 90, 20));
		this.add(lb_frame);
		
		bt_frame.setBounds(new Rectangle(130, 5, 74, 92));
		this.add(bt_frame);
		
		scroll.setBounds(new Rectangle(9, 109, 215, 150));
		this.add(scroll);
				
		for(int i=0 ; i<frame.length ; i++) {
			img_bigFrame[i] = new ImageIcon(bigFrame[i]);
		
			radio_frame[i] = new JRadioButton();
			radio_frame[i].setIcon(new ImageIcon(frame[i]));
			radio_frame[i].setSelectedIcon(new ImageIcon(selectedFrame[i]));
			
			btGroup.add(radio_frame[i]);
			pn_frame.add(radio_frame[i]);
			radio_frame[i].addItemListener(this);
		}
		radio_frame[0].setSelected(true);
		
	
		
	}

	public void itemStateChanged(ItemEvent e) {
		int type = e.getStateChange();
		Object o = e.getSource();
		
		if(o == this.check_frame){
			if(type == ItemEvent.SELECTED){
				this.frameMode = true;
			}else{
				this.frameMode = false;
			}
		}
		for(int i=0 ; i<radio_frame.length ; i++) {
			if(e.getSource().equals(radio_frame[i])) {
				if(e.getStateChange() == ItemEvent.SELECTED) {
					bt_frame.setIcon(img_bigFrame[i]);
					if(this.frameMode){
						this.setFrame(i);
					}
				}
			}	
		}
		
		
	}
	
	public void setFrame(int index){
		ArrayList arrList;
		arrList = mainframe.currentCanvasFrame.canvasPanel.getStorage().getDrawableList();
		for(int i=0;i<arrList.size();i++){ // ڰ ִٸ ڸ .
			if(arrList.get(i) instanceof ElementFrame){
				ElementFrame frame = (ElementFrame)arrList.get(i);
				arrList.remove(frame);
				
				for(int j=0;j < mainframe.currentCanvasFrame.canvasPanel.layerVector.size(); j++){
					if(mainframe.currentCanvasFrame.canvasPanel.layerVector.elementAt(j).vector.contains(frame)){
						mainframe.currentCanvasFrame.canvasPanel.layerVector.elementAt(j).vector.remove(frame);
					}
				}
				
			}
		}
		
		for(int i=0;i<mainframe.currentCanvasFrame.canvasPanel.currentLayer.vector.size();i++){
			if(mainframe.currentCanvasFrame.canvasPanel.currentLayer.vector.elementAt(i) instanceof ElementImage){
				ElementImage image = (ElementImage)mainframe.currentCanvasFrame.canvasPanel.currentLayer.vector.elementAt(i);
				ElementFrame frame = (ElementFrame)this.mainframe.frameVector.get(index);
				float imageWidth = image.getWidth();
				float imageHeight = image.getHeight();
				
				int resultWidth = (int)((imageWidth / 400f)*50f-1);
				int resultHeight = (int)((imageHeight /500f)*50f-1);
				frame.setResizePosition(new Rectangle(image.getStartPoint().x-resultWidth , image.getStartPoint().y-resultHeight,image.getWidth()+(resultWidth*2),image.getHeight()+(resultHeight*2)));
				
				if(mainframe.currentCanvasFrame.getWidth()+10 <frame.getWidth()){
					mainframe.currentCanvasFrame.setSize(new Dimension(frame.getWidth()+10,mainframe.currentCanvasFrame.getHeight()));
					frame.setStartPoint(new Point(0,0));
					image.setStartPoint(new Point(resultWidth-1,resultHeight-1));
				}
				if(mainframe.currentCanvasFrame.getHeight()+15 <frame.getHeight()){
					mainframe.currentCanvasFrame.setSize(new Dimension(mainframe.currentCanvasFrame.getWidth(),frame.getHeight()+15));
					frame.setStartPoint(new Point(0,0));
					image.setStartPoint(new Point(resultWidth-1,resultHeight-1));
				}
				frame.information.setCanvasSize(this.mainframe.currentCanvasFrame.canvasPanel.getWidth(), this.mainframe.currentCanvasFrame.canvasPanel.getHeight());
				this.mainframe.currentCanvasFrame.canvasPanel.currentLayer.addElement(frame);
				this.mainframe.currentCanvasFrame.canvasPanel.getStorage().getDrawableList().add(frame);
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
				this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
				return;
			}
		}
	}
}