package panels;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;


import FuncDialog.FuncDialog;
import FuncDialog.imageFunDialog;
import Shapes.ElementImage;
import Shapes.ParentElement;
import Start.MainFrame;

public class HistoryPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	
	private JPanel inScrollpanel;
	private JScrollPane scroll;
	private Vector<HistoryButton> buttonVector;
	private MainFrame mainframe;
	private ArrayList<ParentElement> sm;
	
	public HistoryPanel(MainFrame mainframe) {
		super();
		this.mainframe = mainframe;
		buttonVector = new Vector<HistoryButton>();
		sm = new ArrayList<ParentElement>();
		
		inScrollpanel = new JPanel();
		inScrollpanel.setBackground(Color.black);
		inScrollpanel.setLayout(new BoxLayout(inScrollpanel, BoxLayout.Y_AXIS));
		
		scroll = new JScrollPane(inScrollpanel, 
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scroll.setPreferredSize(new Dimension(200, 200));
		this.sub();
	}
	
	public void sub() {
		scroll.setBackground(Color.black);
		this.add(scroll);
	}
	
	public void addElement(ParentElement element,int width,int height){
		sm.add(element);
		HistoryButton bt_layer = new HistoryButton(this.mainframe,element,width,height);
		buttonVector.add(bt_layer);
		inScrollpanel.add(bt_layer);
		inScrollpanel.validate();
		this.validate();
		
	}

	public void updateElement(ArrayList<ParentElement> drawableList, int width, int height) {
		inScrollpanel.removeAll();
		sm = drawableList;
		
		for(int i=0;i<sm.size();i++){
			HistoryButton bt_layer = new HistoryButton(this.mainframe,sm.get(i),width,height);
			buttonVector.add(bt_layer);
			bt_layer.lb_historyName.setText(bt_layer.lb_historyName.getText()+i);
			inScrollpanel.add(bt_layer);
		}
		
		inScrollpanel.validate();
		this.validate();
		this.repaint();
	}
		
	public class HistoryButton extends JButton implements ActionListener, ItemListener{
		
		private static final long serialVersionUID = 1L;
		
		private JPanel funcPanel, pn_checkBox;
		public JLabel lb_historyName;
		private JButton func, remove;
		private SmallNaviPanel naviPanel;
		private JCheckBox visible;
		private ParentElement element;
		@SuppressWarnings("unused")
		private ImageIcon img_eye, img_empty, img_remove, img_funcdiag;
		private Font myFont;
		MainFrame mainframe;
		
		public HistoryButton(MainFrame mainframe,ParentElement _element, int width,int height){
			this.mainframe = mainframe;
			this.element = _element;
			
			naviPanel = new SmallNaviPanel(this.element);
			funcPanel = new JPanel();
			
			myFont = new Font("Arial", Font.PLAIN, 10);
			
			lb_historyName = new JLabel("History ");
			lb_historyName.setFont(myFont);
			
			pn_checkBox = new JPanel();
			pn_checkBox.setLayout(new GridLayout());
			pn_checkBox.setPreferredSize(new Dimension(22, 20));
			pn_checkBox.setBorder(BorderFactory.createLoweredBevelBorder());
			
			img_eye = new ImageIcon("image/eye.jpg");
			img_empty = new ImageIcon("image/empty.jpg");
			img_remove = new ImageIcon("image/.jpg");
			img_funcdiag = new ImageIcon("image/funcDialog.jpg");
			
			visible = new JCheckBox(img_eye);
			visible.setSelectedIcon(img_empty);
						
			func = new JButton(img_funcdiag);
			remove = new JButton(img_remove);
			remove.setPreferredSize(new Dimension(25, 25));
			
		//	this.setBorder(BorderFactory.createRaisedBevelBorder());
			this.setLayout(null);
			this.setPreferredSize(new Dimension(180,100));
			this.setMaximumSize(new Dimension(184,52));
			
			if(height <=40){
				naviPanel.setBounds(new Rectangle(5, 6, 40, 40));
			}else{
				float rate =height /(float)40;
				int result =(int)(width/rate);
			
				naviPanel.setBounds(new Rectangle(5, 6, result, 40));
			}
			
			funcPanel.setPreferredSize(new Dimension(40,40));
			
			this.add(naviPanel);
			
			lb_historyName.setBounds(new Rectangle(55, 15, 40, 20));
			this.add(lb_historyName);
			
			pn_checkBox.add(visible);
			pn_checkBox.setBounds(new Rectangle(100, 15, 22, 20));
			this.add(pn_checkBox);
									
			func.setBounds(new Rectangle(125, 13, 25, 25));
			this.add(func);
			
			remove.setBounds(new Rectangle(150, 13, 25, 25));
			this.add(remove);
						
			visible.addItemListener(this);
			func.addActionListener(this);
			remove.addActionListener(this);
			
		}
		
		public void actionPerformed(ActionEvent e) {
			Object o = e.getSource();
			
			if(o == func){
				if(this.element instanceof ElementImage){
					@SuppressWarnings("unused")
					//ImageFuncDialog ifd = new ImageFuncDialog(mainframe,(ElementImage)this.element);
					imageFunDialog ifd = new imageFunDialog(mainframe,(ElementImage)this.element);
					this.mainframe.desktopPane.add(ifd);
				}else{
					@SuppressWarnings("unused")
					FuncDialog fd = new FuncDialog(mainframe,this.element);
				}
			}else if(o == remove){
				this.mainframe.currentCanvasFrame.canvasPanel.removeElement(this.element);
			}
		}
		
		public void itemStateChanged(ItemEvent e) {
			Object o = e.getSource();
			
			int type = e.getStateChange();
			//System.out.println("type :"+type);
			if(o == visible ){
				if( type == 1){
					this.element.isVisible = false;
					this.mainframe.currentCanvasFrame.canvasPanel.repaint();
					//this.mainframe.currentCanvasFrame.canvasPanel.updateElement();
					this.mainframe.editFrame.updateElement(
							this.mainframe.currentCanvasFrame.canvasPanel.getStorage().getDrawableList());
				}else if(type == 2){
					this.element.isVisible = true;
					this.mainframe.currentCanvasFrame.canvasPanel.repaint();
					this.mainframe.editFrame.updateElement(
							this.mainframe.currentCanvasFrame.canvasPanel.getStorage().getDrawableList());
				}
			}
			
		}
		
	}

}