package panels;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JPanel;


import Shapes.ParentElement;
import Start.MainFrame;

public class NavigatorPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	
	private CenterPanel centerPanel;
	MainFrame mainframe;
	
	public NavigatorPanel(MainFrame mainframe) {
		super();
		
		this.mainframe = mainframe;
		centerPanel = new CenterPanel(this.mainframe);
		this.sub();
	}
	
	public void sub() {
		this.setBorder(BorderFactory.createEtchedBorder());
		
		centerPanel.setPreferredSize(new Dimension(150,150));
		centerPanel.setMaximumSize(new Dimension(150,150));
		this.centerPanel.setBackground(Color.white);
		this.add(centerPanel);
	}
	
	public void updateElement(ArrayList<ParentElement> drawableList) {
		this.centerPanel.update(drawableList);
		//centerPanel.validate();
		//centerPanel.repaint();
		//this.validate();
		//this.repaint();
	}	
	
	public class CenterPanel extends JPanel{
		private static final long serialVersionUID = 1L;
		private ArrayList<ParentElement> vector;
		MainFrame mainframe;
		public CenterPanel(MainFrame mainframe){
			vector = new ArrayList<ParentElement>();
			this.mainframe = mainframe;
		}
		
		public void paint(Graphics g){
			super.paint(g);
			Graphics2D g2d = (Graphics2D)g;
			g2d.drawRect(0, 0, this.getWidth()-1, this.getHeight()-1);
			
			
			for(int i=0;i<vector.size();i++){
				if(vector.get(i).isVisible){
					vector.get(i).middlePaint(g2d);
				}
			}
			//g2d.scale(1/scalex, 1/scaley);
			//System.out.println("paint ");
		}
		
		public void update(ArrayList<ParentElement> drawableList) {
			this.vector = drawableList;
			this.repaint();
		}
		
	}
	
}
