package popupMenus;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.SwingConstants;

import toolBars.EditTool;

public class PopupBrushSize extends JPopupMenu implements ActionListener {

	private static final long serialVersionUID = 1L;
	
	private FlowLayout flowLayout;
	
	private Box box_sizeShape;
	
	private JPanel pn_sizeWhole;
	private JPanel pn_size, pn_sizeShape;
	
	private ImageIcon img_size1, img_size3, img_size5, img_size9, img_size13, img_size19;
	
	private JButton bt_size1, bt_size3, bt_size5, bt_size9, bt_size13, bt_size19;
	
	private JScrollPane scroll;
	
	private JLabel lb_masterSize, lb_sizeUnit;
	private JSlider sldr_masterSize;
	private JFormattedTextField txtf_masterSize;
	
	private EditTool editTool;
	
	public PopupBrushSize(EditTool editTool) {
		super();
		
		this.editTool = editTool;
		flowLayout = new FlowLayout(FlowLayout.LEFT, 0, 0);

		box_sizeShape = new Box(BoxLayout.Y_AXIS);
		
		pn_sizeWhole = new JPanel();
		pn_sizeWhole.setPreferredSize(new Dimension(222, 278));
		
		pn_size = new JPanel();
		pn_sizeShape = new JPanel();
		pn_sizeShape.setBorder(BorderFactory.createLoweredBevelBorder());
		
		img_size1 = new ImageIcon("image/size1.jpg");
		img_size3 = new ImageIcon("image/size3.jpg");
		img_size5 = new ImageIcon("image/size5.jpg");
		img_size9 = new ImageIcon("image/size9.jpg");
		img_size13 = new ImageIcon("image/size13.jpg");
		img_size19 = new ImageIcon("image/size19.jpg");
		
		bt_size1 = new JButton(img_size1);
		bt_size1.setPreferredSize(new Dimension(191, 35));
		bt_size1.addActionListener(this);
		
		bt_size3 = new JButton(img_size3);
		bt_size3.setPreferredSize(new Dimension(191, 35));
		bt_size3.addActionListener(this);
		
		bt_size5 = new JButton(img_size5);
		bt_size5.setPreferredSize(new Dimension(191, 35));
		bt_size5.addActionListener(this);
		
		bt_size9 = new JButton(img_size9);
		bt_size9.setPreferredSize(new Dimension(191, 35));
		bt_size9.addActionListener(this);
		
		bt_size13 = new JButton(img_size13);
		bt_size13.setPreferredSize(new Dimension(191, 35));
		bt_size13.addActionListener(this);
		
		bt_size19 = new JButton(img_size19);
		bt_size19.setPreferredSize(new Dimension(191, 35));
		bt_size19.addActionListener(this);
		
		scroll = new JScrollPane(pn_sizeShape, 
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		
		lb_masterSize = new JLabel("Brush Size");
		sldr_masterSize = new JSlider(SwingConstants.HORIZONTAL, 1, 30, 1);
		txtf_masterSize = new JFormattedTextField("1");
		txtf_masterSize.setHorizontalAlignment(SwingConstants.RIGHT);
		lb_sizeUnit = new JLabel("px");
				
		this.sub();
	}
	
	public void sub() {
		this.setLayout(flowLayout);
		this.setPreferredSize(new Dimension(224, 280));
		this.setBackground(Color.yellow);

		pn_sizeWhole.setLayout(null);
		pn_size.setLayout(null);
		pn_sizeShape.setLayout(flowLayout);
		
		lb_masterSize.setBounds(new Rectangle(5, 5, 70, 20));
		pn_size.add(lb_masterSize);
		
		txtf_masterSize.setBounds(new Rectangle(136, 5, 50, 20));
		pn_size.add(txtf_masterSize);
		
		lb_sizeUnit.setBounds(new Rectangle(190, 5, 20, 20));
		pn_size.add(lb_sizeUnit);
		
		sldr_masterSize.setBounds(new Rectangle(5, 30, 200, 20));
		pn_size.add(sldr_masterSize);
		
		pn_size.setBounds(new Rectangle(5, 5, 212, 60));
		
		box_sizeShape.add(bt_size1);
		box_sizeShape.add(bt_size3);
		box_sizeShape.add(bt_size5);
		box_sizeShape.add(bt_size9);
		box_sizeShape.add(bt_size13);
		box_sizeShape.add(bt_size19);
		
		pn_sizeShape.add(box_sizeShape);
		scroll.setBounds(new Rectangle(5, 70, 212, 196));
		pn_sizeWhole.add(scroll);
		
		pn_sizeWhole.add(pn_size);
		
		this.add(pn_sizeWhole);
	}

	
	public void actionPerformed(ActionEvent e) {
		
		if(e.getSource().equals(bt_size1)) {
			editTool.lb_brushSize.setIcon(editTool.img_brush1);
			this.editTool.mainframe.currentCanvasFrame.canvasPanel.getInformation().strokeSize = 1;
		}
		else if(e.getSource().equals(bt_size3)) {
			editTool.lb_brushSize.setIcon(editTool.img_brush3);
			this.editTool.mainframe.currentCanvasFrame.canvasPanel.getInformation().strokeSize = 3;
		}
		else if(e.getSource().equals(bt_size5)) {
			editTool.lb_brushSize.setIcon(editTool.img_brush5);
			this.editTool.mainframe.currentCanvasFrame.canvasPanel.getInformation().strokeSize = 5;
		}
		else if(e.getSource().equals(bt_size9)) {
			editTool.lb_brushSize.setIcon(editTool.img_brush9);
			this.editTool.mainframe.currentCanvasFrame.canvasPanel.getInformation().strokeSize = 9;
		}
		else if(e.getSource().equals(bt_size13)) {
			editTool.lb_brushSize.setIcon(editTool.img_brush13);
			this.editTool.mainframe.currentCanvasFrame.canvasPanel.getInformation().strokeSize = 13;
		}
		else if(e.getSource().equals(bt_size19)) {
			editTool.lb_brushSize.setIcon(editTool.img_brush19);
			this.editTool.mainframe.currentCanvasFrame.canvasPanel.getInformation().strokeSize = 19;
		}
		
	}

}
