package popupMenus;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

import Shapes.ParentElement;
import Tools.ToolStateMove;
import Tools.ToolStateResize;

import panels.CanvasPanel;
import utils.DrawStateSingleton;

public class PopupSelction extends JPopupMenu implements ActionListener{
	private static final long serialVersionUID = -5463233341505412476L;
	private CanvasPanel canvasPanel;
	public JMenuItem copy;
	public JMenuItem paste;
	public JMenuItem move;
	public JMenuItem resize;
	public JMenuItem delete;
	public JMenuItem label;
	public int selectedId;
	int x=-1, y=-1;
	public PopupSelction(CanvasPanel canvasPanel){
		super();
		this.canvasPanel = canvasPanel;
		//this.setPreferredSize(new Dimension(200, 220));
		label = new JMenuItem(" ");
		copy = new JMenuItem("Copy");
		copy.addActionListener(this);
		paste = new JMenuItem("Paste");
		paste.addActionListener(this);
		
		
		move = new JMenuItem("Move");
		move.addActionListener(this);
		resize = new JMenuItem("Resize");
		resize.addActionListener(this);
		
		
		delete = new JMenuItem("Delete");
		delete.addActionListener(this);
		
		this.add(label);
		this.addSeparator();
		
		this.add(copy);
		this.add(paste);
		this.addSeparator();
		
		this.add(move);
		this.add(resize);
		this.addSeparator();
		this.add(delete);
	}
	
	public void show(Component c, int x,int y){
		this.x = x;
		this.y = y;
		int currentSelected = -1;
		@SuppressWarnings("unused")
		int layerId = -1;
		int elementId = -1; 
	
		for(int i = 0;i<this.canvasPanel.selectVector.size();i++){
			if(canvasPanel.selectVector.elementAt(i).contains(x, y)){
				canvasPanel.selectVector.elementAt(i).setSelect(true);
				this.canvasPanel.repaint();
				this.canvasPanel.popup.selectedId = i;
				currentSelected = i;
				this.label.setText("Selection");
				this.canvasPanel.popup.copy.setEnabled(true);
				this.canvasPanel.popup.delete.setEnabled(true);
				this.canvasPanel.popup.move.setEnabled(true);
				this.canvasPanel.popup.resize.setEnabled(false);
				if(this.canvasPanel.mainframe.getSelectedElement() == null){
					this.canvasPanel.popup.paste.setEnabled(false);
				}else{
					this.canvasPanel.popup.paste.setEnabled(true);
				}
				super.show(c, x, y);
				return;
				//break;
			
			}
		}
		
		for(int i =0 ;i<this.canvasPanel.layerVector.size();i++){
			for(int j=0;j<this.canvasPanel.layerVector.elementAt(i).vector.size();j++){
				if(this.canvasPanel.layerVector.elementAt(i).vector.elementAt(j).contains(x, y)){
					this.canvasPanel.layerVector.elementAt(i).vector.elementAt(j).setSelect(true);
					this.canvasPanel.repaint();
					layerId = i;
					elementId = j ;
					this.label.setText("Shape");
					this.canvasPanel.popup.copy.setEnabled(true);
					this.canvasPanel.popup.delete.setEnabled(true);
					this.canvasPanel.popup.move.setEnabled(true);
					this.canvasPanel.popup.resize.setEnabled(true);
					if(this.canvasPanel.mainframe.getSelectedElement() == null){
						this.canvasPanel.popup.paste.setEnabled(false);
					}else{
						this.canvasPanel.popup.paste.setEnabled(true);
					}
					super.show(c, x, y);
					return;
					//break;
				}
			}
		
		}
		
		if(currentSelected == -1 && elementId == -1 ){
			this.label.setText("no Selected");
			this.canvasPanel.popup.copy.setEnabled(false);
			this.canvasPanel.popup.delete.setEnabled(false);
			this.canvasPanel.popup.move.setEnabled(false);
			if(this.canvasPanel.mainframe.getSelectedElement() == null){
				this.canvasPanel.popup.paste.setEnabled(false);
			}else{
				this.canvasPanel.popup.paste.setEnabled(true);
			}
			this.canvasPanel.popup.resize.setEnabled(false);
			super.show(c, x, y);
		}
	}
	
	public void actionPerformed(ActionEvent e) {
		Object o = e.getSource();
		
		if(o == copy){
			this.canvasPanel.copy(this.selectedId);
		}else if(o == paste){
			this.canvasPanel.paste(this.getX(), this.getY());
			
		}else if(o == delete){
			for(int i = this.canvasPanel.selectVector.size();i>= 1;i--){
				if(canvasPanel.selectVector.elementAt(i-1).contains(x, y)){
					canvasPanel.selectVector.remove(i-1);
					this.canvasPanel.repaint();
					this.canvasPanel.updateElement();
					DrawStateSingleton.getInstance().getToolState().refresh();
					return;
				
				}
			}
			
			for(int i = this.canvasPanel.getStorage().getDrawableList().size();i>=1;i--){
				if(canvasPanel.getStorage().getDrawableList().get(i-1).contains(x, y)){
					ParentElement ele = canvasPanel.getStorage().getDrawableList().get(i-1);
					canvasPanel.getStorage().getDrawableList().remove(ele);
					for(int j = 0;j<canvasPanel.layerVector.size();j++){
						if(canvasPanel.layerVector.elementAt(j).vector.contains(ele)){
							canvasPanel.layerVector.elementAt(j).vector.remove(ele);
							this.canvasPanel.repaint();
							this.canvasPanel.updateElement();
							return;
						}
					}
				}
			}
			
		}else if(o == move){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateMove(canvasPanel));
			canvasPanel.updateDrawState();
			canvasPanel.setComponentPopupMenu(canvasPanel.popup);
		}else if(o == resize){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateResize(canvasPanel));
			canvasPanel.updateDrawState();
			canvasPanel.setComponentPopupMenu(canvasPanel.popup);
		}
	}
}
