package subframes;



import java.awt.Image;

import javax.swing.JInternalFrame;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;

import Start.MainFrame;
import panels.CanvasPanel;
import utils.DrawStateSingleton;


public class CanvasFrame extends JInternalFrame{
	
	private static final long serialVersionUID = 1L;
	private canvasFrameHandler canvasframehandler;
	public CanvasPanel canvasPanel;
	private MainFrame mainframe = null;
	
	public CanvasFrame(MainFrame mainframe) {
		super("Noname", true, true, true, true);
		this.mainframe = mainframe;
		
		canvasPanel = new CanvasPanel(mainframe);
		canvasframehandler = new canvasFrameHandler(this);
		this.sub();
	}
	
	public void sub() {
		this.addInternalFrameListener(canvasframehandler);
		this.getContentPane().add(canvasPanel);
		this.setVisible(true);
	}

	public CanvasPanel getCanvasPanel() {return canvasPanel;}
	public void setCanvasPanel(CanvasPanel canvasPanel) {
		this.canvasPanel = canvasPanel;
	}
	public void setCanvasBounds(int startPosition){
		this.setBounds(startPosition, startPosition, 600, 600);
	}
	public void setCanvasBounds(int startPosition ,int width,int height){
		this.setBounds(startPosition, startPosition, width +8, height+25);
	}
	public void setCanvasName(String name){
		super.setName(name);
	}

	public String setCanvasName(){
		return super.getName();
	}
	
	public void setDrawMode(byte DrawMode){
		System.out.print(this.getName());
		//this.canvasPanel.setDrawMode(DrawMode);
	}
	

	public void setImageToCanvasFrame(Image temporeryImage) {
		this.canvasPanel.setImageToCanvasPanel(temporeryImage);
		
	}
	
	
	public class canvasFrameHandler extends InternalFrameAdapter{
		CanvasFrame canvasframe;
		
		public canvasFrameHandler(CanvasFrame canvasframe){
			this.canvasframe = canvasframe;
		}
		public void internalFrameActivated(InternalFrameEvent e) {
			
			this.canvasframe.mainframe.currentCanvasFrame.canvasPanel.removeDrawState();
			
			canvasframe.mainframe.setCurrentCanvasFrame(canvasframe);
			DrawStateSingleton.getInstance().setCurrentPanel(this.canvasframe.getCanvasPanel());
			if(DrawStateSingleton.getInstance().getToolState() != null){
				DrawStateSingleton.getInstance().getToolState().setCanvas(this.canvasframe.canvasPanel);
			}
			this.canvasframe.canvasPanel.updateDrawState();
			canvasframe.canvasPanel.updateElement();
			
			System.gc();
			System.runFinalization();
		}

		public void internalFrameClosed(InternalFrameEvent arg0) {
			canvasframe.mainframe.removeCanvasFrame(canvasframe);
			
		}

		public void internalFrameClosing(InternalFrameEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void internalFrameDeactivated(InternalFrameEvent e) {
			System.gc();
			System.runFinalization();
			
		}

		public void internalFrameDeiconified(InternalFrameEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void internalFrameIconified(InternalFrameEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void internalFrameOpened(InternalFrameEvent arg0) {
			// TODO Auto-generated method stub
			
		}
	
	}






	
}
