package subframes;

import java.awt.Font;
import java.util.ArrayList;
import java.util.Vector;

import javax.swing.JInternalFrame;
import javax.swing.JTabbedPane;


import Layers.Layer;
import Layers.LayerPanel;
import Shapes.ParentElement;
import Start.MainFrame;

import panels.HistoryPanel;



public class HistoryFrame extends JInternalFrame {

	private static final long serialVersionUID = 1L;
	
	private JTabbedPane tab_layer;
	private HistoryPanel historyPanel;
	private MainFrame mainframe;
	private LayerPanel layerPanel;
	private Font myFont;
	
	public HistoryFrame(MainFrame mainframe) {
		super("History", true, true, false, true);
		
		this.mainframe = mainframe;
		
		myFont = new Font("Arial", Font.PLAIN, 10);
		
		tab_layer = new JTabbedPane();
		tab_layer.setFont(myFont);
		historyPanel = new HistoryPanel(mainframe);
		historyPanel.setFont(myFont);
		layerPanel = new LayerPanel(mainframe);	
		layerPanel.setFont(myFont);
		
		this.sub();
	}
	
	public void sub() {
		this.setVisible(true);
		this.setBounds(970, 240, 220, 265);
			
		tab_layer.add("History",historyPanel);
		tab_layer.add("Layer",layerPanel);
		this.add(tab_layer);
		this.setDefaultCloseOperation(HIDE_ON_CLOSE);
		
	}
	
	public void addElement(ParentElement element){
		this.historyPanel.addElement(element,
				this.mainframe.currentCanvasFrame.getWidth(),
				this.mainframe.currentCanvasFrame.getHeight());
	}
	
	

	public void updateElement(ArrayList<ParentElement> drawableList,Vector<Layer> layerVector) {
		this.historyPanel.updateElement(drawableList,
				this.mainframe.currentCanvasFrame.getWidth(),
				this.mainframe.currentCanvasFrame.getHeight());
		this.layerPanel.updateElement(layerVector);
		this.repaint();
		
	}
}

