package subframes;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JInternalFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;

import Layers.Layer;
import Layers.SmallLayerPanel;
import Start.MainFrame;


public class LayerFrame extends JInternalFrame{

	private static final long serialVersionUID = -3299343863096898406L;
	@SuppressWarnings("unused")
	private MainFrame mainframe;
	private JTabbedPane tab;
	private LayerPanel layerPanel;
	
	private Font myFont;
	
	public LayerFrame (MainFrame mainframe){
		super("Layers", true, true, false, true);
		this.setVisible(true);
		this.setBounds(960, 500, 220, 270);
		this.mainframe = mainframe;
		
		myFont = new Font("Arial", Font.PLAIN, 10);
		
		tab = new JTabbedPane();
		tab.setFont(myFont);
		layerPanel = new LayerPanel(mainframe);
		layerPanel.setFont(myFont);
		tab.addTab("Layers", layerPanel);
		this.add(tab);
	}
	
	public void updateElement(Vector<Layer> layerVector){
		this.layerPanel.updateElement(layerVector);
	}
	
	public class LayerPanel extends JPanel{
		private static final long serialVersionUID = -3391425711933314109L;
		private JPanel inScrollpanel;
		private JScrollPane scroll;
		private Vector<LayerButton> buttonVector;
		@SuppressWarnings("unused")
		private Vector<Layer> layerVector;
		MainFrame mainframe;
		public LayerPanel(MainFrame mainframe){
			this.mainframe = mainframe;
			buttonVector = new Vector<LayerButton>();
			layerVector = new Vector<Layer>();
			inScrollpanel = new JPanel();
			inScrollpanel.setBackground(Color.black);
			inScrollpanel.setLayout(new BoxLayout(inScrollpanel, BoxLayout.Y_AXIS));
			
			scroll = new JScrollPane(inScrollpanel, 
					JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, 
					JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			scroll.setPreferredSize(new Dimension(200, 200));
			scroll.setBackground(Color.black);
			this.add(scroll);
		}
		
		
		

		public void updateElement(Vector<Layer> layerVector) {

			inScrollpanel.removeAll();
			this.layerVector = layerVector;
			for(int i=0;i<layerVector.size();i++){
				LayerButton bt_layer = new LayerButton(this.mainframe,layerVector.elementAt(i));
				buttonVector.add(bt_layer);
				inScrollpanel.add(bt_layer);
			}
			inScrollpanel.validate();
			this.validate();
			this.repaint();
			this.mainframe.historyFrame.repaint();
		}
		
	}
	
	public class LayerButton extends JButton implements ActionListener{
	
		private static final long serialVersionUID = 1L;
		
		private JPanel funcPanel, pn_checkBox;
		private SmallLayerPanel naviPanel;
		
		private JButton func, remove;
		private JCheckBox visible;
		private Layer layer;
		@SuppressWarnings("unused")
		private ImageIcon img_eye, img_empty, img_remove, img_funcdiag;
		MainFrame mainframe;
		
		public LayerButton(MainFrame mainframe , Layer layer){
			this.mainframe = mainframe;
			this.layer = layer;
			
			funcPanel = new JPanel();
			
			pn_checkBox = new JPanel();
			pn_checkBox.setLayout(new GridLayout());
			pn_checkBox.setPreferredSize(new Dimension(22, 20));
			pn_checkBox.setBorder(BorderFactory.createLoweredBevelBorder());
						
			img_eye = new ImageIcon("image/eye.jpg");
			img_empty = new ImageIcon("image/empty.jpg");
			img_remove = new ImageIcon("image/.jpg");
			
			visible = new JCheckBox(img_eye);
			visible.setSelectedIcon(img_empty);
							
			func = new JButton("");
			remove = new JButton(img_remove);
			remove.setPreferredSize(new Dimension(25, 25));
			
			this.setBorder(BorderFactory.createRaisedBevelBorder());
			this.setLayout(null);
			this.setPreferredSize(new Dimension(180, 100));
			this.setMaximumSize(new Dimension(184, 52));
			float rate =0;
			float result =0;
			int height = mainframe.currentCanvasFrame.canvasPanel.getHeight();
			rate =height /(float)40;
			result =(int)(mainframe.currentCanvasFrame.canvasPanel.getWidth()/rate);
			
			naviPanel = new SmallLayerPanel(this.layer ,rate,rate);
			
			if(height <=40){
				naviPanel.setBounds(new Rectangle(5, 6, 40, 40));
			}else{
				rate =height /(float)40;
				result =(int)(mainframe.currentCanvasFrame.canvasPanel.getWidth()/rate);
				naviPanel.setBounds(new Rectangle(5, 6, (int)result, 40));
			}
			
			funcPanel.setPreferredSize(new Dimension(40,40));
			
			this.add(naviPanel);
			
			pn_checkBox.add(visible);
			pn_checkBox.setBounds(new Rectangle(100, 15, 22, 20));
			this.add(pn_checkBox);
						
			func.setBounds(new Rectangle(125, 13, 25, 25));
			this.add(func);
			
			remove.setBounds(new Rectangle(150, 13, 25, 25));
			this.add(remove);
						
			visible.addActionListener(this);
			func.addActionListener(this);
			remove.addActionListener(this);
						
		}
		
		public void actionPerformed(ActionEvent e) {
			// TODO Auto-generated method stub
			
		}
	}
}
