package toolBars;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTabbedPane;
import javax.swing.JToolBar;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import Start.MainFrame;

import panels.BrushToolPanel;
import panels.CopyOfBrushToolPanel;
import panels.CopyOfKoreaBrushToolPanel;
import panels.KoreaBrushToolPanel;
import popupMenus.PopupBrushSize;



public class EditTool extends JToolBar implements MouseListener,ActionListener,ItemListener,ChangeListener {

	private static final long serialVersionUID = 1L;

	private FlowLayout flowLayout;
	private Font myFont2, myFont1;
	
	private JLabel lb_rotation;

	private ImageIcon img_leftRotation, img_rightRotation;
	private ImageIcon img_grad, img_fill, img_addLayer;
	public ImageIcon img_brush1, img_brush3, img_brush5, img_brush9, img_brush13, img_brush19;
	
	private JButton bt_leftRotation, bt_rightRotation, bt_addLayer;
	private JCheckBox check_fill, check_grad;
	
	private JPanel pn_brushTab, pn_backBrush;
	
	private JLabel lb_strokeSize, lb_opacity;
	public JLabel lb_brushSize; 
	private JLabel lb_fill, lb_grad, lb_newLayer;
	
	private JSlider sldr_opacity;
	private JFormattedTextField txtf_opacity;
	
	private ImageIcon img_Pointer;
	private ImageIcon img_selectGrad, img_selectFill;
	
	private JButton bt_selectBrush;
	
	private PopupBrushSize popupBrushSize;

	private JTabbedPane tab_brush;

	private KoreaBrushToolPanel koreaBrushToolPanel;
	private BrushToolPanel brushToolPanel;
		
	private CopyOfKoreaBrushToolPanel copyOfkoreaBrushToolPanel;
	private CopyOfBrushToolPanel copyOfbrushToolPanel;
		
	public MainFrame mainframe;

	public EditTool(MainFrame mainframe) {
		super();
		
		this.mainframe = mainframe;
		
		flowLayout = new FlowLayout(FlowLayout.LEFT, 5, 0);
				
		myFont1 = new Font("Arial", Font.PLAIN, 9);
		myFont2 = new Font("Arial", Font.PLAIN, 10);
		
		lb_rotation = new JLabel("    Rotation:");
		lb_rotation.setFont(myFont2);
		
		img_leftRotation = new ImageIcon("image/westLeftRotation.jpg");
		img_rightRotation = new ImageIcon("image/westRightRotation.jpg");
		
		img_grad = new ImageIcon("image/gradation.jpg");
		img_fill = new ImageIcon("image/fill.jpg");
		img_addLayer = new ImageIcon("image/newLayer.jpg");
		
		img_brush1 = new ImageIcon("image/brushSize1.jpg");
		img_brush3 = new ImageIcon("image/brushSize3.jpg");
		img_brush5 = new ImageIcon("image/brushSize5.jpg");
		img_brush9 = new ImageIcon("image/brushSize9.jpg");
		img_brush13 = new ImageIcon("image/brushSize13.jpg");
		img_brush19 = new ImageIcon("image/brushSize19.jpg");
		
		lb_brushSize = new JLabel(img_brush1);
		lb_brushSize.setPreferredSize(new Dimension(21, 19));
		
		bt_leftRotation = new JButton(img_leftRotation);
		bt_leftRotation.setPreferredSize(new Dimension(24, 25));
		
		bt_rightRotation = new JButton(img_rightRotation);
		bt_rightRotation.setPreferredSize(new Dimension(24, 25));
		
		img_selectGrad = new ImageIcon("image/selectGrad.jpg");
		img_selectFill = new ImageIcon("image/selectFill.jpg");
		
		check_fill = new JCheckBox(img_fill);
		check_fill.setPreferredSize(new Dimension(24, 25));
		check_fill.setSelectedIcon(img_selectFill);
		check_fill.addItemListener(this);
			
		check_grad = new JCheckBox(img_grad);
		check_grad.setPreferredSize(new Dimension(24, 25));
		check_grad.setSelectedIcon(img_selectGrad);
		check_grad.addItemListener(this);
		
		bt_addLayer = new JButton(img_addLayer);
		bt_addLayer.setPreferredSize(new Dimension(24, 25));	
		bt_addLayer.addMouseListener(this);	
		
		pn_brushTab = new JPanel();
		pn_brushTab.setPreferredSize(new Dimension(566, 20));
		
		pn_backBrush = new JPanel();
		pn_backBrush.setBackground(Color.DARK_GRAY);
			
		img_Pointer = new ImageIcon("image/ȭǥ.jpg");
		
		bt_selectBrush = new JButton(img_Pointer);
		bt_selectBrush.setPreferredSize(new Dimension(11, 25));
		bt_selectBrush.addMouseListener(this);
		bt_selectBrush.addActionListener(this);
		popupBrushSize = new PopupBrushSize(this);//
		
		lb_strokeSize = new JLabel("   Brush:");
		lb_strokeSize.setFont(myFont2);
		
		lb_fill = new JLabel("    Fill:");
		lb_fill.setFont(myFont2);
		
		lb_grad = new JLabel("    Gradation:");
		lb_grad.setFont(myFont2);
		
		lb_newLayer = new JLabel("    Create Layer:");
		lb_newLayer.setFont(myFont2);
		
		lb_opacity = new JLabel("    Opacity:");
		lb_opacity.setFont(myFont2);
		
		sldr_opacity = new JSlider(SwingConstants.HORIZONTAL, 0, 10, 10);
		sldr_opacity.setPreferredSize(new Dimension(100, 20));
		sldr_opacity.addChangeListener(this);
		
		txtf_opacity = new JFormattedTextField("1.0");
		txtf_opacity.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_opacity.setPreferredSize(new Dimension(30, 20));
			
		copyOfkoreaBrushToolPanel = new CopyOfKoreaBrushToolPanel();
		copyOfbrushToolPanel = new CopyOfBrushToolPanel();
		
		tab_brush = new JTabbedPane();
		tab_brush.setFont(myFont1);		  
		tab_brush.addMouseListener(this);
		tab_brush.setFocusable(true);
		
		this.sub();
	}
	
	public void sub() {
		this.setLayout(flowLayout);
		pn_brushTab.setLayout(null);
		
		this.add(lb_strokeSize);
		this.add(lb_brushSize);
		this.add(bt_selectBrush);
		
		this.add(lb_rotation);
		this.add(bt_leftRotation);
		this.add(bt_rightRotation);	
		
		this.add(lb_fill);
		this.add(check_fill);
		
		this.add(lb_grad);
		this.add(check_grad);
		
		this.add(lb_newLayer);
		this.add(bt_addLayer);
		
		this.add(lb_opacity);
		this.add(sldr_opacity);
		this.add(txtf_opacity);
					
		tab_brush.addTab("K-Brush", copyOfkoreaBrushToolPanel);
		tab_brush.addTab("Brush", copyOfbrushToolPanel);
		
		pn_backBrush.add(tab_brush);
		pn_backBrush.setBounds(new Rectangle(201, 0, 365, 20));
		pn_brushTab.add(pn_backBrush);
		this.add(pn_brushTab);
		
	}

	public void mouseClicked(MouseEvent e) {
		Object o = e.getSource();
		
		
		if(o == bt_addLayer){
			mainframe.currentCanvasFrame.canvasPanel.addLayer();
		}		
		else if(o == this.tab_brush){}
		
	}

	public void mouseEntered(MouseEvent arg0) {
		
	}

	public void mouseExited(MouseEvent arg0) {
		
	}

	public void mousePressed(MouseEvent e) {
		checkTriggerEvent(e);
	}

	public void mouseReleased(MouseEvent e) {
		checkTriggerEvent(e);
	}
	
	private void checkTriggerEvent(MouseEvent e) {
		if(e.getSource().equals(bt_selectBrush)) {
			if(e.isPopupTrigger()) {
				//popupBrushSize.show(e.getComponent(), 0, 20);
				
			}
		}
	}

	public BrushToolPanel getBrushToolPanel() {return brushToolPanel;}
	public void setBrushToolPanel(BrushToolPanel brushToolPanel) {this.brushToolPanel = brushToolPanel;}

	public KoreaBrushToolPanel getKoreaBrushToolPanel() {return koreaBrushToolPanel;}
	public void setKoreaBrushToolPanel(KoreaBrushToolPanel koreaBrushToolPanel) {this.koreaBrushToolPanel = koreaBrushToolPanel;}

	public void actionPerformed(ActionEvent e) {
		Object o = e.getSource();
		if(o == bt_selectBrush){
			popupBrushSize.show(this, 95, 22);
		}
		
		
	}

	public void itemStateChanged(ItemEvent e) {
		Object o = e.getSource();
		int type = e.getStateChange();
		if( o == check_fill){
			if(type == ItemEvent.SELECTED){
				this.mainframe.currentCanvasFrame.canvasPanel.getInformation().isFilled = true;
			
			}else{
				this.mainframe.currentCanvasFrame.canvasPanel.getInformation().isFilled = false;
			}
		}
		
		if( o == check_grad){
			if(type == ItemEvent.SELECTED){
				this.mainframe.currentCanvasFrame.canvasPanel.getInformation().setGradation(true);
			
			}else{
				this.mainframe.currentCanvasFrame.canvasPanel.getInformation().setGradation(false);
			}
		}
		
	}

	public void stateChanged(ChangeEvent e) {
		Object o = e.getSource();
		if(o == sldr_opacity){
			int value = sldr_opacity.getValue();
			float result = (float)value/(float)10;
			this.txtf_opacity.setText(""+ result);
			this.mainframe.currentCanvasFrame.canvasPanel.getInformation().opacity = result;
		}
		
	}

	
}
