package toolBars;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileOutputStream;
import java.net.MalformedURLException;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JSeparator;
import javax.swing.JToolBar;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageEncoder;


import Start.MainFrame;


public class NorthTool extends JToolBar implements ActionListener{

	private static final long serialVersionUID = 1L;
	private Toolkit myToolkit;
	private FlowLayout flowLayout;
			
	private ImageIcon img_newFile, img_open, img_save;
	private ImageIcon img_print, img_preview;
	private ImageIcon img_undo, img_redo;
	private ImageIcon img_newLayer, img_merge;
	
	private JButton bt_newFile, bt_open, bt_save;
	private JButton bt_preview, bt_print;
	private JButton bt_undo, bt_redo;
	private JButton bt_newLayer, bt_merge;

	MainFrame mainframe;

	private JFileChooser fileChooser;
	
	public NorthTool(MainFrame mainframe) {
		super();
		this.mainframe = mainframe;
		flowLayout = new FlowLayout(FlowLayout.LEFT, 10, 0);
		
		img_newFile = new ImageIcon("image/newFile.jpg");
		img_open = new ImageIcon("image/open.jpg");
		img_save = new ImageIcon("image/save.jpg");
		img_print = new ImageIcon("image/print.jpg");
		img_preview = new ImageIcon("image/preview.jpg");
		img_undo = new ImageIcon("image/undo.jpg");
		img_redo = new ImageIcon("image/redo.jpg");
		img_newLayer = new ImageIcon("image/newLayer.jpg");
		img_merge = new ImageIcon("image/merge.jpg");
		
		bt_newFile = new JButton(img_newFile);
		bt_newFile.setPreferredSize(new Dimension(23, 25));
		
		bt_open = new JButton(img_open);
		bt_open.setPreferredSize(new Dimension(23, 25));
		
		bt_save = new JButton(img_save);
		bt_save.setPreferredSize(new Dimension(23, 25));
		
		bt_preview = new JButton(img_preview);
		bt_preview.setPreferredSize(new Dimension(23, 25));
		
		bt_print = new JButton(img_print);
		bt_print.setPreferredSize(new Dimension(23, 25));
		
		bt_undo = new JButton(img_undo);
		bt_undo.setPreferredSize(new Dimension(23, 25));
		
		bt_redo = new JButton(img_redo);
		bt_redo.setPreferredSize(new Dimension(23, 25));
		
		bt_newLayer = new JButton(img_newLayer);
		bt_newLayer.setToolTipText("̾ ߰");
		bt_newLayer.setPreferredSize(new Dimension(23, 25));
				
		bt_merge = new JButton(img_merge);
		bt_merge.setToolTipText("̾ պ");
		bt_merge.setPreferredSize(new Dimension(23, 25));
						
		myToolkit = Toolkit.getDefaultToolkit();
		fileChooser = new JFileChooser(new File("./GraphicIsland") );
		
	    fileChooser.setFileSelectionMode(
	         JFileChooser.FILES_AND_DIRECTORIES );
					
		this.sub();
	}
	
	public void saveJpgNow( BufferedImage bImage )
		throws Exception
		{ 
		JFileChooser fc = new JFileChooser(new File("./GraphicIsland"));
		int returnVal = fc.showSaveDialog(this);

		if(returnVal == JFileChooser.APPROVE_OPTION){
			File file = fc.getSelectedFile();
			String fileName = file.getName();
			fileName = fileName +".jpg";
			File file2 = new File(file.getParent(),fileName);
			FileOutputStream fos = new FileOutputStream(file2);
			JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder( fos );
			encoder.encode( bImage );
			fos.flush();
			fos.close();
		 }
	}
	
	public void sub() {
		this.setLayout(flowLayout);
		
		this.add(bt_newFile);
		this.add(bt_open);
		this.add(bt_save);
		this.add(new JSeparator());
		this.add(bt_preview);
		this.add(bt_print);
		this.add(new JSeparator());
		this.add(bt_undo);
		this.add(bt_redo);
		this.add(new JSeparator());
		this.add(bt_newLayer);
		this.add(bt_merge);
		bt_undo.addActionListener(this);
		bt_redo.addActionListener(this);
		bt_save.addActionListener(this);
		bt_open.addActionListener(this);
		bt_newFile.addActionListener(this);
		
		bt_newLayer.addActionListener(this);
		bt_merge.addActionListener(this);
		
	}

	@SuppressWarnings("deprecation")
	public void actionPerformed(ActionEvent e) {
		Object o = e.getSource();
		if(o == this.bt_undo){
			this.mainframe.currentCanvasFrame.canvasPanel.removeElement();
		}else if( o == this.bt_redo){
			this.mainframe.currentCanvasFrame.canvasPanel.redoElement();
		}else if( o == this.bt_save){
			BufferedImage buf = new BufferedImage(mainframe.currentCanvasFrame.canvasPanel.gBackImg.getWidth(null),
					mainframe.currentCanvasFrame.canvasPanel.gBackImg.getHeight(null),BufferedImage.TYPE_INT_RGB);
			Graphics2D G = buf.createGraphics();
			G.drawImage(mainframe.currentCanvasFrame.canvasPanel.gBackImg, 0, 0, null);
			try {
				this.saveJpgNow(buf);
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}else if( o == this.bt_open){
			Image temporeryImage = null;
			
			fileChooser.showOpenDialog(null);
			File file = fileChooser.getSelectedFile();
			
			if(file == null){}
			else{
			try {
				temporeryImage = myToolkit.getImage(file.toURL());
			} catch (MalformedURLException e1) {
				e1.printStackTrace();
			}
			MediaTracker mt = new MediaTracker(mainframe);
			mt.addImage(temporeryImage, 0);
			try {
				mt.waitForID(0);
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			
			this.mainframe.addCanvasFrame(temporeryImage);
			}
		}else if( o == this.bt_newFile){
			this.mainframe.addCanvasFrame();
		}else if( o == this.bt_newLayer){
			this.mainframe.currentCanvasFrame.canvasPanel.addLayer();
		}else if( o == this.bt_merge){
			this.mainframe.currentCanvasFrame.canvasPanel.currentLayer.merge();
		}
		
	}

}
