package toolBars;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTabbedPane;
import javax.swing.JToolBar;
import javax.swing.SwingConstants;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import Start.MainFrame;
import Tools.ToolStateSubSharpen;
import panels.BrushToolPanel;
import panels.CopyOfBrushToolPanel;
import panels.CopyOfKoreaBrushToolPanel;
import panels.KoreaBrushToolPanel;
import utils.DrawStateSingleton;



public class SharpenTool extends JToolBar implements MouseListener, ChangeListener, CaretListener {

	private static final long serialVersionUID = 1L;

	private FlowLayout flowLayout;
	private Font myFont2, myFont1;
	
	private JLabel lb_toolName, lb_unit;
	private JSlider sldr_ovalSize;
	private JFormattedTextField txtf_ovalSize;
	
	private JPanel pn_brushTab, pn_backBrush;
	
	private JTabbedPane tab_brush;

	private KoreaBrushToolPanel koreaBrushToolPanel;
	private BrushToolPanel brushToolPanel;
		
	private CopyOfKoreaBrushToolPanel copyOfkoreaBrushToolPanel;
	private CopyOfBrushToolPanel copyOfbrushToolPanel;
		
	MainFrame mainframe;

	public SharpenTool(MainFrame mainframe) {
		super();
		
		this.mainframe = mainframe;
		
		flowLayout = new FlowLayout(FlowLayout.LEFT, 5, 0);
				
		myFont1 = new Font("Arial", Font.PLAIN, 9);
		myFont2 = new Font("Arial", Font.PLAIN, 10);
		
		lb_toolName = new JLabel(" SharpenTool:");
		lb_toolName.setPreferredSize(new Dimension(70, 20));
		lb_toolName.setFont(myFont2);
		
		sldr_ovalSize = new JSlider(SwingConstants.HORIZONTAL, 1, 100, 40);
		sldr_ovalSize.setPreferredSize(new Dimension(100, 20));
		sldr_ovalSize.addChangeListener(this);
		
		txtf_ovalSize = new JFormattedTextField("40");
		txtf_ovalSize.setHorizontalAlignment(SwingConstants.RIGHT);
		txtf_ovalSize.setPreferredSize(new Dimension(40, 20));
		txtf_ovalSize.addCaretListener(this);
		
		lb_unit = new JLabel("px");
		lb_unit.setPreferredSize(new Dimension(20, 20));
		lb_unit.setFont(myFont2);
				
		pn_brushTab = new JPanel();
		pn_brushTab.setPreferredSize(new Dimension(985, 20));
		
		pn_backBrush = new JPanel();
		pn_backBrush.setBackground(Color.DARK_GRAY);
						
		copyOfkoreaBrushToolPanel = new CopyOfKoreaBrushToolPanel();
		copyOfbrushToolPanel = new CopyOfBrushToolPanel();
		
		tab_brush = new JTabbedPane();
		tab_brush.setFont(myFont1);		  
		tab_brush.addMouseListener(this);
		tab_brush.setFocusable(true);
		
		this.sub();
	}
	
	public void sub() {
		this.setLayout(flowLayout);
		pn_brushTab.setLayout(null);
		
		this.add(lb_toolName);
		this.add(sldr_ovalSize);
		this.add(txtf_ovalSize);
		this.add(lb_unit);
		
		tab_brush.addTab("K-Brush", copyOfkoreaBrushToolPanel);
		tab_brush.addTab("Brush", copyOfbrushToolPanel);
		
		pn_backBrush.add(tab_brush);
		
		pn_backBrush.setBounds(new Rectangle(620, 0, 365, 20));
		pn_brushTab.add(pn_backBrush);
		this.add(pn_brushTab);
		
	}

	public void mouseClicked(MouseEvent e) {
		Object o = e.getSource();
		
		if(o == this.tab_brush){}
		
	}

	public void mouseEntered(MouseEvent arg0) {
		
	}

	public void mouseExited(MouseEvent arg0) {
		
	}

	public void mousePressed(MouseEvent e) {
		
	}

	public void mouseReleased(MouseEvent e) {
		
	}
	
	public void stateChanged(ChangeEvent e) {
		Object o = e.getSource();
		
		if(o == sldr_ovalSize){
			txtf_ovalSize.setText("" + sldr_ovalSize.getValue());
			int value = sldr_ovalSize.getValue();
			if(DrawStateSingleton.getInstance().getToolState() instanceof ToolStateSubSharpen){
				((ToolStateSubSharpen)DrawStateSingleton.getInstance().getToolState()).setEllipseSize(value);
				this.mainframe.currentCanvasFrame.canvasPanel.repaint();
			}
		}
	
	}

	public void caretUpdate(CaretEvent e) {
		if(e.getSource().equals(txtf_ovalSize)) {
			try{
				int temp = Integer.parseInt(txtf_ovalSize.getText());
				sldr_ovalSize.setValue(temp);
				
			}catch(Exception err) {}
			
		}
		
	}
	
	public BrushToolPanel getBrushToolPanel() {return brushToolPanel;}
	public void setBrushToolPanel(BrushToolPanel brushToolPanel) {this.brushToolPanel = brushToolPanel;}

	public KoreaBrushToolPanel getKoreaBrushToolPanel() {return koreaBrushToolPanel;}
	public void setKoreaBrushToolPanel(KoreaBrushToolPanel koreaBrushToolPanel) {this.koreaBrushToolPanel = koreaBrushToolPanel;}
	
}
