package toolBars;

import java.awt.Button;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.io.File;
import java.net.MalformedURLException;


import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JToolBar;

import Start.MainFrame;
import ToolSelect.ToolStatePen;
import ToolSelect.ToolStatePencilSelect;
import ToolSelect.ToolStateSelectRect;
import Tools.ToolStateBrush_k1;
import Tools.ToolStateEnlarge;
import Tools.ToolStateEraser;
import Tools.ToolStateFont;
import Tools.ToolStateImage;
import Tools.ToolStateLine;
import Tools.ToolStateMove;
import Tools.ToolStateOval;
import Tools.ToolStatePencil;
import Tools.ToolStatePolygon;
import Tools.ToolStatePucker;
import Tools.ToolStateRect;
import Tools.ToolStateResize;
import Tools.ToolStateSpuit;
import Tools.ToolStateStamp;
import Tools.ToolStateStampSpoide;
import Tools.ToolStateSubBlur;
import Tools.ToolStateSubSharpen;

import utils.DrawStateSingleton;




public class WestTool extends JToolBar implements ActionListener{

	private static final long serialVersionUID = 1L;
	
	private JPanel pn_westTool;
	private JLabel lb_lineColor, lb_fillColor;
	private JSeparator separator1, separator2, separator3, separator4, separator5, separator6;
	private JFileChooser fileChooser;
	private Toolkit myToolkit;
	private JColorChooser colorChooser = new JColorChooser();
	private MainFrame mainframe;
	
	private ImageIcon img_nodraw, img_selectrect, img_pentool, img_slice;
	private ImageIcon img_line, img_rect, img_oval, img_polygon;
	private ImageIcon img_brush, img_pen, img_font, img_img;
	private ImageIcon img_move, img_resize, img_copy, img_paste, img_cut, img_eraser;
	private ImageIcon img_pucker, img_bloat, img_healingColor, img_healing;
	private ImageIcon img_blur, img_sharpen;
	private ImageIcon img_spuit;
	
	private JButton bt_nodraw, bt_selectrect, bt_pentool, bt_slice;
	private JButton bt_line, bt_rect, bt_oval, bt_polygon;
	private JButton bt_brush, bt_pen, bt_font, bt_img;
	private JButton bt_move, bt_resize, bt_copy, bt_paste, bt_cut, bt_eraser;
	private JButton bt_bloat, bt_pucker;
	private JButton bt_dropper, bt_healing;
	private JButton bt_subBlur, bt_subSharpen;
	private JButton bt_spuit;
	public Button bt_color;
	private Button bt_background;
	
	private JLabel lb_selectTool, lb_shapeTool, lb_imageEdit;
	
	private Font myFont;
		
	public WestTool(MainFrame mainframe) {
		super();
		this.mainframe = mainframe;
		
		pn_westTool = new JPanel();
		myFont = new Font("Arial", Font.PLAIN, 10);
		
		separator1 = new JSeparator();
		separator2 = new JSeparator();
		separator3 = new JSeparator();
		separator4 = new JSeparator();
		separator5 = new JSeparator();
		separator6 = new JSeparator();
		
		lb_lineColor = new JLabel("Line Color");
		lb_lineColor.setFont(myFont);
		
		lb_fillColor = new JLabel("Fill Color");
		lb_fillColor.setFont(myFont);
		
		lb_selectTool = new JLabel("Select Tool");
		lb_selectTool.setFont(myFont);
		
		lb_shapeTool = new JLabel("Shape Tool");
		lb_shapeTool.setFont(myFont);
		
		lb_imageEdit = new JLabel("Edit Image");
		lb_imageEdit.setFont(myFont);
		
		bt_color = new Button();
		
		img_nodraw = new ImageIcon("image/nodraw.jpg");
		img_selectrect = new ImageIcon("image/selectrect.jpg");
		img_pentool = new ImageIcon("image/pen.jpg");
		img_slice = new ImageIcon("image/slice.jpg");
		
		img_line = new ImageIcon("image/line.jpg");
		img_rect = new ImageIcon("image/rect.jpg");
		img_oval = new ImageIcon("image/circle.jpg");
		img_polygon = new ImageIcon("image/polygon.jpg");
		
		img_brush = new ImageIcon("image/brush.jpg");
		img_pen = new ImageIcon("image/pencil.jpg"); 
		img_font = new ImageIcon("image/text.jpg"); 
		img_img = new ImageIcon("image/image.jpg");
		
		img_move = new ImageIcon("image/move.jpg");
		img_resize = new ImageIcon("image/resize.jpg");
		img_copy = new ImageIcon("image/copy.jpg");
		img_paste = new ImageIcon("image/paste.jpg");
		img_cut = new ImageIcon("image/cut.jpg");
		img_eraser = new ImageIcon("image/eraser.jpg");
		
		img_pucker = new ImageIcon("image/pucker.jpg");
		img_bloat = new ImageIcon("image/bloat.jpg");
		img_healingColor = new ImageIcon("image/healingColor.jpg");
		img_healing = new ImageIcon("image/healing.jpg");
		
		img_blur = new ImageIcon("image/blur.jpg");
		img_sharpen = new ImageIcon("image/sharpen.jpg");
		
		img_spuit = new ImageIcon("image/spuit.jpg");
		
		bt_nodraw = new JButton(img_nodraw);
		bt_selectrect = new JButton(img_selectrect);
		bt_pentool = new JButton(img_pentool);
		bt_slice = new JButton(img_slice);
		
		bt_line = new JButton(img_line);
		bt_rect = new JButton(img_rect);
		bt_oval = new JButton(img_oval);
		bt_polygon = new JButton(img_polygon);
		
		bt_brush = new JButton(img_brush);
		bt_pen = new JButton(img_pen);
		bt_font = new JButton(img_font);
		bt_img = new JButton(img_img);
		
		bt_move = new JButton(img_move);
		bt_resize = new JButton(img_resize);
		bt_copy = new JButton(img_copy);
		bt_paste = new JButton(img_paste);
		bt_cut = new JButton(img_cut);
		bt_eraser = new JButton(img_eraser);
	
		bt_bloat = new JButton(img_bloat);
		bt_bloat.setToolTipText("â");
		
		bt_pucker = new JButton(img_pucker);
		bt_pucker.setToolTipText("Ը");
		
		bt_dropper = new JButton(img_healingColor);
		bt_dropper.setToolTipText(" ̵");
		
		bt_healing = new JButton(img_healing);
		bt_healing.setToolTipText("");
		
		bt_subBlur = new JButton(img_blur);
		bt_subBlur.setToolTipText("帮");
		
		bt_subSharpen = new JButton(img_sharpen);
		bt_subSharpen.setToolTipText("ϰ");
		
		bt_spuit = new JButton(img_spuit);
				
		bt_background = new Button();
		bt_background.setBackground(Color.yellow);				
		bt_color.setBackground(Color.black);
		
		this.sub();
	}
	
	public void sub() {
		this.setLayout(new FlowLayout());
		this.setBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY));
		
		myToolkit = Toolkit.getDefaultToolkit();
		fileChooser = new JFileChooser(new File("./GraphicIsland"));
	    fileChooser.setFileSelectionMode(
	         JFileChooser.FILES_AND_DIRECTORIES );
	     
		pn_westTool.setLayout(null);
		pn_westTool.setPreferredSize(new Dimension(56, 600));
	
		lb_lineColor.setBounds(new Rectangle(3, 15, 60, 20));
		pn_westTool.add(lb_lineColor);
				
		bt_color.setBounds(new Rectangle(5, 35, 45, 40));
		pn_westTool.add(bt_color);
		bt_color.addActionListener(this);
		
		separator1.setBounds(new Rectangle(0, 80, 56, 1));
		pn_westTool.add(separator1);
		
		lb_selectTool.setBounds(new Rectangle(0, 80, 60, 20));
		pn_westTool.add(lb_selectTool);
		
		bt_nodraw.setBounds(new Rectangle(0, 100, 25, 25));
		pn_westTool.add(bt_nodraw);
		bt_nodraw.addActionListener(this);
		
		bt_selectrect.setBounds(new Rectangle(30, 100, 25, 25));
		pn_westTool.add(bt_selectrect);
		bt_selectrect.addActionListener(this);
		
		bt_pentool.setBounds(new Rectangle(0, 130, 25, 25));
		pn_westTool.add(bt_pentool);
		bt_pentool.addActionListener(this);
		
		bt_slice.setBounds(new Rectangle(30, 130, 25, 25));
		pn_westTool.add(bt_slice);
		bt_slice.addActionListener(this);
		
		separator2.setBounds(new Rectangle(0, 160, 56, 1));
		pn_westTool.add(separator2);
		
		lb_shapeTool.setBounds(new Rectangle(0, 160, 60, 20));
		pn_westTool.add(lb_shapeTool);
		
		bt_line.setBounds(new Rectangle(0, 180, 25, 25));
		pn_westTool.add(bt_line);
		bt_line.addActionListener(this);
		
		bt_rect.setBounds(new Rectangle(30, 180, 25, 25));
		pn_westTool.add(bt_rect);
		bt_rect.addActionListener(this);
		
		bt_oval.setBounds(new Rectangle(0, 210, 25, 25));
		pn_westTool.add(bt_oval);
		bt_oval.addActionListener(this);
		
		bt_polygon.setBounds(new Rectangle(30, 210, 25, 25));
		pn_westTool.add(bt_polygon);
		bt_polygon.addActionListener(this);
		
		separator3.setBounds(new Rectangle(0, 240, 56, 1));
		pn_westTool.add(separator3);
		
		bt_brush.setBounds(new Rectangle(0, 245, 25, 25));
		pn_westTool.add(bt_brush);
		bt_brush.addActionListener(this);
		
		bt_pen.setBounds(new Rectangle(30, 245, 25, 25));
		pn_westTool.add(bt_pen);
		bt_pen.addActionListener(this);
		
		bt_font.setBounds(new Rectangle(0, 275, 25, 25));
		pn_westTool.add(bt_font);
		bt_font.addActionListener(this);
		
		bt_img.setBounds(new Rectangle(30, 275, 25, 25));
		pn_westTool.add(bt_img);
		bt_img.addActionListener(this);

		separator5.setBounds(new Rectangle(0, 305, 56, 1));
		pn_westTool.add(separator5);
		
		bt_move.setBounds(new Rectangle(0, 310, 25, 25));
		pn_westTool.add(bt_move);
		bt_move.addActionListener(this);
		
		bt_resize.setBounds(new Rectangle(30, 310, 25, 25));
		pn_westTool.add(bt_resize);
		bt_resize.addActionListener(this);
		
		bt_copy.setBounds(new Rectangle(0, 340, 25, 25));
		pn_westTool.add(bt_copy);
		bt_copy.addActionListener(this);
		
		bt_paste.setBounds(new Rectangle(30, 340, 25, 25));
		pn_westTool.add(bt_paste);
		bt_paste.addActionListener(this);
		
		bt_cut.setBounds(new Rectangle(0, 370, 25, 25));
		pn_westTool.add(bt_cut);
		bt_cut.addActionListener(this);
		
		bt_eraser.setBounds(new Rectangle(30, 370, 25, 25));
		pn_westTool.add(bt_eraser);
		bt_eraser.addActionListener(this);
		
		separator6.setBounds(new Rectangle(0, 400, 56, 1));
		pn_westTool.add(separator6);
		
		lb_imageEdit.setBounds(new Rectangle(2, 400, 60, 20));
		pn_westTool.add(lb_imageEdit);
		
		bt_bloat.setBounds(new Rectangle(0, 420, 25, 25));
		pn_westTool.add(bt_bloat);
		bt_bloat.addActionListener(this);
				
		bt_pucker.setBounds(new Rectangle(30, 420, 25, 25));
		pn_westTool.add(bt_pucker);
		bt_pucker.addActionListener(this);
		
		bt_dropper.setBounds(new Rectangle(0, 450, 25, 25));
		pn_westTool.add(bt_dropper);
		bt_dropper.addActionListener(this);
		
		bt_healing.setBounds(new Rectangle(30, 450, 25, 25));
		pn_westTool.add(bt_healing);
		bt_healing.addActionListener(this);
		
		bt_subBlur.setBounds(new Rectangle(0, 480, 25, 25));
		pn_westTool.add(bt_subBlur);
		bt_subBlur.addActionListener(this);
		
		bt_subSharpen.setBounds(new Rectangle(30, 480, 25, 25));
		pn_westTool.add(bt_subSharpen);
		bt_subSharpen.addActionListener(this);
		
		bt_spuit.setBounds(new Rectangle(0, 510, 25, 25));
		pn_westTool.add(bt_spuit);
		bt_spuit.addActionListener(this);
		
		separator4.setBounds(new Rectangle(0, 540, 56, 1));
		pn_westTool.add(separator4);
		
		lb_fillColor.setBounds(new Rectangle(5, 540, 60, 20));
		pn_westTool.add(lb_fillColor);
		
		bt_background.setBounds(new Rectangle(5, 560, 45, 40));
		pn_westTool.add(bt_background);
		bt_background.addActionListener(this);
		
		this.add(pn_westTool);
	}

	@SuppressWarnings({ "deprecation", "static-access" })
	public void actionPerformed(ActionEvent e) {
		Object o = e.getSource();
		
		if(o == bt_nodraw){
			
			MouseListener[] m = mainframe.currentCanvasFrame.canvasPanel.getMouseListeners();
			if(m.length != 0){
			this.mainframe.currentCanvasFrame.canvasPanel.removeMouseListener(m[0]);
			MouseMotionListener[] mm = mainframe.currentCanvasFrame.canvasPanel.getMouseMotionListeners();
			this.mainframe.currentCanvasFrame.canvasPanel.removeMouseMotionListener(mm[0]);}
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_selectrect){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateSelectRect(this.mainframe.currentCanvasFrame.canvasPanel));
			this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_pentool){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStatePencilSelect(this.mainframe.currentCanvasFrame.canvasPanel));
			this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_slice){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStatePen(this.mainframe.currentCanvasFrame.canvasPanel));
			this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_line){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateLine(this.mainframe.currentCanvasFrame.canvasPanel));
			this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_rect){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateRect(this.mainframe.currentCanvasFrame.canvasPanel));
			this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");

		}
		else if(o == bt_oval){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateOval(this.mainframe.currentCanvasFrame.canvasPanel));
			this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");

		}
		else if(o == bt_polygon){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStatePolygon(mainframe.currentCanvasFrame.canvasPanel));
			this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(null);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_brush){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateBrush_k1(mainframe.currentCanvasFrame.canvasPanel));
				this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
				this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
				this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_pen){
			DrawStateSingleton.getInstance().setToolState(
				new ToolStatePencil(mainframe.currentCanvasFrame.canvasPanel));
			this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_font){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateFont(mainframe.currentCanvasFrame.canvasPanel));
				this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
				this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(null);
				this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_img){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateImage(mainframe.currentCanvasFrame.canvasPanel));
			mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			Image temporeryImage = null;
			fileChooser.showOpenDialog(null);
			File file = fileChooser.getSelectedFile();
			
			if(file == null){}
			else{
			try {
				
				temporeryImage = myToolkit.getImage(file.toURL());
			} catch (MalformedURLException e1) {
				e1.printStackTrace();
			}
			MediaTracker mt = new MediaTracker(mainframe);
			mt.addImage(temporeryImage, 0);
			try {
				mt.waitForID(0);
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			mainframe.setImageToCanvasFrame(temporeryImage);
			this.mainframe.swapToolBar("edit");
			}
		}
		else if(o == bt_move){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateMove(mainframe.currentCanvasFrame.canvasPanel));
			this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_resize){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateResize(mainframe.currentCanvasFrame.canvasPanel));
			this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_copy){
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_paste){
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_cut){
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
			this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_eraser){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateEraser(mainframe.currentCanvasFrame.canvasPanel));
				this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
				this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
				this.mainframe.swapToolBar("edit");
		}
		else if(o == bt_color){
			Color color = colorChooser.showDialog(this, "Choice the Fill Color  ", Color.black);
			mainframe.currentCanvasFrame.canvasPanel.setLineColor(color);
			bt_color.setBackground(color);
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
		}
		else if(o == bt_background){
			Color color = colorChooser.showDialog(this, "Choice the Fill Color  ", Color.black);
			mainframe.currentCanvasFrame.canvasPanel.setFillColor(color);
			bt_background.setBackground(color);
			this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
		}
		else if(o == bt_bloat){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateEnlarge(mainframe.currentCanvasFrame.canvasPanel));
				this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
				this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
				this.mainframe.swapToolBar("bloat");
		}
		else if(o == bt_dropper){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateStampSpoide(mainframe.currentCanvasFrame.canvasPanel));
				this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
				this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
				this.mainframe.swapToolBar("stamp");
		}
		else if(o == bt_healing){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateStamp(mainframe.currentCanvasFrame.canvasPanel));
				this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
				this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
				this.mainframe.swapToolBar("stamp");
		}
		else if(o == bt_subBlur){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateSubBlur(mainframe.currentCanvasFrame.canvasPanel));
				this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
				this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
				this.mainframe.swapToolBar("blur");
		}
		else if(o == bt_subSharpen){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateSubSharpen(mainframe.currentCanvasFrame.canvasPanel));
				this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
				this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
				this.mainframe.swapToolBar("sharpen");
		}
		else if(o == bt_pucker){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStatePucker(mainframe.currentCanvasFrame.canvasPanel));
				this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
				this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
				this.mainframe.swapToolBar("pucker");
		}else if(o == this.bt_spuit){
			DrawStateSingleton.getInstance().setToolState(
					new ToolStateSpuit(mainframe.currentCanvasFrame.canvasPanel));
				this.mainframe.currentCanvasFrame.canvasPanel.updateDrawState();
				this.mainframe.currentCanvasFrame.canvasPanel.setComponentPopupMenu(mainframe.currentCanvasFrame.canvasPanel.popup);
		}
		
		
	}

}