package utils;
import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Shape;
import java.awt.event.ActionListener;
import java.awt.geom.AffineTransform;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;




public class StaticMethods {
	//ư  ϰ Ѵ.
	public static JButton makeNavigationButton(String imageName,
            String actionCommand,
            String toolTipText,
            String altText,
            ActionListener listener) {
		//ButtonHandler handler = new ButtonHandler();	
	//Create and initialize the button.
		JButton button = new JButton();
		button.setActionCommand(actionCommand);
		button.setToolTipText(toolTipText);
		button.addActionListener(listener);
		
		String imgLocation = "/Icon/"
            + imageName
            + ".jpg";
		URL imageURL;
		
		imageURL = System.class.getResource(imgLocation);
		if (imageURL != null) {                      //image found
			button.setIcon(new ImageIcon(imageURL, altText));
		} else {                                     //no image found
			button.setText(altText);
			//System.err.println("Resource not found: "
			//		+ imgLocation);
		}
		return button;
	}
	
	public static Shape getMoveStartPointShape(Shape shape){
		Shape ret = null;
		
		int xGap = shape.getBounds().x;
        int yGap = shape.getBounds().y;
		float f[] = {1,0,0,1,-xGap,-yGap};
		AffineTransform affine = new AffineTransform (f); 
		ret = affine.createTransformedShape(shape);
		
		return ret;
	}
	public static Shape shapeMove(Shape shape,int xGap,int yGap){
		float f[] = {1,0,0,1,xGap,yGap};
		AffineTransform affine = new AffineTransform (f); 
		shape = affine.createTransformedShape(shape);
		return shape;
	}
	
	
	public static void gridBagAddComponent(
			Container ct, 
			Component cm,
			GridBagConstraints constraint, 
			int row, 
			int column,
			int width,
			int height){
		if(ct.getLayout() instanceof GridBagLayout){
			constraint.gridx = column;
			constraint.gridy = row;
			constraint.gridwidth = width;
			constraint.gridheight = height;
			((GridBagLayout)ct.getLayout()).setConstraints(cm, constraint);
			
			ct.add(cm);
		}else{
			return;
		}
	}
	public static void main(String[] args){
		JFrame frame = new JFrame();
		frame.add(new JPanel());
		frame.setVisible(true);
		frame.setSize(300,200);
		//frame.addKeyListener(new MainKeyListener());
	}
}
